// This program was compiled from OCaml by js_of_ocaml 1.3
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_raise_constant (tag) { throw [0, tag]; }
var caml_global_data = [0];
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_div(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return (x/y)|0;
}
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_lessequal (x, y) { return +(caml_compare(x,y,false) <= 0); }
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_out_channels_list () { return 0; }
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
var caml_initial_time = new Date() * 0.001;
function caml_sys_time () { return new Date() * 0.001 - caml_initial_time; }
(function(){function b6(eK,eL,eM){return eK.length==2?eK(eL,eM):caml_call_gen(eK,[eL,eM]);}function aD(eI,eJ){return eI.length==1?eI(eJ):caml_call_gen(eI,[eJ]);}var a=[0,new MlString("Invalid_argument")],b=new MlString("input"),c=[0,10,10,15];caml_register_global(6,[0,new MlString("Not_found")]);caml_register_global(5,[0,new MlString("Division_by_zero")]);caml_register_global(3,a);caml_register_global(2,[0,new MlString("Failure")]);var W=[0,new MlString("Assert_failure")],V=new MlString("%d"),U=new MlString("Pervasives.do_at_exit"),T=new MlString("Random.int"),S=new MlString("x"),R=[0,987910699,495797812,364182224,414272206,318284740,990407751,383018966,270373319,840823159,24560019,536292337,512266505,189156120,730249596,143776328,51606627,140166561,366354223,1003410265,700563762,981890670,913149062,526082594,1021425055,784300257,667753350,630144451,949649812,48546892,415514493,258888527,511570777,89983870,283659902,308386020,242688715,482270760,865188196,1027664170,207196989,193777847,619708188,671350186,149669678,257044018,87658204,558145612,183450813,28133145,901332182,710253903,510646120,652377910,409934019,801085050],Q=new MlString("\""),P=new MlString(" name=\""),O=new MlString("\""),N=new MlString(" type=\""),M=new MlString("<"),L=new MlString(">"),K=new MlString(""),J=new MlString("<input name=\"x\">"),I=new MlString("input"),H=new MlString("x"),G=new MlString("img"),F=new MlString("br"),E=new MlString("div"),D=new MlString("YOU LOSE"),C=new MlString("sprites/bomb.png"),B=new MlString("sprites/flag.png"),A=new MlString("Mode : "),z=new MlString("sprites/bomb.png"),y=new MlString("sprites/normal.png"),x=new MlString("0"),w=new MlString("YOU WIN"),v=new MlString("GAME OVER"),u=new MlString("sprites/flag.png"),t=new MlString("sprites/bomb.png"),s=new MlString("sprites/empty.png"),r=new MlString(".png"),q=new MlString("sprites/"),p=new MlString("sprites/normal.png"),o=[0,0,0],n=[0,new MlString("main.ml"),42,17],m=new MlString("main"),l=new MlString("Number of columns"),k=new MlString("Number of rows"),j=new MlString("Number of mines"),i=new MlString("nouvelle partie"),h=new MlString("submit"),g=new MlString("text");function f(e,d){return caml_greaterequal(e,d)?e:d;}function aj(X,Z){var Y=X.getLen(),_=Z.getLen(),$=caml_create_string(Y+_|0);caml_blit_string(X,0,$,0,Y);caml_blit_string(Z,0,$,Y,_);return $;}function ak(aa){return caml_format_int(V,aa);}function ac(ab,ad){if(ab){var ae=ab[1];return [0,ae,ac(ab[2],ad)];}return ad;}function al(ai){var af=caml_ml_out_channels_list(0);for(;;){if(af){var ag=af[2];try {}catch(ah){}var af=ag;continue;}return 0;}}caml_register_named_value(U,al);function au(am,as,ar){var an=caml_make_vect(am,[0]),ao=0,ap=am-1|0;if(!(ap<ao)){var aq=ao;for(;;){an[aq+1]=caml_make_vect(as,ar);var at=aq+1|0;if(ap!==aq){var aq=at;continue;}break;}}return an;}function aN(av){var aw=av,ax=0;for(;;){if(aw){var ay=aw[2],az=[0,aw[1],ax],aw=ay,ax=az;continue;}return ax;}}function aO(aC,aA){var aB=aA;for(;;){if(aB){var aE=aB[2];aD(aC,aB[1]);var aB=aE;continue;}return 0;}}function aP(aL){return aD(function(aF,aH){var aG=aF,aI=aH;for(;;){if(aI){var aJ=aI[2],aK=aI[1];if(aD(aL,aK)){var aM=[0,aK,aG],aG=aM,aI=aJ;continue;}var aI=aJ;continue;}return aN(aG);}},0);}caml_sys_const_big_endian(0);var aQ=caml_sys_const_word_size(0);caml_sys_const_ostype_unix(0);caml_sys_const_ostype_win32(0);caml_sys_const_ostype_cygwin(0);var aR=[0,0];32===aQ;var aS=[0,R.slice(),0],aT=false,aU=Array,aX=null,aW=undefined;function aY(aV){return aV instanceof aU?0:[0,new MlWrappedString(aV.toString())];}aR[1]=[0,aY,aR[1]];function a6(aZ,a0){aZ.appendChild(a0);return 0;}function a7(a2){return caml_js_wrap_callback(function(a1){if(a1){var a3=aD(a2,a1);if(!(a3|0))a1.preventDefault();return a3;}var a4=event,a5=aD(a2,a4);a4.returnValue=a5;return a5;});}var a8=this,bf=a8.document;function be(a9,a_){return a9?aD(a_,a9[1]):0;}function bb(ba,a$){return ba.createElement(a$.toString());}function bg(bd,bc){return bb(bd,bc);}var bh=[0,785140586];function bD(bi,bj,bk){for(;;){if(0===bi&&0===bj){var bl=bb(bk,b),bm=1;}else var bm=0;if(!bm){var bn=bh[1];if(785140586===bn){try {var bo=bf.createElement(J.toString()),bp=I.toString(),bq=bo.tagName.toLowerCase()===bp?1:0,br=bq?bo.name===H.toString()?1:0:bq,bs=br;}catch(bu){var bs=0;}var bt=bs?982028505:-1003883683;bh[1]=bt;continue;}if(982028505<=bn){var bv=new aU();bv.push(M.toString(),b.toString());be(bi,function(bw){bv.push(N.toString(),caml_js_html_escape(bw),O.toString());return 0;});be(bj,function(bx){bv.push(P.toString(),caml_js_html_escape(bx),Q.toString());return 0;});bv.push(L.toString());var bl=bk.createElement(bv.join(K.toString()));}else{var by=bb(bk,b);be(bi,function(bz){return by.type=bz;});be(bj,function(bA){return by.name=bA;});var bl=by;}}return bl;}}function bE(bB){return bg(bB,F);}function bF(bC){return bg(bC,G);}this.HTMLElement===aW;function bH(bG){return bG.toString();}var bI=a8.document;function ct(bK,bQ){var bJ=0,bL=bK[1]-1|0;if(!(bL<bJ)){var bM=bJ;for(;;){var bN=0,bO=bK[2]-1|0;if(!(bO<bN)){var bP=bN;for(;;){aD(bQ,[0,bM,bP]);var bR=bP+1|0;if(bO!==bP){var bP=bR;continue;}break;}}var bS=bM+1|0;if(bL!==bM){var bM=bS;continue;}break;}}return 0;}function b5(bX,bT){var bU=bT[2],bV=bT[1],bW=0<=bV?1:0;if(bW){var bY=bV<bX[1]?1:0;if(bY){var bZ=0<=bU?1:0,b0=bZ?bU<bX[2]?1:0:bZ;}else var b0=bY;}else var b0=bW;return b0;}function cu(b4,b1){var b2=b1[2],b3=b1[1];return b6(aP,aD(b5,b4),[0,[0,b3-1|0,b2-1|0],[0,[0,b3-1|0,b2],[0,[0,b3-1|0,b2+1|0],[0,[0,b3,b2-1|0],[0,[0,b3,b2+1|0],[0,[0,b3+1|0,b2-1|0],[0,[0,b3+1|0,b2],[0,[0,b3+1|0,b2+1|0],0]]]]]]]]);}function cf(b9,b7){var b8=b7[3]?u:b7[1]?t:b7[2]?0===b7[4]?s:aj(q,aj(ak(b7[4]),r)):p;return b9.src=bH(b8);}function cv(b$){var b_=0,ca=b$[3][2]-1|0;if(!(ca<b_)){var cb=b_;for(;;){var cc=0,cd=b$[3][1]-1|0;if(!(cd<cc)){var ce=cc;for(;;){cf(caml_array_get(caml_array_get(b$[2],cb),ce),caml_array_get(caml_array_get(b$[1],ce),cb));var cg=ce+1|0;if(cd!==ce){var ce=cg;continue;}break;}}var ch=cb+1|0;if(ca!==cb){var cb=ch;continue;}break;}}return 0;}function cw(cj){var ci=0,ck=cj[3][2]-1|0;if(!(ck<ci)){var cl=ci;for(;;){var cm=0,cn=cj[3][1]-1|0;if(!(cn<cm)){var co=cm;for(;;){var cq=caml_array_get(caml_array_get(cj[2],cl),co);cq.onclick=a7(function(cp){a8.alert(bH(v));return aT;});var cr=co+1|0;if(cn!==co){var co=cr;continue;}break;}}var cs=cl+1|0;if(ck!==cl){var cl=cs;continue;}break;}}return 0;}function cy(cx){return cx.toString();}var cz=a8.document;function cK(cB,cD){var cA=cz.createDocumentFragment();a6(cA,cz.createTextNode(cy(cB)));var cC=bD([0,cy(g)],0,cz);cC.value=cy(ak(cD[1]));cC.onchange=a7(function(cF){try {cD[1]=caml_int_of_string(new MlWrappedString(cC.value));}catch(cE){if(cE[1]!==a)throw cE;}cC.value=cy(ak(cD[1]));return aT;});a6(cA,cC);return cA;}a8.onload=a7(function(eH){var cG=cz.getElementById(cy(m));if(cG==aX)throw [0,W,n];var cH=[0,15],cI=[0,12],cJ=[0,10];a6(cG,cK(l,cJ));a6(cG,bE(cz));a6(cG,cK(k,cI));a6(cG,bE(cz));a6(cG,cK(j,cH));a6(cG,bE(cz));var eF=function(eD){var cL=bg(cz,E);a6(cG,cL);var cO=cH[1],cN=cJ[1],cM=f(c[1],cI[1]),cP=f(c[2],cN),cQ=f(1,cO),cR=caml_mul(cM,cP),cS=caml_lessequal(cR,cQ)?cR:cQ,cT=[0,cM,cP,cS],cU=[0,(caml_sys_time(0)*1000|0)%100000|0],cV=0===cU.length-1?[0,0]:cU,cW=cV.length-1,cX=0,cY=54;if(!(cY<cX)){var cZ=cX;for(;;){caml_array_set(aS[1],cZ,cZ);var c0=cZ+1|0;if(cY!==cZ){var cZ=c0;continue;}break;}}var c1=[0,S],c2=0,c3=54+f(55,cW)|0;if(!(c3<c2)){var c4=c2;for(;;){var c5=c4%55|0,c6=c1[1],c7=aj(c6,ak(caml_array_get(cV,caml_mod(c4,cW))));c1[1]=caml_md5_string(c7,0,c7.getLen());var c8=c1[1];caml_array_set(aS[1],c5,(caml_array_get(aS[1],c5)^(((c8.safeGet(0)+(c8.safeGet(1)<<8)|0)+(c8.safeGet(2)<<16)|0)+(c8.safeGet(3)<<24)|0))&1073741823);var c9=c4+1|0;if(c3!==c4){var c4=c9;continue;}break;}}aS[2]=0;var ds=0,dr=caml_mul(cT[2],cT[1])-cT[3]|0,dq=0,dp=caml_make_vect(cP,[0]);function da(c_){return [0,0,0,0,0];}function dt(dd,c$){var dc=c$[2],db=c$[1],de=da(0);return caml_array_set(caml_array_get(dd,db),dc,de);}function du(dg,df){caml_array_get(caml_array_get(dg,caml_div(df,cT[2])),caml_mod(df,cT[2]))[1]=1;return 0;}function dv(dk,dh){var di=dh[2],dj=dh[1];if(caml_array_get(caml_array_get(dk,dj),di)[1])return 0;var dl=[0,0],dn=function(dm){return caml_array_get(caml_array_get(dk,dm[1]),dm[2])[1]?(dl[1]+=1,0):0;};aO(dn,cu(cT,[0,dj,di]));caml_array_get(caml_array_get(dk,dj),di)[4]=dl[1];return 0;}var dw=caml_mul(cT[1],cT[2]),dx=[0,0],dC=cT[3];a:for(;;){var dy=0,dz=dx[1];for(;;){if(dz){var dB=dz[2],dA=dy+1|0,dy=dA,dz=dB;continue;}if(dy<dC){if(!(1073741823<dw)&&0<dw)for(;;){aS[2]=(aS[2]+1|0)%55|0;var dD=caml_array_get(aS[1],aS[2]),dE=(caml_array_get(aS[1],(aS[2]+24|0)%55|0)+(dD^dD>>>25&31)|0)&1073741823;caml_array_set(aS[1],aS[2],dE);var dF=caml_mod(dE,dw);if(((1073741823-dw|0)+1|0)<(dE-dF|0))continue;var dG=dx[1];for(;;){if(dG){var dH=dG[2],dI=0===caml_compare(dG[1],dF)?1:0;if(!dI){var dG=dH;continue;}var dJ=dI;}else var dJ=0;if(!dJ)dx[1]=[0,dF,dx[1]];continue a;}}throw [0,a,T];}var dK=dx[1],dL=da(0),dM=au(cT[1],cT[2],dL);ct(cT,aD(dt,dM));aO(aD(du,dM),dK);ct(cT,aD(dv,dM));var dN=[0,dM,dp,cT,dq,dr,ds],dO=[0,0],dP=bI.createDocumentFragment();a6(dP,bI.createTextNode(bH(A)));var dQ=bF(bI);a6(dP,dQ);dQ.src=bH(z);dQ.onclick=a7(function(dR){if(0===dO[1]){dO[1]=1;dQ.src=bH(B);}else{dO[1]=0;dQ.src=bH(C);}return aT;});a6(dP,bE(bI));var dS=0,dT=dN[3][2]-1|0;if(!(dT<dS)){var dU=dS;for(;;){var dV=[0,0],dW=0,dX=dN[3][1]-1|0;if(!(dX<dW)){var dY=dW;for(;;){var dZ=bF(bI);dV[1]=[0,dZ,dV[1]];dZ.src=bH(y);dZ.onclick=a7(function(dU,dY,dZ){return function(em){if(0===dO[1]){if(!caml_array_get(caml_array_get(dN[1],dY),dU)[2])if(dN[6]){if(caml_array_get(caml_array_get(dN[1],dY),dU)[3]){dN[4]=dN[4]-1|0;caml_array_get(caml_array_get(dN[1],dY),dU)[3]=0;}else{dN[4]=dN[4]+1|0;caml_array_get(caml_array_get(dN[1],dY),dU)[3]=1;}cf(caml_array_get(caml_array_get(dN[2],dU),dY),caml_array_get(caml_array_get(dN[1],dY),dU));}else if(!caml_array_get(caml_array_get(dN[1],dY),dU)[3])if(caml_array_get(caml_array_get(dN[1],dY),dU)[1]){cv(dN);cw(dN);a8.alert(bH(D));}else{var d4=function(d0){var d1=d0[2],d2=d0[1];caml_array_get(caml_array_get(dN[1],d2),d1)[2]=1;cf(caml_array_get(caml_array_get(dN[2],d1),d2),caml_array_get(caml_array_get(dN[1],d2),d1));dN[5]=dN[5]-1|0;return 0;},d3=dN[3],d5=dN[1],d6=au(d3[1],d3[2],0),ec=function(d7){var d8=d7;for(;;){if(d8){var d9=d8[2],d_=d8[1],d$=d_[2],ea=d_[1],eb=caml_array_get(caml_array_get(d5,ea),d$);if(!eb[1]&&!eb[3]&&!eb[2]&&!caml_array_get(caml_array_get(d6,ea),d$)){var ed=ec(d9),ee=ed[2],ef=ed[1];caml_array_set(caml_array_get(d6,ea),d$,1);return 0===eb[4]?[0,ef,[0,d_,ee]]:[0,[0,d_,ef],ee];}var d8=d9;continue;}return o;}},el=function(eg){if(eg){var eh=eg[2],ei=eg[1];if(0===caml_array_get(caml_array_get(d5,ei[1]),ei[2])[4]){var ej=ec(cu(d3,ei)),ek=ej[1];return ac([0,ei,ek],el(ac(ej[2],eh)));}return [0,ei,el(eh)];}return 0;};caml_array_set(caml_array_get(d6,dY),dU,1);aO(d4,el([0,[0,dY,dU],0]));if(0===dN[5]){cv(dN);cw(dN);a8.alert(bH(w));}}}else{caml_array_get(caml_array_get(dN[1],dY),dU)[3]=1-caml_array_get(caml_array_get(dN[1],dY),dU)[3];cf(dZ,caml_array_get(caml_array_get(dN[1],dY),dU));}return aT;};}(dU,dY,dZ));a6(dP,dZ);var en=dY+1|0;if(dX!==dY){var dY=en;continue;}break;}}a6(dP,bE(bI));var eo=aN(dV[1]);if(eo){var ep=0,eq=eo,ew=eo[2],et=eo[1];for(;;){if(eq){var es=eq[2],er=ep+1|0,ep=er,eq=es;continue;}var eu=caml_make_vect(ep,et),ev=1,ex=ew;for(;;){if(ex){var ey=ex[2];eu[ev+1]=ex[1];var ez=ev+1|0,ev=ez,ex=ey;continue;}var eA=eu;break;}break;}}else var eA=[0];caml_array_set(dN[2],dU,eA);var eB=dU+1|0;if(dT!==dU){var dU=eB;continue;}break;}}var eC=cL.style;eC.lineHeight=bH(x);a6(cL,dP);return aT;}}},eE=cz.createDocumentFragment(),eG=bD([0,cy(h)],0,cz);eG.value=cy(i);eG.onclick=a7(eF);a6(eE,eG);a6(cG,eE);return aT;});al(0);return;}());
