// This program was compiled from OCaml by js_of_ocaml 1.3
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_raise_not_found () { caml_raise_constant(caml_global_data[7]); }
function caml_sys_getenv () { caml_raise_not_found (); }
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _hI_(_rg_,_rh_,_ri_,_rj_,_rk_,_rl_,_rm_)
     {return _rg_.length==6
              ?_rg_(_rh_,_ri_,_rj_,_rk_,_rl_,_rm_)
              :caml_call_gen(_rg_,[_rh_,_ri_,_rj_,_rk_,_rl_,_rm_]);}
    function _dz_(_rc_,_rd_,_re_,_rf_)
     {return _rc_.length==3
              ?_rc_(_rd_,_re_,_rf_)
              :caml_call_gen(_rc_,[_rd_,_re_,_rf_]);}
    function _d4_(_q$_,_ra_,_rb_)
     {return _q$_.length==2?_q$_(_ra_,_rb_):caml_call_gen(_q$_,[_ra_,_rb_]);}
    function _bN_(_q9_,_q__)
     {return _q9_.length==1?_q9_(_q__):caml_call_gen(_q9_,[_q__]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")],
     _e_=new MlString("File \"%s\", line %d, characters %d-%d: %s");
    caml_register_global(6,_c_);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _bn_=[0,new MlString("Out_of_memory")],
     _bm_=[0,new MlString("Match_failure")],
     _bl_=[0,new MlString("Stack_overflow")],
     _bk_=[0,new MlString("Undefined_recursive_module")],
     _bj_=new MlString("%.12g"),
     _bi_=new MlString("."),
     _bh_=new MlString("%d"),
     _bg_=new MlString("true"),
     _bf_=new MlString("false"),
     _be_=new MlString("Pervasives.do_at_exit"),
     _bd_=new MlString("\\b"),
     _bc_=new MlString("\\t"),
     _bb_=new MlString("\\n"),
     _ba_=new MlString("\\r"),
     _a$_=new MlString("\\\\"),
     _a__=new MlString("\\'"),
     _a9_=new MlString("String.contains_from"),
     _a8_=new MlString("String.blit"),
     _a7_=new MlString("String.sub"),
     _a6_=new MlString("Queue.Empty"),
     _a5_=new MlString("Buffer.add: cannot grow buffer"),
     _a4_=new MlString(""),
     _a3_=new MlString(""),
     _a2_=new MlString("%.12g"),
     _a1_=new MlString("\""),
     _a0_=new MlString("\""),
     _aZ_=new MlString("'"),
     _aY_=new MlString("'"),
     _aX_=new MlString("nan"),
     _aW_=new MlString("neg_infinity"),
     _aV_=new MlString("infinity"),
     _aU_=new MlString("."),
     _aT_=new MlString("printf: bad positional specification (0)."),
     _aS_=new MlString("%_"),
     _aR_=[0,new MlString("printf.ml"),143,8],
     _aQ_=new MlString("'"),
     _aP_=new MlString("Printf: premature end of format string '"),
     _aO_=new MlString("'"),
     _aN_=new MlString(" in format string '"),
     _aM_=new MlString(", at char number "),
     _aL_=new MlString("Printf: bad conversion %"),
     _aK_=new MlString("Sformat.index_of_int: negative argument "),
     _aJ_=new MlString(""),
     _aI_=new MlString(", %s%s"),
     _aH_=[1,1],
     _aG_=new MlString("%s\n"),
     _aF_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _aE_=new MlString("Raised at"),
     _aD_=new MlString("Re-raised at"),
     _aC_=new MlString("Raised by primitive operation at"),
     _aB_=new MlString("Called from"),
     _aA_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _az_=new MlString("%s unknown location"),
     _ay_=new MlString("Pattern matching failed"),
     _ax_=new MlString("Assertion failed"),
     _aw_=new MlString("Undefined recursive module"),
     _av_=new MlString("(%s%s)"),
     _au_=new MlString(""),
     _at_=new MlString(""),
     _as_=new MlString("(%s)"),
     _ar_=new MlString("%d"),
     _aq_=new MlString("%S"),
     _ap_=new MlString("_"),
     _ao_=new MlString("OCAMLRUNPARAM"),
     _an_=new MlString("CAMLRUNPARAM"),
     _am_=new MlString(""),
     _al_=[0,new MlString("src/core/lwt.ml"),814,20],
     _ak_=[0,new MlString("src/core/lwt.ml"),816,8],
     _aj_=[0,new MlString("src/core/lwt.ml"),648,20],
     _ai_=[0,new MlString("src/core/lwt.ml"),651,8],
     _ah_=[0,new MlString("src/core/lwt.ml"),498,8],
     _ag_=[0,new MlString("src/core/lwt.ml"),487,9],
     _af_=new MlString("Lwt.wakeup_result"),
     _ae_=new MlString("Lwt.Canceled"),
     _ad_=new MlString("on"),
     _ac_=new MlString("\""),
     _ab_=new MlString(" name=\""),
     _aa_=new MlString("\""),
     _$_=new MlString(" type=\""),
     ___=new MlString("<"),
     _Z_=new MlString(">"),
     _Y_=new MlString(""),
     _X_=new MlString("<input name=\"x\">"),
     _W_=new MlString("input"),
     _V_=new MlString("x"),
     _U_=new MlString("canvas"),
     _T_=new MlString("img"),
     _S_=new MlString("br"),
     _R_=new MlString("p"),
     _Q_=new MlString("div"),
     _P_=new MlString("label"),
     _O_=new MlString("input"),
     _N_=new MlString("select"),
     _M_=new MlString("option"),
     _L_=new MlString("mouseup"),
     _K_=new MlString("mousemove"),
     _J_=new MlString("2d"),
     _I_=new MlString("Dom_html.Canvas_not_available"),
     _H_=new MlString("lighter"),
     _G_=new MlString("copy"),
     _F_=new MlString("% 2.f"),
     _E_=new MlString(""),
     _D_=new MlString("controls"),
     _C_=new MlString("Click and drag mouse to rotate."),
     _B_=new MlString("Resume"),
     _A_=new MlString("Pause"),
     _z_=new MlString("Fixed position"),
     _y_=new MlString("Follow rotation"),
     _x_=new MlString("Reset orientation"),
     _w_=new MlString("Date:"),
     _v_=
      [0,
       new MlString("December solstice"),
       [0,new MlString("Equinox"),[0,new MlString("June solstice"),0]]],
     _u_=new MlString("Lighting"),
     _t_=new MlString("Clip"),
     _s_=new MlString("Frames per second: "),
     _r_=
      new
       MlString
       ("Credit: <a href='http://visibleearth.nasa.gov/'>Visual Earth</a>, Nasa"),
     _q_=[0,new MlString("planet.ml"),415,0],
     _p_=[0,new MlString("planet.ml"),416,0],
     _o_=[0,new MlString("planet.ml"),417,0],
     _n_=[0,new MlString("planet.ml"),418,0],
     _m_=new MlString("copy"),
     _l_=new MlString("checkbox"),
     _k_=new MlString("button"),
     v_j_=[254,0,0,1],
     _i_=new MlString("../planet/texture.jpg");
    function _h_(s_f_){throw [0,_a_,s_f_];}
    function _bo_(s_g_){throw [0,_b_,s_g_];}
    function _bv_(s1_bp_,s2_br_)
     {var
       l1_bq_=s1_bp_.getLen(),
       l2_bs_=s2_br_.getLen(),
       s_bt_=caml_create_string(l1_bq_+l2_bs_|0);
      caml_blit_string(s1_bp_,0,s_bt_,0,l1_bq_);
      caml_blit_string(s2_br_,0,s_bt_,l1_bq_,l2_bs_);
      return s_bt_;}
    function string_of_int_bw_(n_bu_){return caml_format_int(_bh_,n_bu_);}
    var stderr_bx_=caml_ml_open_descriptor_out(2);
    function output_string_bF_(oc_bz_,s_by_)
     {return caml_ml_output(oc_bz_,s_by_,0,s_by_.getLen());}
    function do_at_exit_bE_(param_bD_)
     {var param_bA_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_bA_)
         {var l_bB_=param_bA_[2];
          try {}catch(_bC_){}
          var param_bA_=l_bB_;
          continue;}
        return 0;}}
    caml_register_named_value(_be_,do_at_exit_bE_);
    function _bJ_(_bH_,_bG_){return caml_ml_output_char(_bH_,_bG_);}
    function _bU_(_bI_){return caml_ml_flush(_bI_);}
    function _bT_(f_bM_,a_bK_)
     {var l_bL_=a_bK_.length-1;
      if(0===l_bL_)return [0];
      var
       r_bO_=caml_make_vect(l_bL_,_bN_(f_bM_,a_bK_[0+1])),
       _bP_=1,
       _bQ_=l_bL_-1|0;
      if(!(_bQ_<_bP_))
       {var i_bR_=_bP_;
        for(;;)
         {r_bO_[i_bR_+1]=_bN_(f_bM_,a_bK_[i_bR_+1]);
          var _bS_=i_bR_+1|0;
          if(_bQ_!==i_bR_){var i_bR_=_bS_;continue;}
          break;}}
      return r_bO_;}
    function _b7_(n_bV_,c_bX_)
     {var s_bW_=caml_create_string(n_bV_);
      caml_fill_string(s_bW_,0,n_bV_,c_bX_);
      return s_bW_;}
    function _b8_(s_b0_,ofs_bY_,len_bZ_)
     {if(0<=ofs_bY_&&0<=len_bZ_&&!((s_b0_.getLen()-len_bZ_|0)<ofs_bY_))
       {var r_b1_=caml_create_string(len_bZ_);
        caml_blit_string(s_b0_,ofs_bY_,r_b1_,0,len_bZ_);
        return r_b1_;}
      return _bo_(_a7_);}
    function _b9_(s1_b4_,ofs1_b3_,s2_b6_,ofs2_b5_,len_b2_)
     {if
       (0<=
        len_b2_&&
        0<=
        ofs1_b3_&&
        !((s1_b4_.getLen()-len_b2_|0)<ofs1_b3_)&&
        0<=
        ofs2_b5_&&
        !((s2_b6_.getLen()-len_b2_|0)<ofs2_b5_))
       return caml_blit_string(s1_b4_,ofs1_b3_,s2_b6_,ofs2_b5_,len_b2_);
      return _bo_(_a8_);}
    caml_sys_const_big_endian(0);
    var _b__=caml_sys_const_word_size(0);
    caml_sys_const_ostype_unix(0);
    caml_sys_const_ostype_win32(0);
    caml_sys_const_ostype_cygwin(0);
    var
     _b$_=caml_mul(_b__/8|0,(1<<(_b__-10|0))-1|0)-1|0,
     _cu_=252,
     _ct_=253,
     _cs_=[0,_a6_];
    function _cr_(n_ca_)
     {var
       n_cb_=1<=n_ca_?n_ca_:1,
       n_cc_=_b$_<n_cb_?_b$_:n_cb_,
       s_cd_=caml_create_string(n_cc_);
      return [0,s_cd_,0,n_cc_,s_cd_];}
    function _cv_(b_ce_){return _b8_(b_ce_[1],0,b_ce_[2]);}
    function _cl_(b_cf_,more_ch_)
     {var new_len_cg_=[0,b_cf_[3]];
      for(;;)
       {if(new_len_cg_[1]<(b_cf_[2]+more_ch_|0))
         {new_len_cg_[1]=2*new_len_cg_[1]|0;continue;}
        if(_b$_<new_len_cg_[1])
         if((b_cf_[2]+more_ch_|0)<=_b$_)new_len_cg_[1]=_b$_;else _h_(_a5_);
        var new_buffer_ci_=caml_create_string(new_len_cg_[1]);
        _b9_(b_cf_[1],0,new_buffer_ci_,0,b_cf_[2]);
        b_cf_[1]=new_buffer_ci_;
        b_cf_[3]=new_len_cg_[1];
        return 0;}}
    function _cw_(b_cj_,c_cm_)
     {var pos_ck_=b_cj_[2];
      if(b_cj_[3]<=pos_ck_)_cl_(b_cj_,1);
      b_cj_[1].safeSet(pos_ck_,c_cm_);
      b_cj_[2]=pos_ck_+1|0;
      return 0;}
    function _cx_(b_cp_,s_cn_)
     {var len_co_=s_cn_.getLen(),new_position_cq_=b_cp_[2]+len_co_|0;
      if(b_cp_[3]<new_position_cq_)_cl_(b_cp_,len_co_);
      _b9_(s_cn_,0,b_cp_[1],b_cp_[2],len_co_);
      b_cp_[2]=new_position_cq_;
      return 0;}
    function index_of_int_cB_(i_cy_)
     {return 0<=i_cy_?i_cy_:_h_(_bv_(_aK_,string_of_int_bw_(i_cy_)));}
    function add_int_index_cC_(i_cz_,idx_cA_)
     {return index_of_int_cB_(i_cz_+idx_cA_|0);}
    var _cD_=_bN_(add_int_index_cC_,1);
    function _cK_(fmt_cE_){return _b8_(fmt_cE_,0,fmt_cE_.getLen());}
    function bad_conversion_cM_(sfmt_cF_,i_cG_,c_cI_)
     {var
       _cH_=_bv_(_aN_,_bv_(sfmt_cF_,_aO_)),
       _cJ_=_bv_(_aM_,_bv_(string_of_int_bw_(i_cG_),_cH_));
      return _bo_(_bv_(_aL_,_bv_(_b7_(1,c_cI_),_cJ_)));}
    function bad_conversion_format_dF_(fmt_cL_,i_cO_,c_cN_)
     {return bad_conversion_cM_(_cK_(fmt_cL_),i_cO_,c_cN_);}
    function incomplete_format_dG_(fmt_cP_)
     {return _bo_(_bv_(_aP_,_bv_(_cK_(fmt_cP_),_aQ_)));}
    function extract_format_db_(fmt_cQ_,start_cY_,stop_c0_,widths_c2_)
     {function skip_positional_spec_cX_(start_cR_)
       {if
         ((fmt_cQ_.safeGet(start_cR_)-48|0)<
          0||
          9<
          (fmt_cQ_.safeGet(start_cR_)-48|0))
         return start_cR_;
        var i_cS_=start_cR_+1|0;
        for(;;)
         {var _cT_=fmt_cQ_.safeGet(i_cS_);
          if(48<=_cT_)
           {if(!(58<=_cT_)){var _cV_=i_cS_+1|0,i_cS_=_cV_;continue;}
            var _cU_=0;}
          else
           if(36===_cT_){var _cW_=i_cS_+1|0,_cU_=1;}else var _cU_=0;
          if(!_cU_)var _cW_=start_cR_;
          return _cW_;}}
      var
       start_cZ_=skip_positional_spec_cX_(start_cY_+1|0),
       b_c1_=_cr_((stop_c0_-start_cZ_|0)+10|0);
      _cw_(b_c1_,37);
      var l1_c3_=widths_c2_,l2_c4_=0;
      for(;;)
       {if(l1_c3_)
         {var
           l_c5_=l1_c3_[2],
           _c6_=[0,l1_c3_[1],l2_c4_],
           l1_c3_=l_c5_,
           l2_c4_=_c6_;
          continue;}
        var i_c7_=start_cZ_,widths_c8_=l2_c4_;
        for(;;)
         {if(i_c7_<=stop_c0_)
           {var _c9_=fmt_cQ_.safeGet(i_c7_);
            if(42===_c9_)
             {if(widths_c8_)
               {var t_c__=widths_c8_[2];
                _cx_(b_c1_,string_of_int_bw_(widths_c8_[1]));
                var
                 i_c$_=skip_positional_spec_cX_(i_c7_+1|0),
                 i_c7_=i_c$_,
                 widths_c8_=t_c__;
                continue;}
              throw [0,_d_,_aR_];}
            _cw_(b_c1_,_c9_);
            var _da_=i_c7_+1|0,i_c7_=_da_;
            continue;}
          return _cv_(b_c1_);}}}
    function extract_format_int_e7_
     (conv_dh_,fmt_df_,start_de_,stop_dd_,widths_dc_)
     {var sfmt_dg_=extract_format_db_(fmt_df_,start_de_,stop_dd_,widths_dc_);
      if(78!==conv_dh_&&110!==conv_dh_)return sfmt_dg_;
      sfmt_dg_.safeSet(sfmt_dg_.getLen()-1|0,117);
      return sfmt_dg_;}
    function sub_format_dH_
     (incomplete_format_do_,bad_conversion_format_dy_,conv_dD_,fmt_di_,i_dC_)
     {var len_dj_=fmt_di_.getLen();
      function sub_fmt_dA_(c_dk_,i_dx_)
       {var close_dl_=40===c_dk_?41:125;
        function sub_dw_(j_dm_)
         {var j_dn_=j_dm_;
          for(;;)
           {if(len_dj_<=j_dn_)return _bN_(incomplete_format_do_,fmt_di_);
            if(37===fmt_di_.safeGet(j_dn_))
             {var _dp_=j_dn_+1|0;
              if(len_dj_<=_dp_)
               var _dq_=_bN_(incomplete_format_do_,fmt_di_);
              else
               {var _dr_=fmt_di_.safeGet(_dp_),_ds_=_dr_-40|0;
                if(_ds_<0||1<_ds_)
                 {var _dt_=_ds_-83|0;
                  if(_dt_<0||2<_dt_)
                   var _du_=1;
                  else
                   switch(_dt_)
                    {case 1:var _du_=1;break;
                     case 2:var _dv_=1,_du_=0;break;
                     default:var _dv_=0,_du_=0;}
                  if(_du_){var _dq_=sub_dw_(_dp_+1|0),_dv_=2;}}
                else
                 var _dv_=0===_ds_?0:1;
                switch(_dv_)
                 {case 1:
                   var
                    _dq_=
                     _dr_===close_dl_
                      ?_dp_+1|0
                      :_dz_(bad_conversion_format_dy_,fmt_di_,i_dx_,_dr_);
                   break;
                  case 2:break;
                  default:var _dq_=sub_dw_(sub_fmt_dA_(_dr_,_dp_+1|0)+1|0);}}
              return _dq_;}
            var _dB_=j_dn_+1|0,j_dn_=_dB_;
            continue;}}
        return sub_dw_(i_dx_);}
      return sub_fmt_dA_(conv_dD_,i_dC_);}
    function sub_format_for_printf_d7_(conv_dE_)
     {return _dz_
              (sub_format_dH_,
               incomplete_format_dG_,
               bad_conversion_format_dF_,
               conv_dE_);}
    function iter_on_format_args_el_(fmt_dI_,add_conv_dT_,add_char_d3_)
     {var lim_dJ_=fmt_dI_.getLen()-1|0;
      function scan_fmt_d5_(i_dK_)
       {var i_dL_=i_dK_;
        a:
        for(;;)
         {if(i_dL_<lim_dJ_)
           {if(37===fmt_dI_.safeGet(i_dL_))
             {var skip_dM_=0,i_dN_=i_dL_+1|0;
              for(;;)
               {if(lim_dJ_<i_dN_)
                 var _dO_=incomplete_format_dG_(fmt_dI_);
                else
                 {var _dP_=fmt_dI_.safeGet(i_dN_);
                  if(58<=_dP_)
                   {if(95===_dP_)
                     {var _dR_=i_dN_+1|0,_dQ_=1,skip_dM_=_dQ_,i_dN_=_dR_;
                      continue;}}
                  else
                   if(32<=_dP_)
                    switch(_dP_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _dS_=i_dN_+1|0,i_dN_=_dS_;continue;
                      case 10:
                       var _dU_=_dz_(add_conv_dT_,skip_dM_,i_dN_,105),i_dN_=_dU_;
                       continue;
                      default:var _dV_=i_dN_+1|0,i_dN_=_dV_;continue;}
                  var i_dW_=i_dN_;
                  c:
                  for(;;)
                   {if(lim_dJ_<i_dW_)
                     var _dX_=incomplete_format_dG_(fmt_dI_);
                    else
                     {var _dY_=fmt_dI_.safeGet(i_dW_);
                      if(126<=_dY_)
                       var _dZ_=0;
                      else
                       switch(_dY_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,105),_dZ_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,102),_dZ_=1;break;
                         case 33:
                         case 37:
                         case 44:
                         case 64:var _dX_=i_dW_+1|0,_dZ_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,115),_dZ_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,_dY_),_dZ_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_d0_=i_dW_+1|0;
                          if(lim_dJ_<j_d0_)
                           {var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,105),_dZ_=1;}
                          else
                           {var _d1_=fmt_dI_.safeGet(j_d0_)-88|0;
                            if(_d1_<0||32<_d1_)
                             var _d2_=1;
                            else
                             switch(_d1_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _dX_=
                                  _d4_
                                   (add_char_d3_,_dz_(add_conv_dT_,skip_dM_,i_dW_,_dY_),105),
                                 _dZ_=1,
                                 _d2_=0;
                                break;
                               default:var _d2_=1;}
                            if(_d2_)
                             {var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,105),_dZ_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,99),_dZ_=1;break;
                         case 66:
                         case 98:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,66),_dZ_=1;break;
                         case 41:
                         case 125:
                          var _dX_=_dz_(add_conv_dT_,skip_dM_,i_dW_,_dY_),_dZ_=1;
                          break;
                         case 40:
                          var
                           _dX_=scan_fmt_d5_(_dz_(add_conv_dT_,skip_dM_,i_dW_,_dY_)),
                           _dZ_=1;
                          break;
                         case 123:
                          var
                           i_d6_=_dz_(add_conv_dT_,skip_dM_,i_dW_,_dY_),
                           j_d8_=_dz_(sub_format_for_printf_d7_,_dY_,fmt_dI_,i_d6_),
                           i_d9_=i_d6_;
                          for(;;)
                           {if(i_d9_<(j_d8_-2|0))
                             {var
                               _d__=_d4_(add_char_d3_,i_d9_,fmt_dI_.safeGet(i_d9_)),
                               i_d9_=_d__;
                              continue;}
                            var _d$_=j_d8_-1|0,i_dW_=_d$_;
                            continue c;}
                         default:var _dZ_=0;}
                      if(!_dZ_)
                       var _dX_=bad_conversion_format_dF_(fmt_dI_,i_dW_,_dY_);}
                    var _dO_=_dX_;
                    break;}}
                var i_dL_=_dO_;
                continue a;}}
            var _ea_=i_dL_+1|0,i_dL_=_ea_;
            continue;}
          return i_dL_;}}
      scan_fmt_d5_(0);
      return 0;}
    function count_printing_arguments_of_format_gk_(fmt_em_)
     {var ac_eb_=[0,0,0,0];
      function add_conv_ek_(skip_eg_,i_eh_,c_ec_)
       {var _ed_=41!==c_ec_?1:0,_ee_=_ed_?125!==c_ec_?1:0:_ed_;
        if(_ee_)
         {var inc_ef_=97===c_ec_?2:1;
          if(114===c_ec_)ac_eb_[3]=ac_eb_[3]+1|0;
          if(skip_eg_)
           ac_eb_[2]=ac_eb_[2]+inc_ef_|0;
          else
           ac_eb_[1]=ac_eb_[1]+inc_ef_|0;}
        return i_eh_+1|0;}
      iter_on_format_args_el_
       (fmt_em_,add_conv_ek_,function(i_ei_,param_ej_){return i_ei_+1|0;});
      return ac_eb_[1];}
    function scan_positional_spec_e3_(fmt_en_,got_spec_eq_,i_eo_)
     {var _ep_=fmt_en_.safeGet(i_eo_);
      if((_ep_-48|0)<0||9<(_ep_-48|0))return _d4_(got_spec_eq_,0,i_eo_);
      var accu_er_=_ep_-48|0,j_es_=i_eo_+1|0;
      for(;;)
       {var _et_=fmt_en_.safeGet(j_es_);
        if(48<=_et_)
         {if(!(58<=_et_))
           {var
             _ew_=j_es_+1|0,
             _ev_=(10*accu_er_|0)+(_et_-48|0)|0,
             accu_er_=_ev_,
             j_es_=_ew_;
            continue;}
          var _eu_=0;}
        else
         if(36===_et_)
          if(0===accu_er_)
           {var _ex_=_h_(_aT_),_eu_=1;}
          else
           {var
             _ex_=
              _d4_(got_spec_eq_,[0,index_of_int_cB_(accu_er_-1|0)],j_es_+1|0),
             _eu_=1;}
         else
          var _eu_=0;
        if(!_eu_)var _ex_=_d4_(got_spec_eq_,0,i_eo_);
        return _ex_;}}
    function next_index_eY_(spec_ey_,n_ez_)
     {return spec_ey_?n_ez_:_bN_(_cD_,n_ez_);}
    function get_index_eN_(spec_eA_,n_eB_){return spec_eA_?spec_eA_[1]:n_eB_;}
    function _hH_
     (to_s_gF_,get_out_eD_,outc_gR_,outs_eG_,flush_gp_,k_gX_,fmt_eC_)
     {var out_eE_=_bN_(get_out_eD_,fmt_eC_);
      function outs_gG_(s_eF_){return _d4_(outs_eG_,out_eE_,s_eF_);}
      function pr_go_(k_eL_,n_gW_,fmt_eH_,v_eQ_)
       {var len_eK_=fmt_eH_.getLen();
        function doprn_gl_(n_gO_,i_eI_)
         {var i_eJ_=i_eI_;
          for(;;)
           {if(len_eK_<=i_eJ_)return _bN_(k_eL_,out_eE_);
            var _eM_=fmt_eH_.safeGet(i_eJ_);
            if(37===_eM_)
             {var
               get_arg_eU_=
                function(spec_eP_,n_eO_)
                 {return caml_array_get(v_eQ_,get_index_eN_(spec_eP_,n_eO_));},
               scan_flags_e0_=
                function(spec_e2_,n_eV_,widths_eX_,i_eR_)
                 {var i_eS_=i_eR_;
                  for(;;)
                   {var _eT_=fmt_eH_.safeGet(i_eS_)-32|0;
                    if(!(_eT_<0||25<_eT_))
                     switch(_eT_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_e3_
                                (fmt_eH_,
                                 function(wspec_eW_,i_e1_)
                                  {var _eZ_=[0,get_arg_eU_(wspec_eW_,n_eV_),widths_eX_];
                                   return scan_flags_e0_
                                           (spec_e2_,next_index_eY_(wspec_eW_,n_eV_),_eZ_,i_e1_);},
                                 i_eS_+1|0);
                       default:var _e4_=i_eS_+1|0,i_eS_=_e4_;continue;}
                    var _e5_=fmt_eH_.safeGet(i_eS_);
                    if(124<=_e5_)
                     var _e6_=0;
                    else
                     switch(_e5_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_e8_=get_arg_eU_(spec_e2_,n_eV_),
                         s_e9_=
                          caml_format_int
                           (extract_format_int_e7_(_e5_,fmt_eH_,i_eJ_,i_eS_,widths_eX_),
                            x_e8_),
                         _e$_=
                          cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_e9_,i_eS_+1|0),
                         _e6_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_fa_=get_arg_eU_(spec_e2_,n_eV_),
                         s_fb_=
                          caml_format_float
                           (extract_format_db_(fmt_eH_,i_eJ_,i_eS_,widths_eX_),x_fa_),
                         _e$_=
                          cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_fb_,i_eS_+1|0),
                         _e6_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _fc_=fmt_eH_.safeGet(i_eS_+1|0)-88|0;
                        if(_fc_<0||32<_fc_)
                         var _fd_=1;
                        else
                         switch(_fc_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_fe_=i_eS_+1|0,_ff_=_e5_-108|0;
                            if(_ff_<0||2<_ff_)
                             var _fg_=0;
                            else
                             {switch(_ff_)
                               {case 1:var _fg_=0,_fh_=0;break;
                                case 2:
                                 var
                                  x_fi_=get_arg_eU_(spec_e2_,n_eV_),
                                  _fj_=
                                   caml_format_int
                                    (extract_format_db_(fmt_eH_,i_eJ_,i_fe_,widths_eX_),x_fi_),
                                  _fh_=1;
                                 break;
                                default:
                                 var
                                  x_fk_=get_arg_eU_(spec_e2_,n_eV_),
                                  _fj_=
                                   caml_format_int
                                    (extract_format_db_(fmt_eH_,i_eJ_,i_fe_,widths_eX_),x_fk_),
                                  _fh_=1;}
                              if(_fh_){var s_fl_=_fj_,_fg_=1;}}
                            if(!_fg_)
                             {var
                               x_fm_=get_arg_eU_(spec_e2_,n_eV_),
                               s_fl_=
                                caml_int64_format
                                 (extract_format_db_(fmt_eH_,i_eJ_,i_fe_,widths_eX_),x_fm_);}
                            var
                             _e$_=
                              cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_fl_,i_fe_+1|0),
                             _e6_=1,
                             _fd_=0;
                            break;
                           default:var _fd_=1;}
                        if(_fd_)
                         {var
                           x_fn_=get_arg_eU_(spec_e2_,n_eV_),
                           s_fo_=
                            caml_format_int
                             (extract_format_int_e7_(110,fmt_eH_,i_eJ_,i_eS_,widths_eX_),
                              x_fn_),
                           _e$_=
                            cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_fo_,i_eS_+1|0),
                           _e6_=1;}
                        break;
                       case 37:
                       case 64:
                        var _e$_=cont_s_e__(n_eV_,_b7_(1,_e5_),i_eS_+1|0),_e6_=1;
                        break;
                       case 83:
                       case 115:
                        var x_fp_=get_arg_eU_(spec_e2_,n_eV_);
                        if(115===_e5_)
                         var x_fq_=x_fp_;
                        else
                         {var n_fr_=[0,0],_fs_=0,_ft_=x_fp_.getLen()-1|0;
                          if(!(_ft_<_fs_))
                           {var i_fu_=_fs_;
                            for(;;)
                             {var
                               _fv_=x_fp_.safeGet(i_fu_),
                               _fw_=
                                14<=_fv_
                                 ?34===_fv_?1:92===_fv_?1:0
                                 :11<=_fv_?13<=_fv_?1:0:8<=_fv_?1:0,
                               _fx_=_fw_?2:caml_is_printable(_fv_)?1:4;
                              n_fr_[1]=n_fr_[1]+_fx_|0;
                              var _fy_=i_fu_+1|0;
                              if(_ft_!==i_fu_){var i_fu_=_fy_;continue;}
                              break;}}
                          if(n_fr_[1]===x_fp_.getLen())
                           var _fz_=x_fp_;
                          else
                           {var s__fA_=caml_create_string(n_fr_[1]);
                            n_fr_[1]=0;
                            var _fB_=0,_fC_=x_fp_.getLen()-1|0;
                            if(!(_fC_<_fB_))
                             {var i_fD_=_fB_;
                              for(;;)
                               {var _fE_=x_fp_.safeGet(i_fD_),_fF_=_fE_-34|0;
                                if(_fF_<0||58<_fF_)
                                 if(-20<=_fF_)
                                  var _fG_=1;
                                 else
                                  {switch(_fF_+34|0)
                                    {case 8:
                                      s__fA_.safeSet(n_fr_[1],92);
                                      n_fr_[1]+=1;
                                      s__fA_.safeSet(n_fr_[1],98);
                                      var _fH_=1;
                                      break;
                                     case 9:
                                      s__fA_.safeSet(n_fr_[1],92);
                                      n_fr_[1]+=1;
                                      s__fA_.safeSet(n_fr_[1],116);
                                      var _fH_=1;
                                      break;
                                     case 10:
                                      s__fA_.safeSet(n_fr_[1],92);
                                      n_fr_[1]+=1;
                                      s__fA_.safeSet(n_fr_[1],110);
                                      var _fH_=1;
                                      break;
                                     case 13:
                                      s__fA_.safeSet(n_fr_[1],92);
                                      n_fr_[1]+=1;
                                      s__fA_.safeSet(n_fr_[1],114);
                                      var _fH_=1;
                                      break;
                                     default:var _fG_=1,_fH_=0;}
                                   if(_fH_)var _fG_=0;}
                                else
                                 var
                                  _fG_=
                                   (_fF_-1|0)<0||56<(_fF_-1|0)
                                    ?(s__fA_.safeSet(n_fr_[1],92),
                                      n_fr_[1]+=
                                      1,
                                      s__fA_.safeSet(n_fr_[1],_fE_),
                                      0)
                                    :1;
                                if(_fG_)
                                 if(caml_is_printable(_fE_))
                                  s__fA_.safeSet(n_fr_[1],_fE_);
                                 else
                                  {s__fA_.safeSet(n_fr_[1],92);
                                   n_fr_[1]+=1;
                                   s__fA_.safeSet(n_fr_[1],48+(_fE_/100|0)|0);
                                   n_fr_[1]+=1;
                                   s__fA_.safeSet(n_fr_[1],48+((_fE_/10|0)%10|0)|0);
                                   n_fr_[1]+=1;
                                   s__fA_.safeSet(n_fr_[1],48+(_fE_%10|0)|0);}
                                n_fr_[1]+=1;
                                var _fI_=i_fD_+1|0;
                                if(_fC_!==i_fD_){var i_fD_=_fI_;continue;}
                                break;}}
                            var _fz_=s__fA_;}
                          var x_fq_=_bv_(_a0_,_bv_(_fz_,_a1_));}
                        if(i_eS_===(i_eJ_+1|0))
                         var s_fJ_=x_fq_;
                        else
                         {var
                           _fK_=
                            extract_format_db_(fmt_eH_,i_eJ_,i_eS_,widths_eX_);
                          try
                           {var neg_fL_=0,i_fM_=1;
                            for(;;)
                             {if(_fK_.getLen()<=i_fM_)
                               var _fN_=[0,0,neg_fL_];
                              else
                               {var _fO_=_fK_.safeGet(i_fM_);
                                if(49<=_fO_)
                                 if(58<=_fO_)
                                  var _fP_=0;
                                 else
                                  {var
                                    _fN_=
                                     [0,
                                      caml_int_of_string
                                       (_b8_(_fK_,i_fM_,(_fK_.getLen()-i_fM_|0)-1|0)),
                                      neg_fL_],
                                    _fP_=1;}
                                else
                                 {if(45===_fO_)
                                   {var _fR_=i_fM_+1|0,_fQ_=1,neg_fL_=_fQ_,i_fM_=_fR_;
                                    continue;}
                                  var _fP_=0;}
                                if(!_fP_){var _fS_=i_fM_+1|0,i_fM_=_fS_;continue;}}
                              var match_fT_=_fN_;
                              break;}}
                          catch(_fU_)
                           {if(_fU_[1]!==_a_)throw _fU_;
                            var match_fT_=bad_conversion_cM_(_fK_,0,115);}
                          var
                           p_fV_=match_fT_[1],
                           _fW_=x_fq_.getLen(),
                           _fX_=0,
                           neg_f1_=match_fT_[2],
                           _f0_=32;
                          if(p_fV_===_fW_&&0===_fX_)
                           {var _fY_=x_fq_,_fZ_=1;}
                          else
                           var _fZ_=0;
                          if(!_fZ_)
                           if(p_fV_<=_fW_)
                            var _fY_=_b8_(x_fq_,_fX_,_fW_);
                           else
                            {var res_f2_=_b7_(p_fV_,_f0_);
                             if(neg_f1_)
                              _b9_(x_fq_,_fX_,res_f2_,0,_fW_);
                             else
                              _b9_(x_fq_,_fX_,res_f2_,p_fV_-_fW_|0,_fW_);
                             var _fY_=res_f2_;}
                          var s_fJ_=_fY_;}
                        var
                         _e$_=
                          cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_fJ_,i_eS_+1|0),
                         _e6_=1;
                        break;
                       case 67:
                       case 99:
                        var x_f3_=get_arg_eU_(spec_e2_,n_eV_);
                        if(99===_e5_)
                         var s_f4_=_b7_(1,x_f3_);
                        else
                         {if(39===x_f3_)
                           var _f5_=_a__;
                          else
                           if(92===x_f3_)
                            var _f5_=_a$_;
                           else
                            {if(14<=x_f3_)
                              var _f6_=0;
                             else
                              switch(x_f3_)
                               {case 8:var _f5_=_bd_,_f6_=1;break;
                                case 9:var _f5_=_bc_,_f6_=1;break;
                                case 10:var _f5_=_bb_,_f6_=1;break;
                                case 13:var _f5_=_ba_,_f6_=1;break;
                                default:var _f6_=0;}
                             if(!_f6_)
                              if(caml_is_printable(x_f3_))
                               {var s_f7_=caml_create_string(1);
                                s_f7_.safeSet(0,x_f3_);
                                var _f5_=s_f7_;}
                              else
                               {var s_f8_=caml_create_string(4);
                                s_f8_.safeSet(0,92);
                                s_f8_.safeSet(1,48+(x_f3_/100|0)|0);
                                s_f8_.safeSet(2,48+((x_f3_/10|0)%10|0)|0);
                                s_f8_.safeSet(3,48+(x_f3_%10|0)|0);
                                var _f5_=s_f8_;}}
                          var s_f4_=_bv_(_aY_,_bv_(_f5_,_aZ_));}
                        var
                         _e$_=
                          cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_f4_,i_eS_+1|0),
                         _e6_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _f__=i_eS_+1|0,
                         _f9_=get_arg_eU_(spec_e2_,n_eV_)?_bg_:_bf_,
                         _e$_=cont_s_e__(next_index_eY_(spec_e2_,n_eV_),_f9_,_f__),
                         _e6_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_f$_=get_arg_eU_(spec_e2_,n_eV_),
                         i_ga_=_dz_(sub_format_for_printf_d7_,_e5_,fmt_eH_,i_eS_+1|0);
                        if(123===_e5_)
                         {var
                           b_gb_=_cr_(xf_f$_.getLen()),
                           add_char_gf_=
                            function(i_gd_,c_gc_){_cw_(b_gb_,c_gc_);return i_gd_+1|0;};
                          iter_on_format_args_el_
                           (xf_f$_,
                            function(skip_ge_,i_gh_,c_gg_)
                             {if(skip_ge_)_cx_(b_gb_,_aS_);else _cw_(b_gb_,37);
                              return add_char_gf_(i_gh_,c_gg_);},
                            add_char_gf_);
                          var
                           _gi_=_cv_(b_gb_),
                           _e$_=cont_s_e__(next_index_eY_(spec_e2_,n_eV_),_gi_,i_ga_),
                           _e6_=1;}
                        else
                         {var
                           _gj_=next_index_eY_(spec_e2_,n_eV_),
                           m_gm_=
                            add_int_index_cC_
                             (count_printing_arguments_of_format_gk_(xf_f$_),_gj_),
                           _e$_=
                            pr_go_
                             (function(param_gn_){return doprn_gl_(m_gm_,i_ga_);},
                              _gj_,
                              xf_f$_,
                              v_eQ_),
                           _e6_=1;}
                        break;
                       case 33:
                        _bN_(flush_gp_,out_eE_);
                        var _e$_=doprn_gl_(n_eV_,i_eS_+1|0),_e6_=1;
                        break;
                       case 41:
                        var _e$_=cont_s_e__(n_eV_,_a4_,i_eS_+1|0),_e6_=1;break;
                       case 44:
                        var _e$_=cont_s_e__(n_eV_,_a3_,i_eS_+1|0),_e6_=1;break;
                       case 70:
                        var x_gq_=get_arg_eU_(spec_e2_,n_eV_);
                        if(0===widths_eX_)
                         var _gr_=_a2_;
                        else
                         {var
                           sfmt_gs_=
                            extract_format_db_(fmt_eH_,i_eJ_,i_eS_,widths_eX_);
                          if(70===_e5_)sfmt_gs_.safeSet(sfmt_gs_.getLen()-1|0,103);
                          var _gr_=sfmt_gs_;}
                        var _gt_=caml_classify_float(x_gq_);
                        if(3===_gt_)
                         var s_gu_=x_gq_<0?_aW_:_aV_;
                        else
                         if(4<=_gt_)
                          var s_gu_=_aX_;
                         else
                          {var
                            _gv_=caml_format_float(_gr_,x_gq_),
                            i_gw_=0,
                            l_gx_=_gv_.getLen();
                           for(;;)
                            {if(l_gx_<=i_gw_)
                              var _gy_=_bv_(_gv_,_aU_);
                             else
                              {var
                                _gz_=_gv_.safeGet(i_gw_)-46|0,
                                _gA_=
                                 _gz_<0||23<_gz_
                                  ?55===_gz_?1:0
                                  :(_gz_-1|0)<0||21<(_gz_-1|0)?1:0;
                               if(!_gA_){var _gB_=i_gw_+1|0,i_gw_=_gB_;continue;}
                               var _gy_=_gv_;}
                             var s_gu_=_gy_;
                             break;}}
                        var
                         _e$_=
                          cont_s_e__(next_index_eY_(spec_e2_,n_eV_),s_gu_,i_eS_+1|0),
                         _e6_=1;
                        break;
                       case 91:
                        var
                         _e$_=bad_conversion_format_dF_(fmt_eH_,i_eS_,_e5_),
                         _e6_=1;
                        break;
                       case 97:
                        var
                         printer_gC_=get_arg_eU_(spec_e2_,n_eV_),
                         n_gD_=_bN_(_cD_,get_index_eN_(spec_e2_,n_eV_)),
                         arg_gE_=get_arg_eU_(0,n_gD_),
                         _gI_=i_eS_+1|0,
                         _gH_=next_index_eY_(spec_e2_,n_gD_);
                        if(to_s_gF_)
                         outs_gG_(_d4_(printer_gC_,0,arg_gE_));
                        else
                         _d4_(printer_gC_,out_eE_,arg_gE_);
                        var _e$_=doprn_gl_(_gH_,_gI_),_e6_=1;
                        break;
                       case 114:
                        var
                         _e$_=bad_conversion_format_dF_(fmt_eH_,i_eS_,_e5_),
                         _e6_=1;
                        break;
                       case 116:
                        var
                         printer_gJ_=get_arg_eU_(spec_e2_,n_eV_),
                         _gL_=i_eS_+1|0,
                         _gK_=next_index_eY_(spec_e2_,n_eV_);
                        if(to_s_gF_)
                         outs_gG_(_bN_(printer_gJ_,0));
                        else
                         _bN_(printer_gJ_,out_eE_);
                        var _e$_=doprn_gl_(_gK_,_gL_),_e6_=1;
                        break;
                       default:var _e6_=0;}
                    if(!_e6_)
                     var _e$_=bad_conversion_format_dF_(fmt_eH_,i_eS_,_e5_);
                    return _e$_;}},
               _gQ_=i_eJ_+1|0,
               _gN_=0;
              return scan_positional_spec_e3_
                      (fmt_eH_,
                       function(spec_gP_,i_gM_)
                        {return scan_flags_e0_(spec_gP_,n_gO_,_gN_,i_gM_);},
                       _gQ_);}
            _d4_(outc_gR_,out_eE_,_eM_);
            var _gS_=i_eJ_+1|0,i_eJ_=_gS_;
            continue;}}
        function cont_s_e__(n_gV_,s_gT_,i_gU_)
         {outs_gG_(s_gT_);return doprn_gl_(n_gV_,i_gU_);}
        return doprn_gl_(n_gW_,0);}
      var
       kpr_gY_=_d4_(pr_go_,k_gX_,index_of_int_cB_(0)),
       _gZ_=count_printing_arguments_of_format_gk_(fmt_eC_);
      if(_gZ_<0||6<_gZ_)
       {var
         loop_ha_=
          function(i_g0_,args_g6_)
           {if(_gZ_<=i_g0_)
             {var
               a_g1_=caml_make_vect(_gZ_,0),
               _g4_=
                function(i_g2_,arg_g3_)
                 {return caml_array_set(a_g1_,(_gZ_-i_g2_|0)-1|0,arg_g3_);},
               i_g5_=0,
               param_g7_=args_g6_;
              for(;;)
               {if(param_g7_)
                 {var _g8_=param_g7_[2],_g9_=param_g7_[1];
                  if(_g8_)
                   {_g4_(i_g5_,_g9_);
                    var _g__=i_g5_+1|0,i_g5_=_g__,param_g7_=_g8_;
                    continue;}
                  _g4_(i_g5_,_g9_);}
                return _d4_(kpr_gY_,fmt_eC_,a_g1_);}}
            return function(x_g$_)
             {return loop_ha_(i_g0_+1|0,[0,x_g$_,args_g6_]);};},
         _hb_=loop_ha_(0,0);}
      else
       switch(_gZ_)
        {case 1:
          var
           _hb_=
            function(x_hd_)
             {var a_hc_=caml_make_vect(1,0);
              caml_array_set(a_hc_,0,x_hd_);
              return _d4_(kpr_gY_,fmt_eC_,a_hc_);};
          break;
         case 2:
          var
           _hb_=
            function(x_hf_,y_hg_)
             {var a_he_=caml_make_vect(2,0);
              caml_array_set(a_he_,0,x_hf_);
              caml_array_set(a_he_,1,y_hg_);
              return _d4_(kpr_gY_,fmt_eC_,a_he_);};
          break;
         case 3:
          var
           _hb_=
            function(x_hi_,y_hj_,z_hk_)
             {var a_hh_=caml_make_vect(3,0);
              caml_array_set(a_hh_,0,x_hi_);
              caml_array_set(a_hh_,1,y_hj_);
              caml_array_set(a_hh_,2,z_hk_);
              return _d4_(kpr_gY_,fmt_eC_,a_hh_);};
          break;
         case 4:
          var
           _hb_=
            function(x_hm_,y_hn_,z_ho_,t_hp_)
             {var a_hl_=caml_make_vect(4,0);
              caml_array_set(a_hl_,0,x_hm_);
              caml_array_set(a_hl_,1,y_hn_);
              caml_array_set(a_hl_,2,z_ho_);
              caml_array_set(a_hl_,3,t_hp_);
              return _d4_(kpr_gY_,fmt_eC_,a_hl_);};
          break;
         case 5:
          var
           _hb_=
            function(x_hr_,y_hs_,z_ht_,t_hu_,u_hv_)
             {var a_hq_=caml_make_vect(5,0);
              caml_array_set(a_hq_,0,x_hr_);
              caml_array_set(a_hq_,1,y_hs_);
              caml_array_set(a_hq_,2,z_ht_);
              caml_array_set(a_hq_,3,t_hu_);
              caml_array_set(a_hq_,4,u_hv_);
              return _d4_(kpr_gY_,fmt_eC_,a_hq_);};
          break;
         case 6:
          var
           _hb_=
            function(x_hx_,y_hy_,z_hz_,t_hA_,u_hB_,v_hC_)
             {var a_hw_=caml_make_vect(6,0);
              caml_array_set(a_hw_,0,x_hx_);
              caml_array_set(a_hw_,1,y_hy_);
              caml_array_set(a_hw_,2,z_hz_);
              caml_array_set(a_hw_,3,t_hA_);
              caml_array_set(a_hw_,4,u_hB_);
              caml_array_set(a_hw_,5,v_hC_);
              return _d4_(kpr_gY_,fmt_eC_,a_hw_);};
          break;
         default:var _hb_=_d4_(kpr_gY_,fmt_eC_,[0]);}
      return _hb_;}
    function _hV_(oc_hE_)
     {function _hG_(_hD_){return 0;}
      return _hI_
              (_hH_,
               0,
               function(param_hF_){return oc_hE_;},
               _bJ_,
               output_string_bF_,
               _bU_,
               _hG_);}
    function _hR_(fmt_hJ_){return _cr_(2*fmt_hJ_.getLen()|0);}
    function _hO_(k_hM_,b_hK_)
     {var s_hL_=_cv_(b_hK_);b_hK_[2]=0;return _bN_(k_hM_,s_hL_);}
    function _hU_(k_hN_)
     {var _hQ_=_bN_(_hO_,k_hN_);
      return _hI_(_hH_,1,_hR_,_cw_,_cx_,function(_hP_){return 0;},_hQ_);}
    function _hW_(fmt_hT_)
     {return _d4_(_hU_,function(s_hS_){return s_hS_;},fmt_hT_);}
    var _hX_=[0,0];
    function _h$_(x_hY_,i_hZ_)
     {var f_h0_=x_hY_[i_hZ_+1];
      if(caml_obj_is_block(f_h0_))
       {if(caml_obj_tag(f_h0_)===_cu_)return _d4_(_hW_,_aq_,f_h0_);
        if(caml_obj_tag(f_h0_)===_ct_)
         {var _h1_=caml_format_float(_bj_,f_h0_),i_h2_=0,l_h3_=_h1_.getLen();
          for(;;)
           {if(l_h3_<=i_h2_)
             var _h4_=_bv_(_h1_,_bi_);
            else
             {var
               _h5_=_h1_.safeGet(i_h2_),
               _h6_=48<=_h5_?58<=_h5_?0:1:45===_h5_?1:0;
              if(_h6_){var _h7_=i_h2_+1|0,i_h2_=_h7_;continue;}
              var _h4_=_h1_;}
            return _h4_;}}
        return _ap_;}
      return _d4_(_hW_,_ar_,f_h0_);}
    function _h__(x_h8_,i_h9_)
     {if(x_h8_.length-1<=i_h9_)return _aJ_;
      var _ia_=_h__(x_h8_,i_h9_+1|0);
      return _dz_(_hW_,_aI_,_h$_(x_h8_,i_h9_),_ia_);}
    32===_b__;
    try
     {var _ib_=caml_sys_getenv(_ao_),params_ic_=_ib_;}
    catch(_id_)
     {if(_id_[1]!==_c_)throw _id_;
      try
       {var _ie_=caml_sys_getenv(_an_),_if_=_ie_;}
      catch(_ig_){if(_ig_[1]!==_c_)throw _ig_;var _if_=_am_;}
      var params_ic_=_if_;}
    var _ih_=0,l_ii_=params_ic_.getLen(),_il_=82;
    if(0<=_ih_&&!(l_ii_<_ih_))
     try
      {var i_ik_=_ih_;
       for(;;)
        {if(l_ii_<=i_ik_)throw [0,_c_];
         if(params_ic_.safeGet(i_ik_)!==_il_)
          {var _im_=i_ik_+1|0,i_ik_=_im_;continue;}
         var _ij_=1;
         break;}}
     catch(_in_){if(_in_[1]!==_c_)throw _in_;var _ij_=1;}
    else
     var _ij_=0;
    if(!_ij_)_bo_(_a9_);
    function _iq_(param_ip_)
     {var seq_io_=[];
      caml_update_dummy(seq_io_,[0,seq_io_,seq_io_]);
      return seq_io_;}
    var Canceled_ir_=[0,_ae_],current_data_is_=[0,0],max_removed_ju_=42;
    function repr_rec_iw_(t_it_)
     {var _iu_=t_it_[1];
      {if(3===_iu_[0])
        {var t__iv_=_iu_[1],t___ix_=repr_rec_iw_(t__iv_);
         if(t___ix_!==t__iv_)t_it_[1]=[3,t___ix_];
         return t___ix_;}
       return t_it_;}}
    function repr_jv_(t_iy_){return repr_rec_iw_(t_iy_);}
    function _i3_(exn_iA_)
     {var param_iz_=_hX_[1];
      for(;;)
       {if(param_iz_)
         {var tl_iE_=param_iz_[2],hd_iB_=param_iz_[1];
          try
           {var _iC_=_bN_(hd_iB_,exn_iA_),_iD_=_iC_;}
          catch(_iF_){var _iD_=0;}
          if(!_iD_){var param_iz_=tl_iE_;continue;}}
        else
         if(exn_iA_[1]!==_bn_&&exn_iA_[1]!==_bl_)
          if(exn_iA_[1]===_bm_)
           {var match_iG_=exn_iA_[2],char_iH_=match_iG_[3];
            _hI_
             (_hW_,_e_,match_iG_[1],match_iG_[2],char_iH_,char_iH_+5|0,_ay_);}
          else
           if(exn_iA_[1]===_d_)
            {var match_iI_=exn_iA_[2],char_iJ_=match_iI_[3];
             _hI_
              (_hW_,_e_,match_iI_[1],match_iI_[2],char_iJ_,char_iJ_+6|0,_ax_);}
           else
            if(exn_iA_[1]===_bk_)
             {var match_iK_=exn_iA_[2],char_iL_=match_iK_[3];
              _hI_
               (_hW_,_e_,match_iK_[1],match_iK_[2],char_iL_,char_iL_+6|0,_aw_);}
            else
             {var _iM_=exn_iA_.length-1,constructor_iP_=exn_iA_[0+1][0+1];
              if(_iM_<0||2<_iM_)
               {var
                 _iN_=_h__(exn_iA_,2),
                 _iO_=_dz_(_hW_,_av_,_h$_(exn_iA_,1),_iN_);}
              else
               switch(_iM_)
                {case 1:var _iO_=_at_;break;
                 case 2:var _iO_=_d4_(_hW_,_as_,_h$_(exn_iA_,1));break;
                 default:var _iO_=_au_;}
              _bv_(constructor_iP_,_iO_);}
        caml_ml_output_char(stderr_bx_,10);
        var
         _iQ_=
          caml_convert_raw_backtrace(caml_get_exception_raw_backtrace(0));
        if(_iQ_)
         {var a_iR_=_iQ_[1],_iS_=0,_iT_=a_iR_.length-1-1|0;
          if(!(_iT_<_iS_))
           {var i_iU_=_iS_;
            for(;;)
             {if(caml_notequal(caml_array_get(a_iR_,i_iU_),_aH_))
               {var
                 _iV_=caml_array_get(a_iR_,i_iU_),
                 is_raise_iW_=0===_iV_[0]?_iV_[1]:_iV_[1],
                 info_iX_=is_raise_iW_?0===i_iU_?_aE_:_aD_:0===i_iU_?_aC_:_aB_,
                 _iY_=
                  0===_iV_[0]
                   ?_hI_(_hW_,_aA_,info_iX_,_iV_[2],_iV_[3],_iV_[4],_iV_[5])
                   :_d4_(_hW_,_az_,info_iX_);
                _dz_(_hV_,stderr_bx_,_aG_,_iY_);}
              var _iZ_=i_iU_+1|0;
              if(_iT_!==i_iU_){var i_iU_=_iZ_;continue;}
              break;}}}
        else
         _d4_(_hV_,stderr_bx_,_aF_);
        do_at_exit_bE_(0);
        return caml_sys_exit(2);}}
    function call_unsafe_jo_(f_i1_,x_i0_)
     {try {var _i2_=_bN_(f_i1_,x_i0_);}catch(_i4_){return _i3_(_i4_);}
      return _i2_;}
    function run_waiters_rec_jd_(state_i9_,ws_i5_,rem_i7_)
     {var ws_i6_=ws_i5_,rem_i8_=rem_i7_;
      for(;;)
       if(typeof ws_i6_==="number")
        return run_waiters_rec_next_i__(state_i9_,rem_i8_);
       else
        switch(ws_i6_[0])
         {case 1:
           _bN_(ws_i6_[1],state_i9_);
           return run_waiters_rec_next_i__(state_i9_,rem_i8_);
          case 2:
           var
            ws1_i$_=ws_i6_[1],
            _ja_=[0,ws_i6_[2],rem_i8_],
            ws_i6_=ws1_i$_,
            rem_i8_=_ja_;
           continue;
          default:
           var _jb_=ws_i6_[1][1];
           return _jb_
                   ?(_bN_(_jb_[1],state_i9_),
                     run_waiters_rec_next_i__(state_i9_,rem_i8_))
                   :run_waiters_rec_next_i__(state_i9_,rem_i8_);}}
    function run_waiters_rec_next_i__(state_je_,rem_jc_)
     {return rem_jc_?run_waiters_rec_jd_(state_je_,rem_jc_[1],rem_jc_[2]):0;}
    function run_cancel_handlers_rec_jq_(chs_jf_,rem_jh_)
     {var chs_jg_=chs_jf_,rem_ji_=rem_jh_;
      for(;;)
       if(typeof chs_jg_==="number")
        return run_cancel_handlers_rec_next_jk_(rem_ji_);
       else
        switch(chs_jg_[0])
         {case 1:
           var n_jj_=chs_jg_[1];
           if(n_jj_[4]){n_jj_[4]=0;n_jj_[1][2]=n_jj_[2];n_jj_[2][1]=n_jj_[1];}
           return run_cancel_handlers_rec_next_jk_(rem_ji_);
          case 2:
           var
            chs1_jl_=chs_jg_[1],
            _jm_=[0,chs_jg_[2],rem_ji_],
            chs_jg_=chs1_jl_,
            rem_ji_=_jm_;
           continue;
          default:
           var f_jn_=chs_jg_[2];
           current_data_is_[1]=chs_jg_[1];
           call_unsafe_jo_(f_jn_,0);
           return run_cancel_handlers_rec_next_jk_(rem_ji_);}}
    function run_cancel_handlers_rec_next_jk_(rem_jp_)
     {return rem_jp_?run_cancel_handlers_rec_jq_(rem_jp_[1],rem_jp_[2]):0;}
    function unsafe_run_waiters_jw_(sleeper_js_,state_jr_)
     {var
       _jt_=
        1===state_jr_[0]
         ?state_jr_[1][1]===Canceled_ir_
           ?(run_cancel_handlers_rec_jq_(sleeper_js_[4],0),1)
           :0
         :0;
      _jt_;
      return run_waiters_rec_jd_(state_jr_,sleeper_js_[2],0);}
    var wakening_jx_=[0,0],_jy_=[0,0,0];
    function wakeup_ks_(t_jB_,v_jz_)
     {var _jA_=[0,v_jz_],t_jC_=repr_rec_iw_(t_jB_),_jD_=t_jC_[1];
      switch(_jD_[0])
       {case 1:
         if(_jD_[1][1]===Canceled_ir_){var _jE_=0,_jF_=1;}else var _jF_=0;
         break;
        case 2:
         var sleeper_jG_=_jD_[1];
         t_jC_[1]=_jA_;
         var
          snapshot_jH_=current_data_is_[1],
          already_wakening_jI_=wakening_jx_[1]?1:(wakening_jx_[1]=1,0);
         unsafe_run_waiters_jw_(sleeper_jG_,_jA_);
         if(already_wakening_jI_)
          {current_data_is_[1]=snapshot_jH_;var _jJ_=0;}
         else
          for(;;)
           {if(0!==_jy_[1])
             {if(0===_jy_[1])throw [0,_cs_];
              _jy_[1]=_jy_[1]-1|0;
              var tail_jK_=_jy_[2],head_jL_=tail_jK_[2];
              if(head_jL_===tail_jK_)_jy_[2]=0;else tail_jK_[2]=head_jL_[2];
              var _jM_=head_jL_[1];
              unsafe_run_waiters_jw_(_jM_[1],_jM_[2]);
              continue;}
            wakening_jx_[1]=0;
            current_data_is_[1]=snapshot_jH_;
            var _jJ_=0;
            break;}
         var _jE_=_jJ_,_jF_=1;
         break;
        default:var _jF_=0;}
      if(!_jF_)var _jE_=_bo_(_af_);
      return _jE_;}
    function append_jT_(l1_jN_,l2_jO_)
     {return typeof l1_jN_==="number"
              ?l2_jO_
              :typeof l2_jO_==="number"?l1_jN_:[2,l1_jN_,l2_jO_];}
    function cleanup_jQ_(ws_jP_)
     {if(typeof ws_jP_!=="number")
       switch(ws_jP_[0])
        {case 2:
          var l1_jR_=ws_jP_[1],_jS_=cleanup_jQ_(ws_jP_[2]);
          return append_jT_(cleanup_jQ_(l1_jR_),_jS_);
         case 1:break;
         default:if(!ws_jP_[1][1])return 0;}
      return ws_jP_;}
    function task_kt_(param_jV_)
     {var _jU_=[0,[2,[0,1,0,0,0]]];return [0,_jU_,_jU_];}
    function add_immutable_waiter_kq_(sleeper_jY_,waiter_jW_)
     {var
       _jX_=[1,waiter_jW_],
       _jZ_=sleeper_jY_[2],
       _j0_=typeof _jZ_==="number"?_jX_:[2,_jX_,_jZ_];
      sleeper_jY_[2]=_j0_;
      return 0;}
    function bind_ku_(t_j1_,f_j8_)
     {var t_j2_=repr_jv_(t_j1_),_j3_=t_j2_[1];
      switch(_j3_[0])
       {case 1:return [0,_j3_];
        case 2:
         var
          _j4_=[0,[2,[0,[0,[0,t_j2_]],0,0,0]]],
          sleeper_kp_=_j3_[1],
          data_j6_=current_data_is_[1];
         add_immutable_waiter_kq_
          (sleeper_kp_,
           function(state_j5_)
            {switch(state_j5_[0])
              {case 0:
                var v_j7_=state_j5_[1];
                current_data_is_[1]=data_j6_;
                try
                 {var _j9_=_bN_(f_j8_,v_j7_),_j__=_j9_;}
                catch(_j$_){var _j__=[0,[1,_j$_]];}
                var
                 t1_ka_=repr_jv_(_j4_),
                 t2_kb_=repr_jv_(_j__),
                 _kc_=t1_ka_[1];
                {if(2===_kc_[0])
                  {var sleeper1_kd_=_kc_[1];
                   if(t1_ka_===t2_kb_)
                    var _ke_=0;
                   else
                    {var _kf_=t2_kb_[1];
                     if(2===_kf_[0])
                      {var sleeper2_kg_=_kf_[1];
                       t2_kb_[1]=[3,t1_ka_];
                       sleeper1_kd_[1]=sleeper2_kg_[1];
                       var
                        waiters_kh_=append_jT_(sleeper1_kd_[2],sleeper2_kg_[2]),
                        removed_ki_=sleeper1_kd_[3]+sleeper2_kg_[3]|0;
                       if(max_removed_ju_<removed_ki_)
                        {sleeper1_kd_[3]=0;
                         sleeper1_kd_[2]=cleanup_jQ_(waiters_kh_);}
                       else
                        {sleeper1_kd_[3]=removed_ki_;sleeper1_kd_[2]=waiters_kh_;}
                       var
                        _kj_=sleeper2_kg_[4],
                        _kk_=sleeper1_kd_[4],
                        _kl_=
                         typeof _kk_==="number"
                          ?_kj_
                          :typeof _kj_==="number"?_kk_:[2,_kk_,_kj_];
                       sleeper1_kd_[4]=_kl_;
                       var _ke_=0;}
                     else
                      {t1_ka_[1]=_kf_;
                       var _ke_=unsafe_run_waiters_jw_(sleeper1_kd_,_kf_);}}
                   return _ke_;}
                 throw [0,_d_,_ag_];}
               case 1:
                var t_km_=repr_jv_(_j4_),_kn_=t_km_[1];
                {if(2===_kn_[0])
                  {var sleeper_ko_=_kn_[1];
                   t_km_[1]=state_j5_;
                   return unsafe_run_waiters_jw_(sleeper_ko_,state_j5_);}
                 throw [0,_d_,_ah_];}
               default:throw [0,_d_,_aj_];}});
         return _j4_;
        case 3:throw [0,_d_,_ai_];
        default:return _bN_(f_j8_,_j3_[1]);}}
    var
     pause_hook_kw_=[0,function(_kr_){return 0;}],
     _kv_=_iq_(0),
     _kz_=[0,0],
     null_kE_=null,
     undefined_kF_=undefined,
     _true_kG_=true,
     _false_kH_=false,
     array_constructor_kI_=Array,
     date_constr_kJ_=Date;
    function _kL_(param_kD_)
     {var _kx_=1-(_kv_[2]===_kv_?1:0);
      if(_kx_)
       {var tmp_ky_=_iq_(0);
        tmp_ky_[1][2]=_kv_[2];
        _kv_[2][1]=tmp_ky_[1];
        tmp_ky_[1]=_kv_[1];
        _kv_[1][2]=tmp_ky_;
        _kv_[1]=_kv_;
        _kv_[2]=_kv_;
        _kz_[1]=0;
        var curr_kA_=tmp_ky_[2];
        for(;;)
         {var _kB_=curr_kA_!==tmp_ky_?1:0;
          if(_kB_)
           {if(curr_kA_[4])wakeup_ks_(curr_kA_[3],0);
            var _kC_=curr_kA_[2],curr_kA_=_kC_;
            continue;}
          return _kB_;}}
      return _kx_;}
    function _kM_(e_kK_)
     {return e_kK_ instanceof array_constructor_kI_
              ?0
              :[0,new MlWrappedString(e_kK_.toString())];}
    _hX_[1]=[0,_kM_,_hX_[1]];
    function _kO_(_kN_){return _kN_;}
    function _k$_(p_kP_,n_kQ_){p_kP_.appendChild(n_kQ_);return 0;}
    function _la_(f_kS_)
     {return _kO_
              (caml_js_wrap_callback
                (function(e_kR_)
                  {if(e_kR_)
                    {var res_kT_=_bN_(f_kS_,e_kR_);
                     if(!(res_kT_|0))e_kR_.preventDefault();
                     return res_kT_;}
                   var _kU_=event,res_kV_=_bN_(f_kS_,_kU_);
                   _kU_.returnValue=res_kV_;
                   return res_kV_;}));}
    function _lb_(s_kW_){return s_kW_.toString();}
    function _lc_(e_kX_,typ_kY_,h_k1_,capt_k8_)
     {if(e_kX_.addEventListener===undefined_kF_)
       {var
         ev_kZ_=_ad_.toString().concat(typ_kY_),
         callback_k6_=
          function(e_k0_)
           {var _k5_=[0,h_k1_,e_k0_,[0]];
            return _bN_
                    (function(_k4_,_k3_,_k2_)
                      {return caml_js_call(_k4_,_k3_,_k2_);},
                     _k5_);};
        e_kX_.attachEvent(ev_kZ_,callback_k6_);
        return function(param_k7_)
         {return e_kX_.detachEvent(ev_kZ_,callback_k6_);};}
      e_kX_.addEventListener(typ_kY_,h_k1_,capt_k8_);
      return function(param_k9_)
       {return e_kX_.removeEventListener(typ_kY_,h_k1_,capt_k8_);};}
    function _ld_(id_k__){return _bN_(id_k__,0);}
    var
     mouseup_le_=_lb_(_L_),
     mousemove_lg_=_lb_(_K_),
     _2d__lf_=_J_.toString(),
     window_lh_=this,
     document_li_=window_lh_.document;
    function opt_iter_lq_(x_lj_,f_lk_){return x_lj_?_bN_(f_lk_,x_lj_[1]):0;}
    function createElement_ln_(doc_lm_,name_ll_)
     {return doc_lm_.createElement(name_ll_.toString());}
    function unsafeCreateElement_lr_(doc_lp_,name_lo_)
     {return createElement_ln_(doc_lp_,name_lo_);}
    var createElementSyntax_ls_=[0,785140586];
    function unsafeCreateElementEx_lL_(_type_lt_,name_lu_,doc_lw_,elt_lv_)
     {for(;;)
       {if(0===_type_lt_&&0===name_lu_)
         return createElement_ln_(doc_lw_,elt_lv_);
        var _lx_=createElementSyntax_ls_[1];
        if(785140586===_lx_)
         {try
           {var
             el_ly_=document_li_.createElement(_X_.toString()),
             _lz_=_W_.toString(),
             _lA_=el_ly_.tagName.toLowerCase()===_lz_?1:0,
             _lB_=_lA_?el_ly_.name===_V_.toString()?1:0:_lA_,
             _lC_=_lB_;}
          catch(_lE_){var _lC_=0;}
          var _lD_=_lC_?982028505:-1003883683;
          createElementSyntax_ls_[1]=_lD_;
          continue;}
        if(982028505<=_lx_)
         {var a_lF_=new array_constructor_kI_();
          a_lF_.push(___.toString(),elt_lv_.toString());
          opt_iter_lq_
           (_type_lt_,
            function(t_lG_)
             {a_lF_.push
               (_$_.toString(),caml_js_html_escape(t_lG_),_aa_.toString());
              return 0;});
          opt_iter_lq_
           (name_lu_,
            function(n_lH_)
             {a_lF_.push
               (_ab_.toString(),caml_js_html_escape(n_lH_),_ac_.toString());
              return 0;});
          a_lF_.push(_Z_.toString());
          return doc_lw_.createElement(a_lF_.join(_Y_.toString()));}
        var res_lI_=createElement_ln_(doc_lw_,elt_lv_);
        opt_iter_lq_(_type_lt_,function(t_lJ_){return res_lI_.type=t_lJ_;});
        opt_iter_lq_(name_lu_,function(n_lK_){return res_lI_.name=n_lK_;});
        return res_lI_;}}
    function createInput_lR_(_type_lO_,name_lN_,doc_lM_)
     {return unsafeCreateElementEx_lL_(_type_lO_,name_lN_,doc_lM_,_O_);}
    function createLabel_lS_(doc_lP_)
     {return unsafeCreateElement_lr_(doc_lP_,_P_);}
    function createDiv_lT_(doc_lQ_)
     {return unsafeCreateElement_lr_(doc_lQ_,_Q_);}
    var Canvas_not_available_lU_=[0,_I_];
    this.HTMLElement===undefined_kF_;
    pause_hook_kw_[1]=
    function(param_lV_)
     {return 1===param_lV_
              ?(window_lh_.setTimeout(caml_js_wrap_callback(_kL_),0),0)
              :0;};
    var
     width_lW_=600,
     pi_lX_=4*Math.atan(1),
     obliquity_lY_=23.5*pi_lX_/180,
     gamma_lZ_=2,
     dark_l0_=Math.pow(0.2,gamma_lZ_),
     button_type_l1_=_k_.toString();
    function toggle_button_mO_(txt1_l3_,txt2_l5_,action_l9_)
     {var
       state_l2_=[0,0],
       txt1_l4_=txt1_l3_.toString(),
       txt2_l7_=txt2_l5_.toString(),
       b_l6_=createInput_lR_([0,button_type_l1_],0,document_li_);
      b_l6_.value=txt1_l4_;
      b_l6_.onclick=
      _la_
       (function(param_l__)
         {state_l2_[1]=1-state_l2_[1];
          var _l8_=state_l2_[1]?txt2_l7_:txt1_l4_;
          b_l6_.value=_l8_;
          _bN_(action_l9_,state_l2_[1]);
          return _true_kG_;});
      return b_l6_;}
    function checkbox_mP_(txt_me_,checked_ma_,action_mb_)
     {var b_l$_=createInput_lR_([0,_l_.toString()],0,document_li_);
      b_l$_.checked=!!checked_ma_;
      b_l$_.onclick=
      _la_
       (function(param_mc_)
         {_bN_(action_mb_,b_l$_.checked|0);return _true_kG_;});
      var lab_md_=createLabel_lS_(document_li_);
      _k$_(lab_md_,b_l$_);
      _k$_(lab_md_,document_li_.createTextNode(txt_me_.toString()));
      return lab_md_;}
    function vertex_mG_(x_mh_,y_mg_,z_mf_){return [254,x_mh_,y_mg_,z_mf_];}
    function vect_mQ_(param_mj_,_mi_)
     {return [254,
              _mi_[1]-param_mj_[1],
              _mi_[2]-param_mj_[2],
              _mi_[3]-param_mj_[3]];}
    function matrix_vect_mul_mA_(m_mo_,param_mk_)
     {var
       z_ml_=param_mk_[3],
       y_mm_=param_mk_[2],
       x_mn_=param_mk_[1],
       r3_mp_=m_mo_[3],
       r2_mq_=m_mo_[2],
       r1_mr_=m_mo_[1];
      return [254,
              x_mn_*r1_mr_[1]+y_mm_*r1_mr_[2]+z_ml_*r1_mr_[3],
              x_mn_*r2_mq_[1]+y_mm_*r2_mq_[2]+z_ml_*r2_mq_[3],
              x_mn_*r3_mp_[1]+y_mm_*r3_mp_[2]+z_ml_*r3_mp_[3]];}
    function matrix_transp_mw_(m_ms_)
     {var r3_mt_=m_ms_[3],r2_mu_=m_ms_[2],r1_mv_=m_ms_[1];
      return [0,
              [254,r1_mv_[1],r2_mu_[1],r3_mt_[1]],
              [254,r1_mv_[2],r2_mu_[2],r3_mt_[2]],
              [254,r1_mv_[3],r2_mu_[3],r3_mt_[3]]];}
    function matrix_mul_mR_(m_mz_,m__mx_)
     {var
       m__my_=matrix_transp_mw_(m__mx_),
       _mB_=matrix_vect_mul_mA_(m__my_,m_mz_[3]),
       _mC_=matrix_vect_mul_mA_(m__my_,m_mz_[2]);
      return [0,matrix_vect_mul_mA_(m__my_,m_mz_[1]),_mC_,_mB_];}
    function xz_rotation_mS_(phi_mD_)
     {var
       cos_phi_mE_=Math.cos(phi_mD_),
       sin_phi_mF_=Math.sin(phi_mD_),
       _mH_=vertex_mG_(-sin_phi_mF_,0,cos_phi_mE_),
       _mI_=vertex_mG_(0,1,0);
      return [0,vertex_mG_(cos_phi_mE_,0,sin_phi_mF_),_mI_,_mH_];}
    function xy_rotation_mT_(phi_mJ_)
     {var
       cos_phi_mK_=Math.cos(phi_mJ_),
       sin_phi_mL_=Math.sin(phi_mJ_),
       _mM_=vertex_mG_(0,0,1),
       _mN_=vertex_mG_(-sin_phi_mL_,cos_phi_mK_,0);
      return [0,vertex_mG_(cos_phi_mK_,sin_phi_mL_,0),_mN_,_mM_];}
    var matrix_identity_mU_=xz_rotation_mS_(0);
    function face_m5_(v1_mX_,v2_mW_,v3_mV_){return [0,v1_mX_,v2_mW_,v3_mV_];}
    function create_canvas_m6_(w_mZ_,h_m0_)
     {var c_mY_=unsafeCreateElement_lr_(document_li_,_U_);
      if(1-(c_mY_.getContext==null_kE_?1:0))
       {c_mY_.width=w_mZ_;c_mY_.height=h_m0_;return c_mY_;}
      throw [0,Canvas_not_available_lU_];}
    function min_m7_(u_m1_,v_m2_){return u_m1_<v_m2_?u_m1_:v_m2_;}
    function max_m8_(u_m3_,v_m4_){return u_m3_<v_m4_?v_m4_:u_m3_;}
    var
     _m9_=8,
     _m__=12,
     t_delta_m$_=pi_lX_/_m9_,
     n_na_=_m9_*_m__|0,
     vertices_nb_=caml_make_vect(n_na_+2|0,vertex_mG_(0,0,0)),
     faces_nc_=caml_make_vect(n_na_*2|0,face_m5_(0,0,0)),
     south_nd_=n_na_+1|0;
    caml_array_set(vertices_nb_,n_na_,vertex_mG_(0,-1,0));
    caml_array_set(vertices_nb_,south_nd_,vertex_mG_(0,1,0));
    var
     _ne_=0,
     _nf_=_m__-1|0,
     p_delta_nk_=2*pi_lX_/_m__,
     t_offset_nm_=(pi_lX_-t_delta_m$_)/2;
    if(!(_nf_<_ne_))
     {var i_ng_=_ne_;
      for(;;)
       {var _nh_=0,_ni_=_m9_-1|0;
        if(!(_ni_<_nh_))
         {var j_nj_=_nh_;
          for(;;)
           {var
             phi_nl_=i_ng_*p_delta_nk_,
             theta_nn_=j_nj_*t_delta_m$_-t_offset_nm_,
             k_no_=(i_ng_*_m9_|0)+j_nj_|0;
            caml_array_set
             (vertices_nb_,
              k_no_,
              vertex_mG_
               (Math.cos(phi_nl_)*Math.cos(theta_nn_),
                Math.sin(theta_nn_),
                Math.sin(phi_nl_)*Math.cos(theta_nn_)));
            if(0===j_nj_)
             {caml_array_set
               (faces_nc_,
                2*k_no_|0,
                face_m5_(n_na_,k_no_,caml_mod(k_no_+_m9_|0,n_na_)));
              caml_array_set
               (faces_nc_,
                (2*k_no_|0)+1|0,
                face_m5_
                 (south_nd_,
                  caml_mod((k_no_+(2*_m9_|0)|0)-1|0,n_na_),
                  (k_no_+_m9_|0)-1|0));}
            else
             {caml_array_set
               (faces_nc_,
                2*k_no_|0,
                face_m5_(k_no_,caml_mod(k_no_+_m9_|0,n_na_),k_no_-1|0));
              caml_array_set
               (faces_nc_,
                (2*k_no_|0)+1|0,
                face_m5_
                 (k_no_-1|0,
                  caml_mod(k_no_+_m9_|0,n_na_),
                  caml_mod((k_no_+_m9_|0)-1|0,n_na_)));}
            var _np_=j_nj_+1|0;
            if(_ni_!==j_nj_){var j_nj_=_np_;continue;}
            break;}}
        var _nq_=i_ng_+1|0;
        if(_nf_!==i_ng_){var i_ng_=_nq_;continue;}
        break;}}
    var texture_q4_=_i_.toString();
    window_lh_.onload=
    _la_
     (function(param_q8_)
       {function _qV_(texture_nr_)
         {var
           w_ns_=texture_nr_.width,
           h_nt_=texture_nr_.height,
           canvas_nu_=create_canvas_m6_(w_ns_,h_nt_),
           ctx_nv_=canvas_nu_.getContext(_2d__lf_),
           _nw_=h_nt_/8|0,
           _nx_=w_ns_/8|0,
           img_ny_=ctx_nv_.getImageData(0,0,_nx_,_nw_),
           data_nz_=img_ny_.data,
           inv_gamma_nP_=1/gamma_lZ_;
          function update_shadow_nT_(obliquity_nA_)
           {var
             _nB_=0,
             _nC_=_nw_-1|0,
             cos_obl_nJ_=Math.cos(obliquity_nA_),
             sin_obl_nI_=-Math.sin(obliquity_nA_);
            if(!(_nC_<_nB_))
             {var j_nD_=_nB_;
              for(;;)
               {var _nE_=0,_nF_=(_nx_/2|0)-1|0;
                if(!(_nF_<_nE_))
                 {var i_nG_=_nE_;
                  for(;;)
                   {var
                     theta_nH_=(j_nD_/_nw_-0.5)*pi_lX_,
                     _nK_=
                      Math.cos(i_nG_/_nx_*2*pi_lX_)*
                      Math.cos(theta_nH_)*
                      cos_obl_nJ_+
                      Math.sin(theta_nH_)*
                      sin_obl_nI_,
                     k_nN_=4*(i_nG_+j_nD_*_nx_)|0,
                     k__nM_=4*(_nx_-i_nG_+j_nD_*_nx_-1)|0,
                     c_nL_=0<_nK_?dark_l0_:dark_l0_-_nK_*(1-dark_l0_)*1.2,
                     c_nO_=c_nL_<=1?c_nL_:1,
                     c_nQ_=255-(255.99*Math.pow(c_nO_,inv_gamma_nP_)|0)|0;
                    data_nz_[k_nN_+3|0]=c_nQ_;
                    data_nz_[k__nM_+3|0]=c_nQ_;
                    var _nR_=i_nG_+1|0;
                    if(_nF_!==i_nG_){var i_nG_=_nR_;continue;}
                    break;}}
                var _nS_=j_nD_+1|0;
                if(_nC_!==j_nD_){var j_nD_=_nS_;continue;}
                break;}}
            ctx_nv_.putImageData(img_ny_,0,0);
            ctx_nv_.globalCompositeOperation=_m_.toString();
            ctx_nv_.save();
            ctx_nv_.scale(8*(_nx_+2|0)/_nx_,8*(_nw_+2|0)/_nw_);
            ctx_nv_.translate(-1,-1);
            ctx_nv_.drawImage(canvas_nu_,0,0);
            return ctx_nv_.restore();}
          update_shadow_nT_(obliquity_lY_);
          var
           w_nU_=texture_nr_.width,
           canvas__nV_=create_canvas_m6_(w_nU_,texture_nr_.height),
           ctx__nW_=canvas__nV_.getContext(_2d__lf_),
           no_lighting_nX_=[0,0],
           canvas_nY_=create_canvas_m6_(width_lW_,width_lW_),
           canvas__nZ_=create_canvas_m6_(width_lW_,width_lW_);
          _k$_(document_li_.body,canvas_nY_);
          var
           ctx_n0_=canvas_nY_.getContext(_2d__lf_),
           ctx__n1_=canvas__nZ_.getContext(_2d__lf_),
           r_n2_=width_lW_/2,
           tw_n3_=texture_nr_.width,
           th_n4_=texture_nr_.height,
           uv_n8_=
            _bT_
             (function(v_n5_)
               {var
                 u_n6_=
                  (tw_n3_-
                   Math.atan2(v_n5_[3],v_n5_[1])*
                   ((tw_n3_/2-0.99)/pi_lX_)|
                   0)%
                  tw_n3_,
                 v_n7_=th_n4_/2+Math.asin(v_n5_[2])*((th_n4_-0.99)/pi_lX_)|0;
                if(0<=u_n6_)
                 {if(u_n6_<tw_n3_)
                   {if(0<=v_n7_)
                     {if(v_n7_<th_n4_)return [0,u_n6_,v_n7_];throw [0,_d_,_n_];}
                    throw [0,_d_,_o_];}
                  throw [0,_d_,_p_];}
                throw [0,_d_,_q_];},
              vertices_nb_),
           normals_oY_=
            _bT_
             (function(param_n9_)
               {var
                 v1_n__=caml_array_get(vertices_nb_,param_n9_[1]),
                 v2_oa_=caml_array_get(vertices_nb_,param_n9_[2]),
                 _n$_=
                  vect_mQ_(v1_n__,caml_array_get(vertices_nb_,param_n9_[3])),
                 _ob_=vect_mQ_(v1_n__,v2_oa_),
                 z2_oc_=_n$_[3],
                 y2_od_=_n$_[2],
                 x2_oe_=_n$_[1],
                 z1_of_=_ob_[3],
                 y1_og_=_ob_[2],
                 x1_oh_=_ob_[1];
                return [254,
                        y1_og_*z2_oc_-y2_od_*z1_of_,
                        z1_of_*x2_oe_-z2_oc_*x1_oh_,
                        x1_oh_*y2_od_-x2_oe_*y1_og_];},
              faces_nc_),
           paused_oZ_=[0,0],
           follow_o0_=[0,0],
           lighting_o1_=[0,1],
           clipped_o2_=[0,1],
           obl_o3_=[0,obliquity_lY_],
           face_info_o4_=
            _bT_
             (function(f_oi_)
               {var
                 match_oj_=caml_array_get(uv_n8_,f_oi_[1]),
                 v1_ok_=match_oj_[2],
                 u1_ol_=match_oj_[1],
                 match_om_=caml_array_get(uv_n8_,f_oi_[2]),
                 v2_on_=match_om_[2],
                 u2_oo_=match_om_[1],
                 match_op_=caml_array_get(uv_n8_,f_oi_[3]),
                 v3_oq_=match_op_[2],
                 u3_or_=match_op_[1],
                 mid_os_=tw_n3_/2;
                if(u1_ol_==0)
                 {if(mid_os_<u2_oo_||mid_os_<u3_or_)
                   var _ot_=1;
                  else
                   {var _ou_=0,_ot_=0;}
                  if(_ot_){var u1_ov_=tw_n3_-2,_ou_=1;}}
                else
                 var _ou_=0;
                if(!_ou_)var u1_ov_=u1_ol_;
                if(u2_oo_==0)
                 {if(mid_os_<u1_ov_||mid_os_<u3_or_)
                   var _ow_=1;
                  else
                   {var _ox_=0,_ow_=0;}
                  if(_ow_){var u2_oy_=tw_n3_-2,_ox_=1;}}
                else
                 var _ox_=0;
                if(!_ox_)var u2_oy_=u2_oo_;
                if(u3_or_==0)
                 {if(mid_os_<u2_oy_||mid_os_<u1_ov_)
                   var _oz_=1;
                  else
                   {var _oA_=0,_oz_=0;}
                  if(_oz_){var u3_oB_=tw_n3_-2,_oA_=1;}}
                else
                 var _oA_=0;
                if(!_oA_)var u3_oB_=u3_or_;
                var mth_oC_=th_n4_-2;
                if(v1_ok_==0||mth_oC_<=v1_ok_)
                 var _oD_=0;
                else
                 {var u1_oE_=u1_ov_,_oD_=1;}
                if(!_oD_)var u1_oE_=(u2_oy_+u3_oB_)/2;
                if(v2_on_==0||mth_oC_<=v2_on_)
                 var _oF_=0;
                else
                 {var u2_oG_=u2_oy_,_oF_=1;}
                if(!_oF_)var u2_oG_=(u1_oE_+u3_oB_)/2;
                if(v3_oq_==0||mth_oC_<=v3_oq_)
                 var _oH_=0;
                else
                 {var u3_oI_=u3_oB_,_oH_=1;}
                if(!_oH_)var u3_oI_=(u2_oG_+u1_oE_)/2;
                var
                 u1_oJ_=max_m8_(1,u1_oE_),
                 u2_oK_=max_m8_(1,u2_oG_),
                 u3_oL_=max_m8_(1,u3_oI_),
                 v1_oM_=max_m8_(1,v1_ok_),
                 v2_oN_=max_m8_(1,v2_on_),
                 v3_oO_=max_m8_(1,v3_oq_),
                 du2_oP_=u2_oK_-u1_oJ_,
                 du3_oQ_=u3_oL_-u1_oJ_,
                 dv2_oR_=v2_oN_-v1_oM_,
                 dv3_oS_=v3_oO_-v1_oM_,
                 su_oT_=dv2_oR_*du3_oQ_-dv3_oS_*du2_oP_,
                 sv_oU_=du2_oP_*dv3_oS_-du3_oQ_*dv2_oR_,
                 u_oV_=max_m8_(0,min_m7_(u1_oJ_,min_m7_(u2_oK_,u3_oL_))-4),
                 v_oW_=max_m8_(0,min_m7_(v1_oM_,min_m7_(v2_oN_,v3_oO_))-4),
                 u__oX_=
                  min_m7_(tw_n3_,max_m8_(u1_oJ_,max_m8_(u2_oK_,u3_oL_))+4);
                return [0,
                        u1_oJ_,
                        v1_oM_,
                        du2_oP_/su_oT_,
                        dv2_oR_/sv_oU_,
                        du3_oQ_/su_oT_,
                        dv3_oS_/sv_oU_,
                        u_oV_,
                        v_oW_,
                        u__oX_-u_oV_,
                        min_m7_(th_n4_,max_m8_(v1_oM_,max_m8_(v2_oN_,v3_oO_))+4)-
                        v_oW_];},
              faces_nc_),
           m_obliq_o5_=[0,xy_rotation_mT_(-obliquity_lY_)],
           m_o6_=[0,matrix_identity_mU_],
           phi_rot_o7_=[0,0],
           rateText_o8_=document_li_.createTextNode(_E_.toString()),
           ctrl_o9_=createDiv_lT_(document_li_);
          ctrl_o9_.className=_D_.toString();
          var d_o__=createDiv_lT_(document_li_);
          _k$_(d_o__,document_li_.createTextNode(_C_.toString()));
          _k$_(ctrl_o9_,d_o__);
          var form_o$_=createDiv_lT_(document_li_);
          function br_pc_(param_pa_)
           {return unsafeCreateElement_lr_(document_li_,_S_);}
          _k$_
           (form_o$_,
            toggle_button_mO_
             (_A_,_B_,function(p_pb_){paused_oZ_[1]=p_pb_;return 0;}));
          _k$_(form_o$_,br_pc_(0));
          _k$_
           (form_o$_,
            toggle_button_mO_
             (_y_,_z_,function(f_pd_){follow_o0_[1]=f_pd_;return 0;}));
          _k$_(form_o$_,br_pc_(0));
          var b_pe_=createInput_lR_([0,button_type_l1_],0,document_li_);
          b_pe_.value=_x_.toString();
          b_pe_.onclick=
          _la_
           (function(param_pf_)
             {m_o6_[1]=matrix_identity_mU_;
              phi_rot_o7_[1]=0;
              m_obliq_o5_[1]=xy_rotation_mT_(-obl_o3_[1]);
              return _true_kG_;});
          _k$_(form_o$_,b_pe_);
          _k$_(form_o$_,br_pc_(0));
          var lab_pg_=createLabel_lS_(document_li_);
          _k$_(lab_pg_,document_li_.createTextNode(_w_.toString()));
          var
           _ph_=unsafeCreateElementEx_lL_(0,0,document_li_,_N_),
           param_pi_=_v_;
          for(;;)
           {if(param_pi_)
             {var
               l_pl_=param_pi_[2],
               a_pk_=param_pi_[1],
               _pj_=unsafeCreateElement_lr_(document_li_,_M_);
              _k$_(_pj_,document_li_.createTextNode(a_pk_.toString()));
              _ph_.add(_pj_,null_kE_);
              var param_pi_=l_pl_;
              continue;}
            _ph_.onchange=
            _la_
             (function(param_po_)
               {var
                 _pm_=_ph_.selectedIndex,
                 o_pn_=0===_pm_?obliquity_lY_:1===_pm_?0:-obliquity_lY_;
                update_shadow_nT_(o_pn_);
                obl_o3_[1]=o_pn_;
                return _true_kG_;});
            _k$_(lab_pg_,_ph_);
            _k$_(form_o$_,lab_pg_);
            _k$_(ctrl_o9_,form_o$_);
            var form_pp_=createDiv_lT_(document_li_);
            _k$_
             (form_pp_,
              checkbox_mP_
               (_u_,1,function(l_pq_){lighting_o1_[1]=l_pq_;return 0;}));
            _k$_(form_pp_,br_pc_(0));
            _k$_
             (form_pp_,
              checkbox_mP_
               (_t_,1,function(l_pr_){clipped_o2_[1]=l_pr_;return 0;}));
            _k$_(form_pp_,br_pc_(0));
            _k$_(form_pp_,document_li_.createTextNode(_s_.toString()));
            _k$_(form_pp_,rateText_o8_);
            _k$_(ctrl_o9_,form_pp_);
            _k$_(document_li_.body,ctrl_o9_);
            var _ps_=unsafeCreateElement_lr_(document_li_,_R_);
            _ps_.innerHTML=_r_.toString();
            _k$_(document_li_.body,_ps_);
            var mx_pt_=[0,0],my_pu_=[0,0];
            canvas_nY_.onmousedown=
            _la_
             (function(ev_pv_)
               {mx_pt_[1]=ev_pv_.clientX;
                my_pu_[1]=ev_pv_.clientY;
                var
                 c2_pI_=[0,null_kE_],
                 c1_pJ_=
                  _lc_
                   (document_li_,
                    mousemove_lg_,
                    _la_
                     (function(ev_pw_)
                       {var
                         x_px_=ev_pw_.clientX,
                         y_py_=ev_pw_.clientY,
                         dx_pz_=x_px_-mx_pt_[1]|0,
                         dy_pA_=y_py_-my_pu_[1]|0;
                        if(0!==dy_pA_)
                         {var
                           _pB_=2*dy_pA_/width_lW_,
                           cos_phi_pC_=Math.cos(_pB_),
                           sin_phi_pD_=Math.sin(_pB_),
                           _pE_=m_o6_[1],
                           _pF_=vertex_mG_(0,-sin_phi_pD_,cos_phi_pC_),
                           _pG_=vertex_mG_(0,cos_phi_pC_,sin_phi_pD_);
                          m_o6_[1]=
                          matrix_mul_mR_([0,vertex_mG_(1,0,0),_pG_,_pF_],_pE_);}
                        if(0!==dx_pz_)
                         {var _pH_=m_o6_[1];
                          m_o6_[1]=
                          matrix_mul_mR_(xz_rotation_mS_(2*dx_pz_/width_lW_),_pH_);}
                        mx_pt_[1]=x_px_;
                        my_pu_[1]=y_py_;
                        return _true_kG_;}),
                    _true_kG_);
                c2_pI_[1]=
                _kO_
                 (_lc_
                   (document_li_,
                    mouseup_le_,
                    _la_
                     (function(param_pL_)
                       {_ld_(c1_pJ_);
                        var _pK_=c2_pI_[1];
                        if(_pK_!=null_kE_)_ld_(_pK_);
                        return _true_kG_;}),
                    _true_kG_));
                return _false_kH_;});
            var
             ti_pM_=[0,new date_constr_kJ_().getTime()],
             fps_pN_=[0,0],
             loop_qC_=
              function(t_qw_,phi_pO_)
               {var rotation_pP_=xz_rotation_mS_(phi_pO_-phi_rot_o7_[1]);
                if(lighting_o1_[1])
                 {no_lighting_nX_[1]=0;
                  ctx__nW_.drawImage(texture_nr_,0,0);
                  var
                   i_pQ_=
                    (2*pi_lX_-phi_pO_%(2*pi_lX_))*w_nU_/2/pi_lX_%w_nU_|0;
                  ctx__nW_.drawImage(canvas_nu_,i_pQ_,0);
                  ctx__nW_.drawImage(canvas_nu_,i_pQ_-w_nU_,0);}
                else
                 if(!no_lighting_nX_[1])
                  {ctx__nW_.drawImage(texture_nr_,0,0);no_lighting_nX_[1]=1;}
                var
                 _pR_=matrix_mul_mR_(m_obliq_o5_[1],rotation_pP_),
                 m_pS_=matrix_mul_mR_(m_o6_[1],_pR_),
                 _pU_=
                  _bT_
                   (function(v_pT_){return matrix_vect_mul_mA_(m_pS_,v_pT_);},
                    vertices_nb_),
                 _pV_=matrix_vect_mul_mA_(matrix_transp_mw_(m_pS_),v_j_);
                ctx__n1_.clearRect(0,0,width_lW_,width_lW_);
                ctx__n1_.save();
                if(clipped_o2_[1])
                 {ctx__n1_.beginPath();
                  ctx__n1_.arc(r_n2_,r_n2_,r_n2_*0.95,0,-2*pi_lX_,_true_kG_);
                  ctx__n1_.clip();}
                ctx__n1_.setTransform(r_n2_-2,0,0,r_n2_-2,r_n2_,r_n2_);
                ctx__n1_.globalCompositeOperation=_H_.toString();
                var _pW_=0,_pX_=faces_nc_.length-1-1|0;
                if(!(_pX_<_pW_))
                 {var i_pY_=_pW_;
                  for(;;)
                   {var
                     _pZ_=faces_nc_[i_pY_+1],
                     match_p0_=caml_array_get(_pU_,_pZ_[1]),
                     y1_p1_=match_p0_[2],
                     x1_p2_=match_p0_[1],
                     match_p3_=caml_array_get(_pU_,_pZ_[2]),
                     y2_p4_=match_p3_[2],
                     x2_p5_=match_p3_[1],
                     match_p6_=caml_array_get(_pU_,_pZ_[3]),
                     y3_p7_=match_p6_[2],
                     x3_p8_=match_p6_[1],
                     _p9_=caml_array_get(normals_oY_,i_pY_);
                    if(0<=_p9_[1]*_pV_[1]+_p9_[2]*_pV_[2]+_p9_[3]*_pV_[3])
                     {ctx__n1_.beginPath();
                      ctx__n1_.moveTo(x1_p2_,y1_p1_);
                      ctx__n1_.lineTo(x2_p5_,y2_p4_);
                      ctx__n1_.lineTo(x3_p8_,y3_p7_);
                      ctx__n1_.closePath();
                      ctx__n1_.save();
                      ctx__n1_.clip();
                      var
                       match_p__=caml_array_get(face_info_o4_,i_pY_),
                       dv_p$_=match_p__[10],
                       du_qa_=match_p__[9],
                       v_qb_=match_p__[8],
                       u_qc_=match_p__[7],
                       dv3_qd_=match_p__[6],
                       du3_qe_=match_p__[5],
                       dv2_qf_=match_p__[4],
                       du2_qg_=match_p__[3],
                       v1_qh_=match_p__[2],
                       u1_qi_=match_p__[1],
                       dx2_qj_=x2_p5_-x1_p2_,
                       dx3_qk_=x3_p8_-x1_p2_,
                       dy2_ql_=y2_p4_-y1_p1_,
                       dy3_qm_=y3_p7_-y1_p1_,
                       a_qn_=dx2_qj_*dv3_qd_-dx3_qk_*dv2_qf_,
                       b_qo_=dx2_qj_*du3_qe_-dx3_qk_*du2_qg_,
                       d_qp_=dy2_ql_*dv3_qd_-dy3_qm_*dv2_qf_,
                       e_qq_=dy2_ql_*du3_qe_-dy3_qm_*du2_qg_;
                      ctx__n1_.transform
                       (a_qn_,
                        d_qp_,
                        b_qo_,
                        e_qq_,
                        x1_p2_-a_qn_*u1_qi_-b_qo_*v1_qh_,
                        y1_p1_-d_qp_*u1_qi_-e_qq_*v1_qh_);
                      ctx__n1_.drawImage
                       (canvas__nV_,
                        u_qc_,
                        v_qb_,
                        du_qa_,
                        dv_p$_,
                        u_qc_,
                        v_qb_,
                        du_qa_,
                        dv_p$_);
                      ctx__n1_.restore();}
                    var _qr_=i_pY_+1|0;
                    if(_pX_!==i_pY_){var i_pY_=_qr_;continue;}
                    break;}}
                ctx__n1_.restore();
                ctx_n0_.globalCompositeOperation=_G_.toString();
                ctx_n0_.drawImage(canvas__nZ_,0,0);
                try {ctx_n0_.getImageData(0,0,1,1);}catch(_qT_){}
                var
                 t__qs_=new date_constr_kJ_().getTime(),
                 hz_qt_=1000/(t__qs_-ti_pM_[1]),
                 _qu_=fps_pN_[1]==0?hz_qt_:0.9*fps_pN_[1]+0.1*hz_qt_;
                fps_pN_[1]=_qu_;
                rateText_o8_.data=_d4_(_hW_,_F_,fps_pN_[1]).toString();
                ti_pM_[1]=t__qs_;
                function _qF_(param_qD_)
                 {var
                   t__qv_=new date_constr_kJ_().getTime(),
                   dt_qx_=t__qv_-t_qw_,
                   dt_qy_=dt_qx_<0?0:1000<dt_qx_?0:dt_qx_,
                   angle_qz_=2*pi_lX_*dt_qy_/1000/10,
                   _qA_=
                    paused_oZ_[1]
                     ?0
                     :follow_o0_[1]?(phi_rot_o7_[1]=phi_rot_o7_[1]+angle_qz_,1):0;
                  _qA_;
                  var _qB_=paused_oZ_[1]?phi_pO_:phi_pO_+angle_qz_;
                  return loop_qC_(t__qv_,_qB_);}
                var
                 match_qE_=task_kt_(0),
                 t_qG_=match_qE_[1],
                 w_qH_=match_qE_[2],
                 _qJ_=0.01*1000,
                 id_qK_=
                  window_lh_.setTimeout
                   (caml_js_wrap_callback
                     (function(param_qI_){return wakeup_ks_(w_qH_,0);}),
                    _qJ_);
                function _qM_(param_qL_)
                 {return window_lh_.clearTimeout(id_qK_);}
                var _qN_=repr_jv_(t_qG_)[1];
                switch(_qN_[0])
                 {case 1:
                   var
                    _qO_=
                     _qN_[1][1]===Canceled_ir_?(call_unsafe_jo_(_qM_,0),1):0;
                   break;
                  case 2:
                   var
                    sleeper_qP_=_qN_[1],
                    handler_qQ_=[0,current_data_is_[1],_qM_],
                    _qR_=sleeper_qP_[4],
                    _qS_=typeof _qR_==="number"?handler_qQ_:[2,handler_qQ_,_qR_];
                   sleeper_qP_[4]=_qS_;
                   var _qO_=1;
                   break;
                  default:var _qO_=0;}
                _qO_;
                return bind_ku_(t_qG_,_qF_);};
            return loop_qC_(new date_constr_kJ_().getTime(),0);}}
        var _qU_=unsafeCreateElement_lr_(document_li_,_T_);
        function _qY_(param_qW_){return [0,[0,_qU_]];}
        var match_qX_=task_kt_(0),w_q0_=match_qX_[2],t_q1_=match_qX_[1];
        function cont_q2_(x_qZ_){return wakeup_ks_(w_q0_,x_qZ_);}
        _qU_.onload=_la_(function(param_q3_){cont_q2_(0);return _false_kH_;});
        _qU_.src=texture_q4_;
        var _q5_=repr_jv_(bind_ku_(bind_ku_(t_q1_,_qY_),_qV_))[1];
        switch(_q5_[0])
         {case 1:throw _q5_[1];
          case 2:
           var sleeper_q7_=_q5_[1];
           add_immutable_waiter_kq_
            (sleeper_q7_,
             function(param_q6_)
              {switch(param_q6_[0])
                {case 0:return 0;
                 case 1:return _i3_(param_q6_[1]);
                 default:throw [0,_d_,_al_];}});
           break;
          case 3:throw [0,_d_,_ak_];
          default:}
        return _false_kH_;});
    do_at_exit_bE_(0);
    return;}
  ());
