// This program was compiled from OCaml by js_of_ocaml 1.3
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_float_of_string(s) {
  var res;
  s = s.getFullBytes();
  res = +s;
  if ((s.length > 0) && (res === res)) return res;
  s = s.replace(/_/g,"");
  res = +s;
  if (((s.length > 0) && (res === res)) || /^[+-]?nan$/i.test(s)) return res;
  caml_failwith("float_of_string");
}
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_from_byte_string (s) {return s.getFullBytes();}
function caml_js_get_console () {
  var c = this.console?this.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
function caml_js_on_ie () {
  var ua = this.navigator?this.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_to_byte_string (s) {return new MlString (s);}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _jG_(_wd_,_we_,_wf_,_wg_,_wh_,_wi_,_wj_)
     {return _wd_.length==6
              ?_wd_(_we_,_wf_,_wg_,_wh_,_wi_,_wj_)
              :caml_call_gen(_wd_,[_we_,_wf_,_wg_,_wh_,_wi_,_wj_]);}
    function _fx_(_v$_,_wa_,_wb_,_wc_)
     {return _v$_.length==3
              ?_v$_(_wa_,_wb_,_wc_)
              :caml_call_gen(_v$_,[_wa_,_wb_,_wc_]);}
    function _f2_(_v8_,_v9_,_v__)
     {return _v8_.length==2?_v8_(_v9_,_v__):caml_call_gen(_v8_,[_v9_,_v__]);}
    function _c5_(_v6_,_v7_)
     {return _v6_.length==1?_v6_(_v7_):caml_call_gen(_v6_,[_v7_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")],
     _e_=new MlString("File \"%s\", line %d, characters %d-%d: %s"),
     _f_=new MlString("monkey.model"),
     _g_=new MlString("canvas");
    caml_register_global(6,_c_);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _cC_=[0,new MlString("Out_of_memory")],
     _cB_=[0,new MlString("Match_failure")],
     _cA_=[0,new MlString("Stack_overflow")],
     _cz_=[0,new MlString("Undefined_recursive_module")],
     _cy_=new MlString("%.12g"),
     _cx_=new MlString("."),
     _cw_=new MlString("%d"),
     _cv_=new MlString("true"),
     _cu_=new MlString("false"),
     _ct_=new MlString("Pervasives.do_at_exit"),
     _cs_=new MlString("\\b"),
     _cr_=new MlString("\\t"),
     _cq_=new MlString("\\n"),
     _cp_=new MlString("\\r"),
     _co_=new MlString("\\\\"),
     _cn_=new MlString("\\'"),
     _cm_=new MlString(""),
     _cl_=new MlString("String.blit"),
     _ck_=new MlString("String.sub"),
     _cj_=new MlString("Queue.Empty"),
     _ci_=new MlString("Buffer.add: cannot grow buffer"),
     _ch_=new MlString(""),
     _cg_=new MlString(""),
     _cf_=new MlString("%.12g"),
     _ce_=new MlString("\""),
     _cd_=new MlString("\""),
     _cc_=new MlString("'"),
     _cb_=new MlString("'"),
     _ca_=new MlString("nan"),
     _b$_=new MlString("neg_infinity"),
     _b__=new MlString("infinity"),
     _b9_=new MlString("."),
     _b8_=new MlString("printf: bad positional specification (0)."),
     _b7_=new MlString("%_"),
     _b6_=[0,new MlString("printf.ml"),143,8],
     _b5_=new MlString("'"),
     _b4_=new MlString("Printf: premature end of format string '"),
     _b3_=new MlString("'"),
     _b2_=new MlString(" in format string '"),
     _b1_=new MlString(", at char number "),
     _b0_=new MlString("Printf: bad conversion %"),
     _bZ_=new MlString("Sformat.index_of_int: negative argument "),
     _bY_=new MlString(""),
     _bX_=new MlString(", %s%s"),
     _bW_=[1,1],
     _bV_=new MlString("%s\n"),
     _bU_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _bT_=new MlString("Raised at"),
     _bS_=new MlString("Re-raised at"),
     _bR_=new MlString("Raised by primitive operation at"),
     _bQ_=new MlString("Called from"),
     _bP_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _bO_=new MlString("%s unknown location"),
     _bN_=new MlString("Out of memory"),
     _bM_=new MlString("Stack overflow"),
     _bL_=new MlString("Pattern matching failed"),
     _bK_=new MlString("Assertion failed"),
     _bJ_=new MlString("Undefined recursive module"),
     _bI_=new MlString("(%s%s)"),
     _bH_=new MlString(""),
     _bG_=new MlString(""),
     _bF_=new MlString("(%s)"),
     _bE_=new MlString("%d"),
     _bD_=new MlString("%S"),
     _bC_=new MlString("_"),
     _bB_=[0,new MlString("src/core/lwt.ml"),692,20],
     _bA_=[0,new MlString("src/core/lwt.ml"),695,8],
     _bz_=[0,new MlString("src/core/lwt.ml"),670,20],
     _by_=[0,new MlString("src/core/lwt.ml"),673,8],
     _bx_=[0,new MlString("src/core/lwt.ml"),648,20],
     _bw_=[0,new MlString("src/core/lwt.ml"),651,8],
     _bv_=[0,new MlString("src/core/lwt.ml"),498,8],
     _bu_=[0,new MlString("src/core/lwt.ml"),487,9],
     _bt_=new MlString("Lwt.wakeup_result"),
     _bs_=new MlString("Lwt.Canceled"),
     state_return_unit_br_=[0,0],
     _bq_=new MlString("script"),
     _bp_=new MlString("canvas"),
     _bo_=new MlString("browser can't read file: unimplemented"),
     _bn_=new MlString("utf8"),
     _bm_=[0,new MlString("file.ml"),132,15],
     _bl_=new MlString("string"),
     _bk_=new MlString("can't retrieve file name: not implemented"),
     _bj_=new MlString("\\$&"),
     _bi_=new MlString("$$$$"),
     _bh_=new MlString("g"),
     _bg_=new MlString("g"),
     _bf_=new MlString("[$]"),
     _be_=new MlString("[\\][()\\\\|+*.?{}^$]"),
     _bd_=[0,new MlString(""),0],
     _bc_=new MlString(""),
     _bb_=new MlString(""),
     _ba_=new MlString("#"),
     _a$_=new MlString(""),
     _a__=new MlString("?"),
     _a9_=new MlString(""),
     _a8_=new MlString("/"),
     _a7_=new MlString("/"),
     _a6_=new MlString(":"),
     _a5_=new MlString(""),
     _a4_=new MlString("http://"),
     _a3_=new MlString(""),
     _a2_=new MlString("#"),
     _a1_=new MlString(""),
     _a0_=new MlString("?"),
     _aZ_=new MlString(""),
     _aY_=new MlString("/"),
     _aX_=new MlString("/"),
     _aW_=new MlString(":"),
     _aV_=new MlString(""),
     _aU_=new MlString("https://"),
     _aT_=new MlString(""),
     _aS_=new MlString("#"),
     _aR_=new MlString(""),
     _aQ_=new MlString("?"),
     _aP_=new MlString(""),
     _aO_=new MlString("/"),
     _aN_=new MlString("file://"),
     _aM_=new MlString(""),
     _aL_=new MlString(""),
     _aK_=new MlString(""),
     _aJ_=new MlString(""),
     _aI_=new MlString(""),
     _aH_=new MlString(""),
     _aG_=new MlString("="),
     _aF_=new MlString("&"),
     _aE_=new MlString("file"),
     _aD_=new MlString("file:"),
     _aC_=new MlString("http"),
     _aB_=new MlString("http:"),
     _aA_=new MlString("https"),
     _az_=new MlString("https:"),
     _ay_=new MlString(" "),
     _ax_=new MlString("%2B"),
     _aw_=new MlString("Url.Local_exn"),
     _av_=new MlString("+"),
     _au_=new MlString("g"),
     _at_=new MlString("\\+"),
     _as_=new MlString("Url.Not_an_http_protocol"),
     _ar_=
      new
       MlString
       ("^([Hh][Tt][Tt][Pp][Ss]?)://([0-9a-zA-Z.-]+|\\[[0-9a-zA-Z.-]+\\]|\\[[0-9A-Fa-f:.]+\\])?(:([0-9]+))?/([^\\?#]*)(\\?([^#]*))?(#(.*))?$"),
     _aq_=
      new MlString("^([Ff][Ii][Ll][Ee])://([^\\?#]*)(\\?([^#])*)?(#(.*))?$"),
     _ap_=new MlString(""),
     _ao_=new MlString("POST"),
     _an_=new MlString("multipart/form-data; boundary="),
     _am_=new MlString("POST"),
     _al_=
      [0,
       new MlString("POST"),
       [0,new MlString("application/x-www-form-urlencoded")],
       126925477],
     _ak_=[0,new MlString("POST"),0,126925477],
     _aj_=new MlString("GET"),
     _ai_=new MlString("?"),
     _ah_=new MlString("Content-type"),
     _ag_=new MlString("="),
     _af_=new MlString("="),
     _ae_=new MlString("&"),
     _ad_=new MlString("Content-Type: application/octet-stream\r\n"),
     _ac_=new MlString("\"\r\n"),
     _ab_=new MlString("\"; filename=\""),
     _aa_=new MlString("Content-Disposition: form-data; name=\""),
     _$_=new MlString("\r\n"),
     ___=new MlString("\r\n"),
     _Z_=new MlString("\r\n"),
     _Y_=new MlString("--"),
     _X_=new MlString("\r\n"),
     _W_=new MlString("\"\r\n\r\n"),
     _V_=new MlString("Content-Disposition: form-data; name=\""),
     _U_=new MlString("--\r\n"),
     _T_=new MlString("--"),
     _S_=new MlString("js_of_ocaml-------------------"),
     _R_=new MlString("Msxml2.XMLHTTP"),
     _Q_=new MlString("Msxml3.XMLHTTP"),
     _P_=new MlString("Microsoft.XMLHTTP"),
     _O_=[0,new MlString("xmlHttpRequest.ml"),79,2],
     _N_=new MlString("XmlHttpRequest.Wrong_headers"),
     _M_=new MlString("webgl"),
     _L_=new MlString("experimental-webgl"),
     _K_=new MlString("uncaught exception: %s"),
     _J_=new MlString("%.1f"),
     _I_=new MlString("loading"),
     _H_=new MlString("fps"),
     _G_=new MlString("fragment-shader"),
     _F_=new MlString("vertex-shader"),
     _E_=new MlString("program loaded"),
     _D_=new MlString("u_proj"),
     _C_=new MlString("u_lightPos"),
     _B_=new MlString("u_ambientLight"),
     _A_=new MlString("a_position"),
     _z_=new MlString("a_normal"),
     _y_=new MlString("ready"),
     _x_=new MlString("\n"),
     _w_=[0,1,[0,2,[0,3,[0,4,0]]]],
     _v_=new MlString("f"),
     _u_=new MlString("v"),
     _t_=new MlString("vn"),
     _s_=[0,1,[0,2,0]],
     _r_=new MlString("can't find script element %s"),
     _q_=new MlString("Unable to link the shader program."),
     _p_=new MlString("An error occurred compiling the shaders: \n%s\n%s"),
     _o_=new MlString("can't initialise webgl context"),
     _n_=new MlString("can't find canvas element %s"),
     _m_=new MlString("WebGL error"),
     _l_=new MlString("(v|vn|f)\\ ([^\\ ]+)\\ ([^\\ ]+)\\ ([^\\ ]+)"),
     _k_=new MlString("([0-9]+)//([0-9]+)");
    function _j_(s_h_){throw [0,_a_,s_h_];}
    function _cD_(s_i_){throw [0,_b_,s_i_];}
    function _cO_(s1_cE_,s2_cG_)
     {var
       l1_cF_=s1_cE_.getLen(),
       l2_cH_=s2_cG_.getLen(),
       s_cI_=caml_create_string(l1_cF_+l2_cH_|0);
      caml_blit_string(s1_cE_,0,s_cI_,0,l1_cF_);
      caml_blit_string(s2_cG_,0,s_cI_,l1_cF_,l2_cH_);
      return s_cI_;}
    function string_of_int_cP_(n_cJ_){return caml_format_int(_cw_,n_cJ_);}
    function _cL_(l1_cK_,l2_cM_)
     {if(l1_cK_)
       {var hd_cN_=l1_cK_[1];return [0,hd_cN_,_cL_(l1_cK_[2],l2_cM_)];}
      return l2_cM_;}
    var stderr_cQ_=caml_ml_open_descriptor_out(2);
    function output_string_cY_(oc_cS_,s_cR_)
     {return caml_ml_output(oc_cS_,s_cR_,0,s_cR_.getLen());}
    function do_at_exit_cX_(param_cW_)
     {var param_cT_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_cT_)
         {var l_cU_=param_cT_[2];
          try {}catch(_cV_){}
          var param_cT_=l_cU_;
          continue;}
        return 0;}}
    caml_register_named_value(_ct_,do_at_exit_cX_);
    function _c2_(_c0_,_cZ_){return caml_ml_output_char(_c0_,_cZ_);}
    function _dm_(_c1_){return caml_ml_flush(_c1_);}
    function _dl_(l_c3_,f_c4_)
     {if(0===l_c3_)return [0];
      var res_c6_=caml_make_vect(l_c3_,_c5_(f_c4_,0)),_c7_=1,_c8_=l_c3_-1|0;
      if(!(_c8_<_c7_))
       {var i_c9_=_c7_;
        for(;;)
         {res_c6_[i_c9_+1]=_c5_(f_c4_,i_c9_);
          var _c__=i_c9_+1|0;
          if(_c8_!==i_c9_){var i_c9_=_c__;continue;}
          break;}}
      return res_c6_;}
    function _dn_(l_c$_)
     {if(l_c$_)
       {var accu_da_=0,param_db_=l_c$_,tl_dh_=l_c$_[2],hd_de_=l_c$_[1];
        for(;;)
         {if(param_db_)
           {var
             t_dd_=param_db_[2],
             _dc_=accu_da_+1|0,
             accu_da_=_dc_,
             param_db_=t_dd_;
            continue;}
          var a_df_=caml_make_vect(accu_da_,hd_de_),i_dg_=1,param_di_=tl_dh_;
          for(;;)
           {if(param_di_)
             {var tl_dj_=param_di_[2];
              a_df_[i_dg_+1]=param_di_[1];
              var _dk_=i_dg_+1|0,i_dg_=_dk_,param_di_=tl_dj_;
              continue;}
            return a_df_;}}}
      return [0];}
    function _dC_(l_do_)
     {var l1_dp_=l_do_,l2_dq_=0;
      for(;;)
       {if(l1_dp_)
         {var
           l_dr_=l1_dp_[2],
           _ds_=[0,l1_dp_[1],l2_dq_],
           l1_dp_=l_dr_,
           l2_dq_=_ds_;
          continue;}
        return l2_dq_;}}
    function _dw_(f_du_,param_dt_)
     {if(param_dt_)
       {var l_dv_=param_dt_[2],r_dx_=_c5_(f_du_,param_dt_[1]);
        return [0,r_dx_,_dw_(f_du_,l_dv_)];}
      return 0;}
    function _dD_(f_dA_,param_dy_)
     {var param_dz_=param_dy_;
      for(;;)
       {if(param_dz_)
         {var l_dB_=param_dz_[2];
          _c5_(f_dA_,param_dz_[1]);
          var param_dz_=l_dB_;
          continue;}
        return 0;}}
    function _d0_(n_dE_,c_dG_)
     {var s_dF_=caml_create_string(n_dE_);
      caml_fill_string(s_dF_,0,n_dE_,c_dG_);
      return s_dF_;}
    function _d1_(s_dJ_,ofs_dH_,len_dI_)
     {if(0<=ofs_dH_&&0<=len_dI_&&!((s_dJ_.getLen()-len_dI_|0)<ofs_dH_))
       {var r_dK_=caml_create_string(len_dI_);
        caml_blit_string(s_dJ_,ofs_dH_,r_dK_,0,len_dI_);
        return r_dK_;}
      return _cD_(_ck_);}
    function _d2_(s1_dN_,ofs1_dM_,s2_dP_,ofs2_dO_,len_dL_)
     {if
       (0<=
        len_dL_&&
        0<=
        ofs1_dM_&&
        !((s1_dN_.getLen()-len_dL_|0)<ofs1_dM_)&&
        0<=
        ofs2_dO_&&
        !((s2_dP_.getLen()-len_dL_|0)<ofs2_dO_))
       return caml_blit_string(s1_dN_,ofs1_dM_,s2_dP_,ofs2_dO_,len_dL_);
      return _cD_(_cl_);}
    function _d3_(sep_dW_,l_dQ_)
     {if(l_dQ_)
       {var hd_dR_=l_dQ_[1],num_dS_=[0,0],len_dT_=[0,0],tl_dV_=l_dQ_[2];
        _dD_
         (function(s_dU_)
           {num_dS_[1]+=1;len_dT_[1]=len_dT_[1]+s_dU_.getLen()|0;return 0;},
          l_dQ_);
        var
         r_dX_=
          caml_create_string
           (len_dT_[1]+caml_mul(sep_dW_.getLen(),num_dS_[1]-1|0)|0);
        caml_blit_string(hd_dR_,0,r_dX_,0,hd_dR_.getLen());
        var pos_dY_=[0,hd_dR_.getLen()];
        _dD_
         (function(s_dZ_)
           {caml_blit_string(sep_dW_,0,r_dX_,pos_dY_[1],sep_dW_.getLen());
            pos_dY_[1]=pos_dY_[1]+sep_dW_.getLen()|0;
            caml_blit_string(s_dZ_,0,r_dX_,pos_dY_[1],s_dZ_.getLen());
            pos_dY_[1]=pos_dY_[1]+s_dZ_.getLen()|0;
            return 0;},
          tl_dV_);
        return r_dX_;}
      return _cm_;}
    caml_sys_const_big_endian(0);
    var _d4_=caml_sys_const_word_size(0);
    caml_sys_const_ostype_unix(0);
    caml_sys_const_ostype_win32(0);
    caml_sys_const_ostype_cygwin(0);
    var
     _d5_=caml_mul(_d4_/8|0,(1<<(_d4_-10|0))-1|0)-1|0,
     _ec_=252,
     _eb_=253,
     _d8_=[0,_cj_];
    function _ea_(param_d6_){return [0,0,0];}
    function _ed_(q_d7_)
     {if(0===q_d7_[1])throw [0,_d8_];
      q_d7_[1]=q_d7_[1]-1|0;
      var tail_d9_=q_d7_[2],head_d__=tail_d9_[2];
      if(head_d__===tail_d9_)q_d7_[2]=0;else tail_d9_[2]=head_d__[2];
      return head_d__[1];}
    function _ee_(q_d$_){return q_d$_[1];}
    function _ew_(n_ef_)
     {var
       n_eg_=1<=n_ef_?n_ef_:1,
       n_eh_=_d5_<n_eg_?_d5_:n_eg_,
       s_ei_=caml_create_string(n_eh_);
      return [0,s_ei_,0,n_eh_,s_ei_];}
    function _ex_(b_ej_){return _d1_(b_ej_[1],0,b_ej_[2]);}
    function _eq_(b_ek_,more_em_)
     {var new_len_el_=[0,b_ek_[3]];
      for(;;)
       {if(new_len_el_[1]<(b_ek_[2]+more_em_|0))
         {new_len_el_[1]=2*new_len_el_[1]|0;continue;}
        if(_d5_<new_len_el_[1])
         if((b_ek_[2]+more_em_|0)<=_d5_)new_len_el_[1]=_d5_;else _j_(_ci_);
        var new_buffer_en_=caml_create_string(new_len_el_[1]);
        _d2_(b_ek_[1],0,new_buffer_en_,0,b_ek_[2]);
        b_ek_[1]=new_buffer_en_;
        b_ek_[3]=new_len_el_[1];
        return 0;}}
    function _ey_(b_eo_,c_er_)
     {var pos_ep_=b_eo_[2];
      if(b_eo_[3]<=pos_ep_)_eq_(b_eo_,1);
      b_eo_[1].safeSet(pos_ep_,c_er_);
      b_eo_[2]=pos_ep_+1|0;
      return 0;}
    function _ez_(b_eu_,s_es_)
     {var len_et_=s_es_.getLen(),new_position_ev_=b_eu_[2]+len_et_|0;
      if(b_eu_[3]<new_position_ev_)_eq_(b_eu_,len_et_);
      _d2_(s_es_,0,b_eu_[1],b_eu_[2],len_et_);
      b_eu_[2]=new_position_ev_;
      return 0;}
    function index_of_int_eD_(i_eA_)
     {return 0<=i_eA_?i_eA_:_j_(_cO_(_bZ_,string_of_int_cP_(i_eA_)));}
    function add_int_index_eE_(i_eB_,idx_eC_)
     {return index_of_int_eD_(i_eB_+idx_eC_|0);}
    var _eF_=_c5_(add_int_index_eE_,1);
    function _eM_(fmt_eG_){return _d1_(fmt_eG_,0,fmt_eG_.getLen());}
    function bad_conversion_eO_(sfmt_eH_,i_eI_,c_eK_)
     {var
       _eJ_=_cO_(_b2_,_cO_(sfmt_eH_,_b3_)),
       _eL_=_cO_(_b1_,_cO_(string_of_int_cP_(i_eI_),_eJ_));
      return _cD_(_cO_(_b0_,_cO_(_d0_(1,c_eK_),_eL_)));}
    function bad_conversion_format_fD_(fmt_eN_,i_eQ_,c_eP_)
     {return bad_conversion_eO_(_eM_(fmt_eN_),i_eQ_,c_eP_);}
    function incomplete_format_fE_(fmt_eR_)
     {return _cD_(_cO_(_b4_,_cO_(_eM_(fmt_eR_),_b5_)));}
    function extract_format_e$_(fmt_eS_,start_e0_,stop_e2_,widths_e4_)
     {function skip_positional_spec_eZ_(start_eT_)
       {if
         ((fmt_eS_.safeGet(start_eT_)-48|0)<
          0||
          9<
          (fmt_eS_.safeGet(start_eT_)-48|0))
         return start_eT_;
        var i_eU_=start_eT_+1|0;
        for(;;)
         {var _eV_=fmt_eS_.safeGet(i_eU_);
          if(48<=_eV_)
           {if(!(58<=_eV_)){var _eX_=i_eU_+1|0,i_eU_=_eX_;continue;}
            var _eW_=0;}
          else
           if(36===_eV_){var _eY_=i_eU_+1|0,_eW_=1;}else var _eW_=0;
          if(!_eW_)var _eY_=start_eT_;
          return _eY_;}}
      var
       start_e1_=skip_positional_spec_eZ_(start_e0_+1|0),
       b_e3_=_ew_((stop_e2_-start_e1_|0)+10|0);
      _ey_(b_e3_,37);
      var i_e5_=start_e1_,widths_e6_=_dC_(widths_e4_);
      for(;;)
       {if(i_e5_<=stop_e2_)
         {var _e7_=fmt_eS_.safeGet(i_e5_);
          if(42===_e7_)
           {if(widths_e6_)
             {var t_e8_=widths_e6_[2];
              _ez_(b_e3_,string_of_int_cP_(widths_e6_[1]));
              var
               i_e9_=skip_positional_spec_eZ_(i_e5_+1|0),
               i_e5_=i_e9_,
               widths_e6_=t_e8_;
              continue;}
            throw [0,_d_,_b6_];}
          _ey_(b_e3_,_e7_);
          var _e__=i_e5_+1|0,i_e5_=_e__;
          continue;}
        return _ex_(b_e3_);}}
    function extract_format_int_g5_
     (conv_ff_,fmt_fd_,start_fc_,stop_fb_,widths_fa_)
     {var sfmt_fe_=extract_format_e$_(fmt_fd_,start_fc_,stop_fb_,widths_fa_);
      if(78!==conv_ff_&&110!==conv_ff_)return sfmt_fe_;
      sfmt_fe_.safeSet(sfmt_fe_.getLen()-1|0,117);
      return sfmt_fe_;}
    function sub_format_fF_
     (incomplete_format_fm_,bad_conversion_format_fw_,conv_fB_,fmt_fg_,i_fA_)
     {var len_fh_=fmt_fg_.getLen();
      function sub_fmt_fy_(c_fi_,i_fv_)
       {var close_fj_=40===c_fi_?41:125;
        function sub_fu_(j_fk_)
         {var j_fl_=j_fk_;
          for(;;)
           {if(len_fh_<=j_fl_)return _c5_(incomplete_format_fm_,fmt_fg_);
            if(37===fmt_fg_.safeGet(j_fl_))
             {var _fn_=j_fl_+1|0;
              if(len_fh_<=_fn_)
               var _fo_=_c5_(incomplete_format_fm_,fmt_fg_);
              else
               {var _fp_=fmt_fg_.safeGet(_fn_),_fq_=_fp_-40|0;
                if(_fq_<0||1<_fq_)
                 {var _fr_=_fq_-83|0;
                  if(_fr_<0||2<_fr_)
                   var _fs_=1;
                  else
                   switch(_fr_)
                    {case 1:var _fs_=1;break;
                     case 2:var _ft_=1,_fs_=0;break;
                     default:var _ft_=0,_fs_=0;}
                  if(_fs_){var _fo_=sub_fu_(_fn_+1|0),_ft_=2;}}
                else
                 var _ft_=0===_fq_?0:1;
                switch(_ft_)
                 {case 1:
                   var
                    _fo_=
                     _fp_===close_fj_
                      ?_fn_+1|0
                      :_fx_(bad_conversion_format_fw_,fmt_fg_,i_fv_,_fp_);
                   break;
                  case 2:break;
                  default:var _fo_=sub_fu_(sub_fmt_fy_(_fp_,_fn_+1|0)+1|0);}}
              return _fo_;}
            var _fz_=j_fl_+1|0,j_fl_=_fz_;
            continue;}}
        return sub_fu_(i_fv_);}
      return sub_fmt_fy_(conv_fB_,i_fA_);}
    function sub_format_for_printf_f5_(conv_fC_)
     {return _fx_
              (sub_format_fF_,
               incomplete_format_fE_,
               bad_conversion_format_fD_,
               conv_fC_);}
    function iter_on_format_args_gj_(fmt_fG_,add_conv_fR_,add_char_f1_)
     {var lim_fH_=fmt_fG_.getLen()-1|0;
      function scan_fmt_f3_(i_fI_)
       {var i_fJ_=i_fI_;
        a:
        for(;;)
         {if(i_fJ_<lim_fH_)
           {if(37===fmt_fG_.safeGet(i_fJ_))
             {var skip_fK_=0,i_fL_=i_fJ_+1|0;
              for(;;)
               {if(lim_fH_<i_fL_)
                 var _fM_=incomplete_format_fE_(fmt_fG_);
                else
                 {var _fN_=fmt_fG_.safeGet(i_fL_);
                  if(58<=_fN_)
                   {if(95===_fN_)
                     {var _fP_=i_fL_+1|0,_fO_=1,skip_fK_=_fO_,i_fL_=_fP_;
                      continue;}}
                  else
                   if(32<=_fN_)
                    switch(_fN_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _fQ_=i_fL_+1|0,i_fL_=_fQ_;continue;
                      case 10:
                       var _fS_=_fx_(add_conv_fR_,skip_fK_,i_fL_,105),i_fL_=_fS_;
                       continue;
                      default:var _fT_=i_fL_+1|0,i_fL_=_fT_;continue;}
                  var i_fU_=i_fL_;
                  c:
                  for(;;)
                   {if(lim_fH_<i_fU_)
                     var _fV_=incomplete_format_fE_(fmt_fG_);
                    else
                     {var _fW_=fmt_fG_.safeGet(i_fU_);
                      if(126<=_fW_)
                       var _fX_=0;
                      else
                       switch(_fW_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,105),_fX_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,102),_fX_=1;break;
                         case 33:
                         case 37:
                         case 44:
                         case 64:var _fV_=i_fU_+1|0,_fX_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,115),_fX_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,_fW_),_fX_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_fY_=i_fU_+1|0;
                          if(lim_fH_<j_fY_)
                           {var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,105),_fX_=1;}
                          else
                           {var _fZ_=fmt_fG_.safeGet(j_fY_)-88|0;
                            if(_fZ_<0||32<_fZ_)
                             var _f0_=1;
                            else
                             switch(_fZ_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _fV_=
                                  _f2_
                                   (add_char_f1_,_fx_(add_conv_fR_,skip_fK_,i_fU_,_fW_),105),
                                 _fX_=1,
                                 _f0_=0;
                                break;
                               default:var _f0_=1;}
                            if(_f0_)
                             {var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,105),_fX_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,99),_fX_=1;break;
                         case 66:
                         case 98:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,66),_fX_=1;break;
                         case 41:
                         case 125:
                          var _fV_=_fx_(add_conv_fR_,skip_fK_,i_fU_,_fW_),_fX_=1;
                          break;
                         case 40:
                          var
                           _fV_=scan_fmt_f3_(_fx_(add_conv_fR_,skip_fK_,i_fU_,_fW_)),
                           _fX_=1;
                          break;
                         case 123:
                          var
                           i_f4_=_fx_(add_conv_fR_,skip_fK_,i_fU_,_fW_),
                           j_f6_=_fx_(sub_format_for_printf_f5_,_fW_,fmt_fG_,i_f4_),
                           i_f7_=i_f4_;
                          for(;;)
                           {if(i_f7_<(j_f6_-2|0))
                             {var
                               _f8_=_f2_(add_char_f1_,i_f7_,fmt_fG_.safeGet(i_f7_)),
                               i_f7_=_f8_;
                              continue;}
                            var _f9_=j_f6_-1|0,i_fU_=_f9_;
                            continue c;}
                         default:var _fX_=0;}
                      if(!_fX_)
                       var _fV_=bad_conversion_format_fD_(fmt_fG_,i_fU_,_fW_);}
                    var _fM_=_fV_;
                    break;}}
                var i_fJ_=_fM_;
                continue a;}}
            var _f__=i_fJ_+1|0,i_fJ_=_f__;
            continue;}
          return i_fJ_;}}
      scan_fmt_f3_(0);
      return 0;}
    function count_printing_arguments_of_format_ii_(fmt_gk_)
     {var ac_f$_=[0,0,0,0];
      function add_conv_gi_(skip_ge_,i_gf_,c_ga_)
       {var _gb_=41!==c_ga_?1:0,_gc_=_gb_?125!==c_ga_?1:0:_gb_;
        if(_gc_)
         {var inc_gd_=97===c_ga_?2:1;
          if(114===c_ga_)ac_f$_[3]=ac_f$_[3]+1|0;
          if(skip_ge_)
           ac_f$_[2]=ac_f$_[2]+inc_gd_|0;
          else
           ac_f$_[1]=ac_f$_[1]+inc_gd_|0;}
        return i_gf_+1|0;}
      iter_on_format_args_gj_
       (fmt_gk_,add_conv_gi_,function(i_gg_,param_gh_){return i_gg_+1|0;});
      return ac_f$_[1];}
    function scan_positional_spec_g1_(fmt_gl_,got_spec_go_,i_gm_)
     {var _gn_=fmt_gl_.safeGet(i_gm_);
      if((_gn_-48|0)<0||9<(_gn_-48|0))return _f2_(got_spec_go_,0,i_gm_);
      var accu_gp_=_gn_-48|0,j_gq_=i_gm_+1|0;
      for(;;)
       {var _gr_=fmt_gl_.safeGet(j_gq_);
        if(48<=_gr_)
         {if(!(58<=_gr_))
           {var
             _gu_=j_gq_+1|0,
             _gt_=(10*accu_gp_|0)+(_gr_-48|0)|0,
             accu_gp_=_gt_,
             j_gq_=_gu_;
            continue;}
          var _gs_=0;}
        else
         if(36===_gr_)
          if(0===accu_gp_)
           {var _gv_=_j_(_b8_),_gs_=1;}
          else
           {var
             _gv_=
              _f2_(got_spec_go_,[0,index_of_int_eD_(accu_gp_-1|0)],j_gq_+1|0),
             _gs_=1;}
         else
          var _gs_=0;
        if(!_gs_)var _gv_=_f2_(got_spec_go_,0,i_gm_);
        return _gv_;}}
    function next_index_gW_(spec_gw_,n_gx_)
     {return spec_gw_?n_gx_:_c5_(_eF_,n_gx_);}
    function get_index_gL_(spec_gy_,n_gz_){return spec_gy_?spec_gy_[1]:n_gz_;}
    function _jF_
     (to_s_iD_,get_out_gB_,outc_iP_,outs_gE_,flush_in_,k_iV_,fmt_gA_)
     {var out_gC_=_c5_(get_out_gB_,fmt_gA_);
      function outs_iE_(s_gD_){return _f2_(outs_gE_,out_gC_,s_gD_);}
      function pr_im_(k_gJ_,n_iU_,fmt_gF_,v_gO_)
       {var len_gI_=fmt_gF_.getLen();
        function doprn_ij_(n_iM_,i_gG_)
         {var i_gH_=i_gG_;
          for(;;)
           {if(len_gI_<=i_gH_)return _c5_(k_gJ_,out_gC_);
            var _gK_=fmt_gF_.safeGet(i_gH_);
            if(37===_gK_)
             {var
               get_arg_gS_=
                function(spec_gN_,n_gM_)
                 {return caml_array_get(v_gO_,get_index_gL_(spec_gN_,n_gM_));},
               scan_flags_gY_=
                function(spec_g0_,n_gT_,widths_gV_,i_gP_)
                 {var i_gQ_=i_gP_;
                  for(;;)
                   {var _gR_=fmt_gF_.safeGet(i_gQ_)-32|0;
                    if(!(_gR_<0||25<_gR_))
                     switch(_gR_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_g1_
                                (fmt_gF_,
                                 function(wspec_gU_,i_gZ_)
                                  {var _gX_=[0,get_arg_gS_(wspec_gU_,n_gT_),widths_gV_];
                                   return scan_flags_gY_
                                           (spec_g0_,next_index_gW_(wspec_gU_,n_gT_),_gX_,i_gZ_);},
                                 i_gQ_+1|0);
                       default:var _g2_=i_gQ_+1|0,i_gQ_=_g2_;continue;}
                    var _g3_=fmt_gF_.safeGet(i_gQ_);
                    if(124<=_g3_)
                     var _g4_=0;
                    else
                     switch(_g3_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_g6_=get_arg_gS_(spec_g0_,n_gT_),
                         s_g7_=
                          caml_format_int
                           (extract_format_int_g5_(_g3_,fmt_gF_,i_gH_,i_gQ_,widths_gV_),
                            x_g6_),
                         _g9_=
                          cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_g7_,i_gQ_+1|0),
                         _g4_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_g__=get_arg_gS_(spec_g0_,n_gT_),
                         s_g$_=
                          caml_format_float
                           (extract_format_e$_(fmt_gF_,i_gH_,i_gQ_,widths_gV_),x_g__),
                         _g9_=
                          cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_g$_,i_gQ_+1|0),
                         _g4_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _ha_=fmt_gF_.safeGet(i_gQ_+1|0)-88|0;
                        if(_ha_<0||32<_ha_)
                         var _hb_=1;
                        else
                         switch(_ha_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_hc_=i_gQ_+1|0,_hd_=_g3_-108|0;
                            if(_hd_<0||2<_hd_)
                             var _he_=0;
                            else
                             {switch(_hd_)
                               {case 1:var _he_=0,_hf_=0;break;
                                case 2:
                                 var
                                  x_hg_=get_arg_gS_(spec_g0_,n_gT_),
                                  _hh_=
                                   caml_format_int
                                    (extract_format_e$_(fmt_gF_,i_gH_,i_hc_,widths_gV_),x_hg_),
                                  _hf_=1;
                                 break;
                                default:
                                 var
                                  x_hi_=get_arg_gS_(spec_g0_,n_gT_),
                                  _hh_=
                                   caml_format_int
                                    (extract_format_e$_(fmt_gF_,i_gH_,i_hc_,widths_gV_),x_hi_),
                                  _hf_=1;}
                              if(_hf_){var s_hj_=_hh_,_he_=1;}}
                            if(!_he_)
                             {var
                               x_hk_=get_arg_gS_(spec_g0_,n_gT_),
                               s_hj_=
                                caml_int64_format
                                 (extract_format_e$_(fmt_gF_,i_gH_,i_hc_,widths_gV_),x_hk_);}
                            var
                             _g9_=
                              cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_hj_,i_hc_+1|0),
                             _g4_=1,
                             _hb_=0;
                            break;
                           default:var _hb_=1;}
                        if(_hb_)
                         {var
                           x_hl_=get_arg_gS_(spec_g0_,n_gT_),
                           s_hm_=
                            caml_format_int
                             (extract_format_int_g5_(110,fmt_gF_,i_gH_,i_gQ_,widths_gV_),
                              x_hl_),
                           _g9_=
                            cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_hm_,i_gQ_+1|0),
                           _g4_=1;}
                        break;
                       case 37:
                       case 64:
                        var _g9_=cont_s_g8_(n_gT_,_d0_(1,_g3_),i_gQ_+1|0),_g4_=1;
                        break;
                       case 83:
                       case 115:
                        var x_hn_=get_arg_gS_(spec_g0_,n_gT_);
                        if(115===_g3_)
                         var x_ho_=x_hn_;
                        else
                         {var n_hp_=[0,0],_hq_=0,_hr_=x_hn_.getLen()-1|0;
                          if(!(_hr_<_hq_))
                           {var i_hs_=_hq_;
                            for(;;)
                             {var
                               _ht_=x_hn_.safeGet(i_hs_),
                               _hu_=
                                14<=_ht_
                                 ?34===_ht_?1:92===_ht_?1:0
                                 :11<=_ht_?13<=_ht_?1:0:8<=_ht_?1:0,
                               _hv_=_hu_?2:caml_is_printable(_ht_)?1:4;
                              n_hp_[1]=n_hp_[1]+_hv_|0;
                              var _hw_=i_hs_+1|0;
                              if(_hr_!==i_hs_){var i_hs_=_hw_;continue;}
                              break;}}
                          if(n_hp_[1]===x_hn_.getLen())
                           var _hx_=x_hn_;
                          else
                           {var s__hy_=caml_create_string(n_hp_[1]);
                            n_hp_[1]=0;
                            var _hz_=0,_hA_=x_hn_.getLen()-1|0;
                            if(!(_hA_<_hz_))
                             {var i_hB_=_hz_;
                              for(;;)
                               {var _hC_=x_hn_.safeGet(i_hB_),_hD_=_hC_-34|0;
                                if(_hD_<0||58<_hD_)
                                 if(-20<=_hD_)
                                  var _hE_=1;
                                 else
                                  {switch(_hD_+34|0)
                                    {case 8:
                                      s__hy_.safeSet(n_hp_[1],92);
                                      n_hp_[1]+=1;
                                      s__hy_.safeSet(n_hp_[1],98);
                                      var _hF_=1;
                                      break;
                                     case 9:
                                      s__hy_.safeSet(n_hp_[1],92);
                                      n_hp_[1]+=1;
                                      s__hy_.safeSet(n_hp_[1],116);
                                      var _hF_=1;
                                      break;
                                     case 10:
                                      s__hy_.safeSet(n_hp_[1],92);
                                      n_hp_[1]+=1;
                                      s__hy_.safeSet(n_hp_[1],110);
                                      var _hF_=1;
                                      break;
                                     case 13:
                                      s__hy_.safeSet(n_hp_[1],92);
                                      n_hp_[1]+=1;
                                      s__hy_.safeSet(n_hp_[1],114);
                                      var _hF_=1;
                                      break;
                                     default:var _hE_=1,_hF_=0;}
                                   if(_hF_)var _hE_=0;}
                                else
                                 var
                                  _hE_=
                                   (_hD_-1|0)<0||56<(_hD_-1|0)
                                    ?(s__hy_.safeSet(n_hp_[1],92),
                                      n_hp_[1]+=
                                      1,
                                      s__hy_.safeSet(n_hp_[1],_hC_),
                                      0)
                                    :1;
                                if(_hE_)
                                 if(caml_is_printable(_hC_))
                                  s__hy_.safeSet(n_hp_[1],_hC_);
                                 else
                                  {s__hy_.safeSet(n_hp_[1],92);
                                   n_hp_[1]+=1;
                                   s__hy_.safeSet(n_hp_[1],48+(_hC_/100|0)|0);
                                   n_hp_[1]+=1;
                                   s__hy_.safeSet(n_hp_[1],48+((_hC_/10|0)%10|0)|0);
                                   n_hp_[1]+=1;
                                   s__hy_.safeSet(n_hp_[1],48+(_hC_%10|0)|0);}
                                n_hp_[1]+=1;
                                var _hG_=i_hB_+1|0;
                                if(_hA_!==i_hB_){var i_hB_=_hG_;continue;}
                                break;}}
                            var _hx_=s__hy_;}
                          var x_ho_=_cO_(_cd_,_cO_(_hx_,_ce_));}
                        if(i_gQ_===(i_gH_+1|0))
                         var s_hH_=x_ho_;
                        else
                         {var
                           _hI_=
                            extract_format_e$_(fmt_gF_,i_gH_,i_gQ_,widths_gV_);
                          try
                           {var neg_hJ_=0,i_hK_=1;
                            for(;;)
                             {if(_hI_.getLen()<=i_hK_)
                               var _hL_=[0,0,neg_hJ_];
                              else
                               {var _hM_=_hI_.safeGet(i_hK_);
                                if(49<=_hM_)
                                 if(58<=_hM_)
                                  var _hN_=0;
                                 else
                                  {var
                                    _hL_=
                                     [0,
                                      caml_int_of_string
                                       (_d1_(_hI_,i_hK_,(_hI_.getLen()-i_hK_|0)-1|0)),
                                      neg_hJ_],
                                    _hN_=1;}
                                else
                                 {if(45===_hM_)
                                   {var _hP_=i_hK_+1|0,_hO_=1,neg_hJ_=_hO_,i_hK_=_hP_;
                                    continue;}
                                  var _hN_=0;}
                                if(!_hN_){var _hQ_=i_hK_+1|0,i_hK_=_hQ_;continue;}}
                              var match_hR_=_hL_;
                              break;}}
                          catch(_hS_)
                           {if(_hS_[1]!==_a_)throw _hS_;
                            var match_hR_=bad_conversion_eO_(_hI_,0,115);}
                          var
                           p_hT_=match_hR_[1],
                           _hU_=x_ho_.getLen(),
                           _hV_=0,
                           neg_hZ_=match_hR_[2],
                           _hY_=32;
                          if(p_hT_===_hU_&&0===_hV_)
                           {var _hW_=x_ho_,_hX_=1;}
                          else
                           var _hX_=0;
                          if(!_hX_)
                           if(p_hT_<=_hU_)
                            var _hW_=_d1_(x_ho_,_hV_,_hU_);
                           else
                            {var res_h0_=_d0_(p_hT_,_hY_);
                             if(neg_hZ_)
                              _d2_(x_ho_,_hV_,res_h0_,0,_hU_);
                             else
                              _d2_(x_ho_,_hV_,res_h0_,p_hT_-_hU_|0,_hU_);
                             var _hW_=res_h0_;}
                          var s_hH_=_hW_;}
                        var
                         _g9_=
                          cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_hH_,i_gQ_+1|0),
                         _g4_=1;
                        break;
                       case 67:
                       case 99:
                        var x_h1_=get_arg_gS_(spec_g0_,n_gT_);
                        if(99===_g3_)
                         var s_h2_=_d0_(1,x_h1_);
                        else
                         {if(39===x_h1_)
                           var _h3_=_cn_;
                          else
                           if(92===x_h1_)
                            var _h3_=_co_;
                           else
                            {if(14<=x_h1_)
                              var _h4_=0;
                             else
                              switch(x_h1_)
                               {case 8:var _h3_=_cs_,_h4_=1;break;
                                case 9:var _h3_=_cr_,_h4_=1;break;
                                case 10:var _h3_=_cq_,_h4_=1;break;
                                case 13:var _h3_=_cp_,_h4_=1;break;
                                default:var _h4_=0;}
                             if(!_h4_)
                              if(caml_is_printable(x_h1_))
                               {var s_h5_=caml_create_string(1);
                                s_h5_.safeSet(0,x_h1_);
                                var _h3_=s_h5_;}
                              else
                               {var s_h6_=caml_create_string(4);
                                s_h6_.safeSet(0,92);
                                s_h6_.safeSet(1,48+(x_h1_/100|0)|0);
                                s_h6_.safeSet(2,48+((x_h1_/10|0)%10|0)|0);
                                s_h6_.safeSet(3,48+(x_h1_%10|0)|0);
                                var _h3_=s_h6_;}}
                          var s_h2_=_cO_(_cb_,_cO_(_h3_,_cc_));}
                        var
                         _g9_=
                          cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_h2_,i_gQ_+1|0),
                         _g4_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _h8_=i_gQ_+1|0,
                         _h7_=get_arg_gS_(spec_g0_,n_gT_)?_cv_:_cu_,
                         _g9_=cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),_h7_,_h8_),
                         _g4_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_h9_=get_arg_gS_(spec_g0_,n_gT_),
                         i_h__=_fx_(sub_format_for_printf_f5_,_g3_,fmt_gF_,i_gQ_+1|0);
                        if(123===_g3_)
                         {var
                           b_h$_=_ew_(xf_h9_.getLen()),
                           add_char_id_=
                            function(i_ib_,c_ia_){_ey_(b_h$_,c_ia_);return i_ib_+1|0;};
                          iter_on_format_args_gj_
                           (xf_h9_,
                            function(skip_ic_,i_if_,c_ie_)
                             {if(skip_ic_)_ez_(b_h$_,_b7_);else _ey_(b_h$_,37);
                              return add_char_id_(i_if_,c_ie_);},
                            add_char_id_);
                          var
                           _ig_=_ex_(b_h$_),
                           _g9_=cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),_ig_,i_h__),
                           _g4_=1;}
                        else
                         {var
                           _ih_=next_index_gW_(spec_g0_,n_gT_),
                           m_ik_=
                            add_int_index_eE_
                             (count_printing_arguments_of_format_ii_(xf_h9_),_ih_),
                           _g9_=
                            pr_im_
                             (function(param_il_){return doprn_ij_(m_ik_,i_h__);},
                              _ih_,
                              xf_h9_,
                              v_gO_),
                           _g4_=1;}
                        break;
                       case 33:
                        _c5_(flush_in_,out_gC_);
                        var _g9_=doprn_ij_(n_gT_,i_gQ_+1|0),_g4_=1;
                        break;
                       case 41:
                        var _g9_=cont_s_g8_(n_gT_,_ch_,i_gQ_+1|0),_g4_=1;break;
                       case 44:
                        var _g9_=cont_s_g8_(n_gT_,_cg_,i_gQ_+1|0),_g4_=1;break;
                       case 70:
                        var x_io_=get_arg_gS_(spec_g0_,n_gT_);
                        if(0===widths_gV_)
                         var _ip_=_cf_;
                        else
                         {var
                           sfmt_iq_=
                            extract_format_e$_(fmt_gF_,i_gH_,i_gQ_,widths_gV_);
                          if(70===_g3_)sfmt_iq_.safeSet(sfmt_iq_.getLen()-1|0,103);
                          var _ip_=sfmt_iq_;}
                        var _ir_=caml_classify_float(x_io_);
                        if(3===_ir_)
                         var s_is_=x_io_<0?_b$_:_b__;
                        else
                         if(4<=_ir_)
                          var s_is_=_ca_;
                         else
                          {var
                            _it_=caml_format_float(_ip_,x_io_),
                            i_iu_=0,
                            l_iv_=_it_.getLen();
                           for(;;)
                            {if(l_iv_<=i_iu_)
                              var _iw_=_cO_(_it_,_b9_);
                             else
                              {var
                                _ix_=_it_.safeGet(i_iu_)-46|0,
                                _iy_=
                                 _ix_<0||23<_ix_
                                  ?55===_ix_?1:0
                                  :(_ix_-1|0)<0||21<(_ix_-1|0)?1:0;
                               if(!_iy_){var _iz_=i_iu_+1|0,i_iu_=_iz_;continue;}
                               var _iw_=_it_;}
                             var s_is_=_iw_;
                             break;}}
                        var
                         _g9_=
                          cont_s_g8_(next_index_gW_(spec_g0_,n_gT_),s_is_,i_gQ_+1|0),
                         _g4_=1;
                        break;
                       case 91:
                        var
                         _g9_=bad_conversion_format_fD_(fmt_gF_,i_gQ_,_g3_),
                         _g4_=1;
                        break;
                       case 97:
                        var
                         printer_iA_=get_arg_gS_(spec_g0_,n_gT_),
                         n_iB_=_c5_(_eF_,get_index_gL_(spec_g0_,n_gT_)),
                         arg_iC_=get_arg_gS_(0,n_iB_),
                         _iG_=i_gQ_+1|0,
                         _iF_=next_index_gW_(spec_g0_,n_iB_);
                        if(to_s_iD_)
                         outs_iE_(_f2_(printer_iA_,0,arg_iC_));
                        else
                         _f2_(printer_iA_,out_gC_,arg_iC_);
                        var _g9_=doprn_ij_(_iF_,_iG_),_g4_=1;
                        break;
                       case 114:
                        var
                         _g9_=bad_conversion_format_fD_(fmt_gF_,i_gQ_,_g3_),
                         _g4_=1;
                        break;
                       case 116:
                        var
                         printer_iH_=get_arg_gS_(spec_g0_,n_gT_),
                         _iJ_=i_gQ_+1|0,
                         _iI_=next_index_gW_(spec_g0_,n_gT_);
                        if(to_s_iD_)
                         outs_iE_(_c5_(printer_iH_,0));
                        else
                         _c5_(printer_iH_,out_gC_);
                        var _g9_=doprn_ij_(_iI_,_iJ_),_g4_=1;
                        break;
                       default:var _g4_=0;}
                    if(!_g4_)
                     var _g9_=bad_conversion_format_fD_(fmt_gF_,i_gQ_,_g3_);
                    return _g9_;}},
               _iO_=i_gH_+1|0,
               _iL_=0;
              return scan_positional_spec_g1_
                      (fmt_gF_,
                       function(spec_iN_,i_iK_)
                        {return scan_flags_gY_(spec_iN_,n_iM_,_iL_,i_iK_);},
                       _iO_);}
            _f2_(outc_iP_,out_gC_,_gK_);
            var _iQ_=i_gH_+1|0,i_gH_=_iQ_;
            continue;}}
        function cont_s_g8_(n_iT_,s_iR_,i_iS_)
         {outs_iE_(s_iR_);return doprn_ij_(n_iT_,i_iS_);}
        return doprn_ij_(n_iU_,0);}
      var
       kpr_iW_=_f2_(pr_im_,k_iV_,index_of_int_eD_(0)),
       _iX_=count_printing_arguments_of_format_ii_(fmt_gA_);
      if(_iX_<0||6<_iX_)
       {var
         loop_i__=
          function(i_iY_,args_i4_)
           {if(_iX_<=i_iY_)
             {var
               a_iZ_=caml_make_vect(_iX_,0),
               _i2_=
                function(i_i0_,arg_i1_)
                 {return caml_array_set(a_iZ_,(_iX_-i_i0_|0)-1|0,arg_i1_);},
               i_i3_=0,
               param_i5_=args_i4_;
              for(;;)
               {if(param_i5_)
                 {var _i6_=param_i5_[2],_i7_=param_i5_[1];
                  if(_i6_)
                   {_i2_(i_i3_,_i7_);
                    var _i8_=i_i3_+1|0,i_i3_=_i8_,param_i5_=_i6_;
                    continue;}
                  _i2_(i_i3_,_i7_);}
                return _f2_(kpr_iW_,fmt_gA_,a_iZ_);}}
            return function(x_i9_)
             {return loop_i__(i_iY_+1|0,[0,x_i9_,args_i4_]);};},
         _i$_=loop_i__(0,0);}
      else
       switch(_iX_)
        {case 1:
          var
           _i$_=
            function(x_jb_)
             {var a_ja_=caml_make_vect(1,0);
              caml_array_set(a_ja_,0,x_jb_);
              return _f2_(kpr_iW_,fmt_gA_,a_ja_);};
          break;
         case 2:
          var
           _i$_=
            function(x_jd_,y_je_)
             {var a_jc_=caml_make_vect(2,0);
              caml_array_set(a_jc_,0,x_jd_);
              caml_array_set(a_jc_,1,y_je_);
              return _f2_(kpr_iW_,fmt_gA_,a_jc_);};
          break;
         case 3:
          var
           _i$_=
            function(x_jg_,y_jh_,z_ji_)
             {var a_jf_=caml_make_vect(3,0);
              caml_array_set(a_jf_,0,x_jg_);
              caml_array_set(a_jf_,1,y_jh_);
              caml_array_set(a_jf_,2,z_ji_);
              return _f2_(kpr_iW_,fmt_gA_,a_jf_);};
          break;
         case 4:
          var
           _i$_=
            function(x_jk_,y_jl_,z_jm_,t_jn_)
             {var a_jj_=caml_make_vect(4,0);
              caml_array_set(a_jj_,0,x_jk_);
              caml_array_set(a_jj_,1,y_jl_);
              caml_array_set(a_jj_,2,z_jm_);
              caml_array_set(a_jj_,3,t_jn_);
              return _f2_(kpr_iW_,fmt_gA_,a_jj_);};
          break;
         case 5:
          var
           _i$_=
            function(x_jp_,y_jq_,z_jr_,t_js_,u_jt_)
             {var a_jo_=caml_make_vect(5,0);
              caml_array_set(a_jo_,0,x_jp_);
              caml_array_set(a_jo_,1,y_jq_);
              caml_array_set(a_jo_,2,z_jr_);
              caml_array_set(a_jo_,3,t_js_);
              caml_array_set(a_jo_,4,u_jt_);
              return _f2_(kpr_iW_,fmt_gA_,a_jo_);};
          break;
         case 6:
          var
           _i$_=
            function(x_jv_,y_jw_,z_jx_,t_jy_,u_jz_,v_jA_)
             {var a_ju_=caml_make_vect(6,0);
              caml_array_set(a_ju_,0,x_jv_);
              caml_array_set(a_ju_,1,y_jw_);
              caml_array_set(a_ju_,2,z_jx_);
              caml_array_set(a_ju_,3,t_jy_);
              caml_array_set(a_ju_,4,u_jz_);
              caml_array_set(a_ju_,5,v_jA_);
              return _f2_(kpr_iW_,fmt_gA_,a_ju_);};
          break;
         default:var _i$_=_f2_(kpr_iW_,fmt_gA_,[0]);}
      return _i$_;}
    function _jT_(oc_jC_)
     {function _jE_(_jB_){return 0;}
      return _jG_
              (_jF_,
               0,
               function(param_jD_){return oc_jC_;},
               _c2_,
               output_string_cY_,
               _dm_,
               _jE_);}
    function _jP_(fmt_jH_){return _ew_(2*fmt_jH_.getLen()|0);}
    function _jM_(k_jK_,b_jI_)
     {var s_jJ_=_ex_(b_jI_);b_jI_[2]=0;return _c5_(k_jK_,s_jJ_);}
    function _jS_(k_jL_)
     {var _jO_=_c5_(_jM_,k_jL_);
      return _jG_(_jF_,1,_jP_,_ey_,_ez_,function(_jN_){return 0;},_jO_);}
    function _jU_(fmt_jR_)
     {return _f2_(_jS_,function(s_jQ_){return s_jQ_;},fmt_jR_);}
    var _jV_=[0,0];
    function _j9_(x_jW_,i_jX_)
     {var f_jY_=x_jW_[i_jX_+1];
      if(caml_obj_is_block(f_jY_))
       {if(caml_obj_tag(f_jY_)===_ec_)return _f2_(_jU_,_bD_,f_jY_);
        if(caml_obj_tag(f_jY_)===_eb_)
         {var _jZ_=caml_format_float(_cy_,f_jY_),i_j0_=0,l_j1_=_jZ_.getLen();
          for(;;)
           {if(l_j1_<=i_j0_)
             var _j2_=_cO_(_jZ_,_cx_);
            else
             {var
               _j3_=_jZ_.safeGet(i_j0_),
               _j4_=48<=_j3_?58<=_j3_?0:1:45===_j3_?1:0;
              if(_j4_){var _j5_=i_j0_+1|0,i_j0_=_j5_;continue;}
              var _j2_=_jZ_;}
            return _j2_;}}
        return _bC_;}
      return _f2_(_jU_,_bE_,f_jY_);}
    function _j8_(x_j6_,i_j7_)
     {if(x_j6_.length-1<=i_j7_)return _bY_;
      var _j__=_j8_(x_j6_,i_j7_+1|0);
      return _fx_(_jU_,_bX_,_j9_(x_j6_,i_j7_),_j__);}
    function _kr_(x_ka_)
     {var param_j$_=_jV_[1];
      for(;;)
       {if(param_j$_)
         {var tl_kf_=param_j$_[2],hd_kb_=param_j$_[1];
          try {var _kc_=_c5_(hd_kb_,x_ka_),_kd_=_kc_;}catch(_kg_){var _kd_=0;}
          if(!_kd_){var param_j$_=tl_kf_;continue;}
          var _ke_=_kd_[1];}
        else
         if(x_ka_[1]===_cC_)
          var _ke_=_bN_;
         else
          if(x_ka_[1]===_cA_)
           var _ke_=_bM_;
          else
           if(x_ka_[1]===_cB_)
            {var
              match_kh_=x_ka_[2],
              char_ki_=match_kh_[3],
              _ke_=
               _jG_
                (_jU_,
                 _e_,
                 match_kh_[1],
                 match_kh_[2],
                 char_ki_,
                 char_ki_+5|0,
                 _bL_);}
           else
            if(x_ka_[1]===_d_)
             {var
               match_kj_=x_ka_[2],
               char_kk_=match_kj_[3],
               _ke_=
                _jG_
                 (_jU_,
                  _e_,
                  match_kj_[1],
                  match_kj_[2],
                  char_kk_,
                  char_kk_+6|0,
                  _bK_);}
            else
             if(x_ka_[1]===_cz_)
              {var
                match_kl_=x_ka_[2],
                char_km_=match_kl_[3],
                _ke_=
                 _jG_
                  (_jU_,
                   _e_,
                   match_kl_[1],
                   match_kl_[2],
                   char_km_,
                   char_km_+6|0,
                   _bJ_);}
             else
              {var _kn_=x_ka_.length-1,constructor_kq_=x_ka_[0+1][0+1];
               if(_kn_<0||2<_kn_)
                {var
                  _ko_=_j8_(x_ka_,2),
                  _kp_=_fx_(_jU_,_bI_,_j9_(x_ka_,1),_ko_);}
               else
                switch(_kn_)
                 {case 1:var _kp_=_bG_;break;
                  case 2:var _kp_=_f2_(_jU_,_bF_,_j9_(x_ka_,1));break;
                  default:var _kp_=_bH_;}
               var _ke_=_cO_(constructor_kq_,_kp_);}
        return _ke_;}}
    32===_d4_;
    function _ku_(param_kt_)
     {var seq_ks_=[];
      caml_update_dummy(seq_ks_,[0,seq_ks_,seq_ks_]);
      return seq_ks_;}
    var Canceled_kv_=[0,_bs_],current_data_kw_=[0,0],max_removed_lg_=42;
    function repr_rec_kA_(t_kx_)
     {var _ky_=t_kx_[1];
      {if(3===_ky_[0])
        {var t__kz_=_ky_[1],t___kB_=repr_rec_kA_(t__kz_);
         if(t___kB_!==t__kz_)t_kx_[1]=[3,t___kB_];
         return t___kB_;}
       return t_kx_;}}
    function repr_lh_(t_kC_){return repr_rec_kA_(t_kC_);}
    function call_unsafe_la_(f_kE_,x_kD_)
     {try
       {var _kF_=_c5_(f_kE_,x_kD_);}
      catch(_kG_)
       {_kr_(_kG_);
        caml_ml_output_char(stderr_cQ_,10);
        var
         _kH_=
          caml_convert_raw_backtrace(caml_get_exception_raw_backtrace(0));
        if(_kH_)
         {var a_kI_=_kH_[1],_kJ_=0,_kK_=a_kI_.length-1-1|0;
          if(!(_kK_<_kJ_))
           {var i_kL_=_kJ_;
            for(;;)
             {if(caml_notequal(caml_array_get(a_kI_,i_kL_),_bW_))
               {var
                 _kM_=caml_array_get(a_kI_,i_kL_),
                 is_raise_kN_=0===_kM_[0]?_kM_[1]:_kM_[1],
                 info_kO_=is_raise_kN_?0===i_kL_?_bT_:_bS_:0===i_kL_?_bR_:_bQ_,
                 _kP_=
                  0===_kM_[0]
                   ?_jG_(_jU_,_bP_,info_kO_,_kM_[2],_kM_[3],_kM_[4],_kM_[5])
                   :_f2_(_jU_,_bO_,info_kO_);
                _fx_(_jT_,stderr_cQ_,_bV_,_kP_);}
              var _kQ_=i_kL_+1|0;
              if(_kK_!==i_kL_){var i_kL_=_kQ_;continue;}
              break;}}}
        else
         _f2_(_jT_,stderr_cQ_,_bU_);
        do_at_exit_cX_(0);
        return caml_sys_exit(2);}
      return _kF_;}
    function run_waiters_rec_k1_(state_kV_,ws_kR_,rem_kT_)
     {var ws_kS_=ws_kR_,rem_kU_=rem_kT_;
      for(;;)
       if(typeof ws_kS_==="number")
        return run_waiters_rec_next_kW_(state_kV_,rem_kU_);
       else
        switch(ws_kS_[0])
         {case 1:
           _c5_(ws_kS_[1],state_kV_);
           return run_waiters_rec_next_kW_(state_kV_,rem_kU_);
          case 2:
           var
            ws1_kX_=ws_kS_[1],
            _kY_=[0,ws_kS_[2],rem_kU_],
            ws_kS_=ws1_kX_,
            rem_kU_=_kY_;
           continue;
          default:
           var _kZ_=ws_kS_[1][1];
           return _kZ_
                   ?(_c5_(_kZ_[1],state_kV_),
                     run_waiters_rec_next_kW_(state_kV_,rem_kU_))
                   :run_waiters_rec_next_kW_(state_kV_,rem_kU_);}}
    function run_waiters_rec_next_kW_(state_k2_,rem_k0_)
     {return rem_k0_?run_waiters_rec_k1_(state_k2_,rem_k0_[1],rem_k0_[2]):0;}
    function run_cancel_handlers_rec_lc_(chs_k3_,rem_k5_)
     {var chs_k4_=chs_k3_,rem_k6_=rem_k5_;
      for(;;)
       if(typeof chs_k4_==="number")
        return run_cancel_handlers_rec_next_k8_(rem_k6_);
       else
        switch(chs_k4_[0])
         {case 1:
           var n_k7_=chs_k4_[1];
           if(n_k7_[4]){n_k7_[4]=0;n_k7_[1][2]=n_k7_[2];n_k7_[2][1]=n_k7_[1];}
           return run_cancel_handlers_rec_next_k8_(rem_k6_);
          case 2:
           var
            chs1_k9_=chs_k4_[1],
            _k__=[0,chs_k4_[2],rem_k6_],
            chs_k4_=chs1_k9_,
            rem_k6_=_k__;
           continue;
          default:
           var f_k$_=chs_k4_[2];
           current_data_kw_[1]=chs_k4_[1];
           call_unsafe_la_(f_k$_,0);
           return run_cancel_handlers_rec_next_k8_(rem_k6_);}}
    function run_cancel_handlers_rec_next_k8_(rem_lb_)
     {return rem_lb_?run_cancel_handlers_rec_lc_(rem_lb_[1],rem_lb_[2]):0;}
    function unsafe_run_waiters_li_(sleeper_le_,state_ld_)
     {var
       _lf_=
        1===state_ld_[0]
         ?state_ld_[1][1]===Canceled_kv_
           ?(run_cancel_handlers_rec_lc_(sleeper_le_[4],0),1)
           :0
         :0;
      _lf_;
      return run_waiters_rec_k1_(state_ld_,sleeper_le_[2],0);}
    var wakening_lj_=[0,0],to_wakeup_lk_=_ea_(0);
    function wakeup_result_lv_(t_ll_,result_lo_)
     {var t_lm_=repr_rec_kA_(t_ll_),_ln_=t_lm_[1];
      switch(_ln_[0])
       {case 1:if(_ln_[1][1]===Canceled_kv_)return 0;break;
        case 2:
         var sleeper_lp_=_ln_[1];
         t_lm_[1]=result_lo_;
         var
          snapshot_lq_=current_data_kw_[1],
          already_wakening_lr_=wakening_lj_[1]?1:(wakening_lj_[1]=1,0);
         unsafe_run_waiters_li_(sleeper_lp_,result_lo_);
         if(already_wakening_lr_)
          {current_data_kw_[1]=snapshot_lq_;var _ls_=0;}
         else
          for(;;)
           {if(0!==to_wakeup_lk_[1])
             {var closure_lt_=_ed_(to_wakeup_lk_);
              unsafe_run_waiters_li_(closure_lt_[1],closure_lt_[2]);
              continue;}
            wakening_lj_[1]=0;
            current_data_kw_[1]=snapshot_lq_;
            var _ls_=0;
            break;}
         return _ls_;
        default:}
      return _cD_(_bt_);}
    function wakeup_lX_(t_lw_,v_lu_)
     {return wakeup_result_lv_(t_lw_,[0,v_lu_]);}
    function append_lD_(l1_lx_,l2_ly_)
     {return typeof l1_lx_==="number"
              ?l2_ly_
              :typeof l2_ly_==="number"?l1_lx_:[2,l1_lx_,l2_ly_];}
    function cleanup_lA_(ws_lz_)
     {if(typeof ws_lz_!=="number")
       switch(ws_lz_[0])
        {case 2:
          var l1_lB_=ws_lz_[1],_lC_=cleanup_lA_(ws_lz_[2]);
          return append_lD_(cleanup_lA_(l1_lB_),_lC_);
         case 1:break;
         default:if(!ws_lz_[1][1])return 0;}
      return ws_lz_;}
    function connect_lY_(t1_lE_,t2_lG_)
     {var t1_lF_=repr_lh_(t1_lE_),t2_lH_=repr_lh_(t2_lG_),_lI_=t1_lF_[1];
      {if(2===_lI_[0])
        {var sleeper1_lJ_=_lI_[1];
         if(t1_lF_===t2_lH_)return 0;
         var _lK_=t2_lH_[1];
         {if(2===_lK_[0])
           {var sleeper2_lL_=_lK_[1];
            t2_lH_[1]=[3,t1_lF_];
            sleeper1_lJ_[1]=sleeper2_lL_[1];
            var
             waiters_lM_=append_lD_(sleeper1_lJ_[2],sleeper2_lL_[2]),
             removed_lN_=sleeper1_lJ_[3]+sleeper2_lL_[3]|0;
            if(max_removed_lg_<removed_lN_)
             {sleeper1_lJ_[3]=0;sleeper1_lJ_[2]=cleanup_lA_(waiters_lM_);}
            else
             {sleeper1_lJ_[3]=removed_lN_;sleeper1_lJ_[2]=waiters_lM_;}
            var
             _lO_=sleeper2_lL_[4],
             _lP_=sleeper1_lJ_[4],
             _lQ_=
              typeof _lP_==="number"
               ?_lO_
               :typeof _lO_==="number"?_lP_:[2,_lP_,_lO_];
            sleeper1_lJ_[4]=_lQ_;
            return 0;}
          t1_lF_[1]=_lK_;
          return unsafe_run_waiters_li_(sleeper1_lJ_,_lK_);}}
       throw [0,_d_,_bu_];}}
    function fast_connect_lZ_(t_lR_,state_lU_)
     {var t_lS_=repr_lh_(t_lR_),_lT_=t_lS_[1];
      {if(2===_lT_[0])
        {var sleeper_lV_=_lT_[1];
         t_lS_[1]=state_lU_;
         return unsafe_run_waiters_li_(sleeper_lV_,state_lU_);}
       throw [0,_d_,_bv_];}}
    function return_l0_(v_lW_){return [0,[0,v_lW_]];}
    var return_unit_mN_=[0,state_return_unit_br_];
    function fail_ms_(e_l1_){return [0,[1,e_l1_]];}
    function temp_mj_(t_l2_){return [0,[2,[0,[0,[0,t_l2_]],0,0,0]]];}
    function task_mO_(param_l4_)
     {var _l3_=[0,[2,[0,1,0,0,0]]];return [0,_l3_,_l3_];}
    function add_immutable_waiter_mu_(sleeper_l7_,waiter_l5_)
     {var
       _l6_=[1,waiter_l5_],
       _l8_=sleeper_l7_[2],
       _l9_=typeof _l8_==="number"?_l6_:[2,_l6_,_l8_];
      sleeper_l7_[2]=_l9_;
      return 0;}
    function on_cancel_mP_(t_l__,f_ma_)
     {var _l$_=repr_lh_(t_l__)[1];
      switch(_l$_[0])
       {case 1:
         if(_l$_[1][1]===Canceled_kv_)return call_unsafe_la_(f_ma_,0);break;
        case 2:
         var
          sleeper_mb_=_l$_[1],
          handler_mc_=[0,current_data_kw_[1],f_ma_],
          _md_=sleeper_mb_[4],
          _me_=typeof _md_==="number"?handler_mc_:[2,handler_mc_,_md_];
         sleeper_mb_[4]=_me_;
         return 0;
        default:}
      return 0;}
    function _mQ_(t_mf_,f_mp_)
     {var t_mg_=repr_lh_(t_mf_),_mh_=t_mg_[1];
      switch(_mh_[0])
       {case 1:var _mi_=[0,_mh_];break;
        case 2:
         var
          sleeper_ml_=_mh_[1],
          res_mk_=temp_mj_(t_mg_),
          data_mn_=current_data_kw_[1];
         add_immutable_waiter_mu_
          (sleeper_ml_,
           function(state_mm_)
            {switch(state_mm_[0])
              {case 0:
                var v_mo_=state_mm_[1];
                current_data_kw_[1]=data_mn_;
                try
                 {var _mq_=_c5_(f_mp_,v_mo_),_mr_=_mq_;}
                catch(_mt_){var _mr_=fail_ms_(_mt_);}
                return connect_lY_(res_mk_,_mr_);
               case 1:return fast_connect_lZ_(res_mk_,state_mm_);
               default:throw [0,_d_,_bx_];}});
         var _mi_=res_mk_;
         break;
        case 3:throw [0,_d_,_bw_];
        default:var _mi_=_c5_(f_mp_,_mh_[1]);}
      return _mi_;}
    function _mR_(t_mv_,f_mE_)
     {var t_mw_=repr_lh_(t_mv_),_mx_=t_mw_[1];
      switch(_mx_[0])
       {case 1:var _my_=[0,_mx_];break;
        case 2:
         var
          sleeper_mA_=_mx_[1],
          res_mz_=temp_mj_(t_mw_),
          data_mC_=current_data_kw_[1];
         add_immutable_waiter_mu_
          (sleeper_mA_,
           function(state_mB_)
            {switch(state_mB_[0])
              {case 0:
                var v_mD_=state_mB_[1];
                current_data_kw_[1]=data_mC_;
                try
                 {var _mF_=[0,_c5_(f_mE_,v_mD_)],_mG_=_mF_;}
                catch(_mH_){var _mG_=[1,_mH_];}
                return fast_connect_lZ_(res_mz_,_mG_);
               case 1:return fast_connect_lZ_(res_mz_,state_mB_);
               default:throw [0,_d_,_bz_];}});
         var _my_=res_mz_;
         break;
        case 3:throw [0,_d_,_by_];
        default:
         var v_mI_=_mx_[1];
         try
          {var _mJ_=[0,_c5_(f_mE_,v_mI_)],_mK_=_mJ_;}
         catch(_mL_){var _mK_=[1,_mL_];}
         var _my_=[0,_mK_];}
      return _my_;}
    var pause_hook_mT_=[0,function(_mM_){return 0;}],_mS_=_ku_(0),_mW_=[0,0];
    function _m8_(param_m0_)
     {var _mU_=1-(_mS_[2]===_mS_?1:0);
      if(_mU_)
       {var tmp_mV_=_ku_(0);
        tmp_mV_[1][2]=_mS_[2];
        _mS_[2][1]=tmp_mV_[1];
        tmp_mV_[1]=_mS_[1];
        _mS_[1][2]=tmp_mV_;
        _mS_[1]=_mS_;
        _mS_[2]=_mS_;
        _mW_[1]=0;
        var curr_mX_=tmp_mV_[2];
        for(;;)
         {var _mY_=curr_mX_!==tmp_mV_?1:0;
          if(_mY_)
           {if(curr_mX_[4])wakeup_lX_(curr_mX_[3],0);
            var _mZ_=curr_mX_[2],curr_mX_=_mZ_;
            continue;}
          return _mY_;}}
      return _mU_;}
    function iter_s_m2_(f_m4_,l_m1_)
     {if(l_m1_)
       {var
         l_m3_=l_m1_[2],
         x_m6_=l_m1_[1],
         _m7_=function(param_m5_){return iter_s_m2_(f_m4_,l_m3_);};
        return _mQ_(_c5_(f_m4_,x_m6_),_m7_);}
      return return_unit_mN_;}
    var null_m9_=null,undefined_m__=undefined;
    function _nw_(x_m$_,f_na_)
     {return x_m$_==null_m9_?null_m9_:_c5_(f_na_,x_m$_);}
    function _nj_(x_nb_,f_nc_,g_nd_)
     {return x_nb_==null_m9_?_c5_(f_nc_,0):_c5_(g_nd_,x_nb_);}
    function _nx_(x_ne_,f_nf_){return x_ne_==null_m9_?_c5_(f_nf_,0):x_ne_;}
    function _ny_(x_nk_)
     {function _ni_(x_ng_){return [0,x_ng_];}
      return _nj_(x_nk_,function(param_nh_){return 0;},_ni_);}
    function _nz_(x_nl_){return x_nl_!==undefined_m__?1:0;}
    function _nu_(x_nm_,f_nn_,g_no_)
     {return x_nm_===undefined_m__?_c5_(f_nn_,0):_c5_(g_no_,x_nm_);}
    function _nA_(x_np_,f_nq_)
     {return x_np_===undefined_m__?_c5_(f_nq_,0):x_np_;}
    function _nB_(x_nv_)
     {function _nt_(x_nr_){return [0,x_nr_];}
      return _nu_(x_nv_,function(param_ns_){return 0;},_nt_);}
    var
     _true_nC_=true,
     _false_nD_=false,
     regExp_nE_=RegExp,
     array_constructor_nF_=Array;
    function array_get_nK_(_nG_,_nH_){return _nG_[_nH_];}
    function str_array_nL_(_nI_){return _nI_;}
    function match_result_nM_(_nJ_){return _nJ_;}
    var date_constr_nN_=Date,math_nR_=Math;
    function escape_nQ_(s_nO_){return escape(s_nO_);}
    function _nS_(e_nP_)
     {return e_nP_ instanceof array_constructor_nF_
              ?0
              :[0,new MlWrappedString(e_nP_.toString())];}
    _jV_[1]=[0,_nS_,_jV_[1]];
    function _nV_(_nT_){return _nT_;}
    function _nW_(_nU_){return _nU_;}
    function _n2_(f_nY_)
     {return _nW_
              (caml_js_wrap_callback
                (function(e_nX_)
                  {if(e_nX_)
                    {var res_nZ_=_c5_(f_nY_,e_nX_);
                     if(!(res_nZ_|0))e_nX_.preventDefault();
                     return res_nZ_;}
                   var _n0_=event,res_n1_=_c5_(f_nY_,_n0_);
                   _n0_.returnValue=res_n1_;
                   return res_n1_;}));}
    var
     onIE_n3_=caml_js_on_ie(0)|0,
     window_n4_=this,
     document_n5_=window_n4_.document,
     html_element_n6_=this.HTMLElement,
     float32Array_n__=this.Float32Array,
     _n8_=
      _nV_(html_element_n6_)===undefined_m__
       ?function(e_n7_)
         {return _nV_(e_n7_.innerHTML)===undefined_m__?null_m9_:_nW_(e_n7_);}
       :function(e_n9_)
         {return e_n9_ instanceof html_element_n6_?_nW_(e_n9_):null_m9_;};
    function _oc_(tag_n$_,e_oa_)
     {var _ob_=tag_n$_.toString();
      return e_oa_.tagName.toLowerCase()===_ob_?_nW_(e_oa_):null_m9_;}
    function _of_(e_od_){return _oc_(_bp_,e_od_);}
    function _oi_(e_oe_){return _oc_(_bq_,e_oe_);}
    var _oh_=this.FileReader;
    pause_hook_mT_[1]=
    function(param_og_)
     {return 1===param_og_
              ?(window_n4_.setTimeout(caml_js_wrap_callback(_m8_),0),0)
              :0;};
    var _oj_=caml_js_get_console(0);
    function regexp_ou_(s_ok_)
     {return new regExp_nE_(caml_js_from_byte_string(s_ok_),_bh_.toString());}
    function string_match_ov_(r_ol_,s_on_,i_om_)
     {r_ol_.lastIndex=i_om_;
      var
       _oo_=r_ol_.exec(caml_js_from_byte_string(s_on_)),
       _op_=_oo_==null_m9_?null_m9_:match_result_nM_(_oo_);
      return _ny_(_op_);}
    function matched_group_ow_(r_or_,i_oq_)
     {var
       _os_=array_get_nK_(r_or_,i_oq_),
       _ot_=_os_===undefined_m__?undefined_m__:caml_js_to_byte_string(_os_);
      return _nB_(_ot_);}
    var
     quote_repl_re_ox_=new regExp_nE_(_bf_.toString(),_bg_.toString()),
     _oB_=regexp_ou_(_be_);
    function split_oA_(c_oy_,s_oz_)
     {return str_array_nL_(s_oz_.split(_d0_(1,c_oy_).toString()));}
    var Local_exn_oC_=[0,_aw_];
    function interrupt_oE_(param_oD_){throw [0,Local_exn_oC_];}
    var
     _oF_=
      regexp_ou_
       (caml_js_to_byte_string
         (caml_js_from_byte_string(_av_).replace(_oB_,_bj_.toString()))),
     plus_re_js_string_oG_=new regExp_nE_(_at_.toString(),_au_.toString());
    function urldecode_js_string_string_oN_(s_oH_)
     {plus_re_js_string_oG_.lastIndex=0;
      return caml_js_to_byte_string
              (unescape(s_oH_.replace(plus_re_js_string_oG_,_ay_.toString())));}
    function urlencode_oO_(_opt__oI_,s_oK_)
     {var with_plus_oJ_=_opt__oI_?_opt__oI_[1]:1;
      if(with_plus_oJ_)
       {var
         _oL_=
          caml_js_to_byte_string(escape_nQ_(caml_js_from_byte_string(s_oK_)));
        _oF_.lastIndex=0;
        var a103345e2_oM_=caml_js_from_byte_string(_oL_);
        return caml_js_to_byte_string
                (a103345e2_oM_.replace
                  (_oF_,
                   caml_js_from_byte_string(_ax_).replace
                    (quote_repl_re_ox_,_bi_.toString())));}
      return caml_js_to_byte_string
              (escape_nQ_(caml_js_from_byte_string(s_oK_)));}
    var Not_an_http_protocol_pp_=[0,_as_];
    function path_of_path_string_oV_(s_oP_)
     {try
       {var length_oQ_=s_oP_.getLen();
        if(0===length_oQ_)
         var _oR_=_bd_;
        else
         {var i_oS_=0,_oU_=47,_oT_=s_oP_.getLen();
          for(;;)
           {if(_oT_<=i_oS_)throw [0,_c_];
            if(s_oP_.safeGet(i_oS_)!==_oU_)
             {var _oY_=i_oS_+1|0,i_oS_=_oY_;continue;}
            if(0===i_oS_)
             var
              _oW_=
               [0,_bc_,path_of_path_string_oV_(_d1_(s_oP_,1,length_oQ_-1|0))];
            else
             {var
               _oX_=
                path_of_path_string_oV_
                 (_d1_(s_oP_,i_oS_+1|0,(length_oQ_-i_oS_|0)-1|0)),
               _oW_=[0,_d1_(s_oP_,0,i_oS_),_oX_];}
            var _oR_=_oW_;
            break;}}}
      catch(_oZ_){if(_oZ_[1]===_c_)return [0,s_oP_,0];throw _oZ_;}
      return _oR_;}
    function encode_arguments_pq_(l_o3_)
     {return _d3_
              (_aF_,
               _dw_
                (function(param_o0_)
                  {var
                    n_o1_=param_o0_[1],
                    _o2_=_cO_(_aG_,urlencode_oO_(0,param_o0_[2]));
                   return _cO_(urlencode_oO_(0,n_o1_),_o2_);},
                 l_o3_));}
    function decode_arguments_js_string_pr_(s_o4_)
     {var arr_o5_=split_oA_(38,s_o4_),len_po_=arr_o5_.length;
      function aux_pk_(acc_pj_,idx_o6_)
       {var idx_o7_=idx_o6_;
        for(;;)
         {if(0<=idx_o7_)
           {try
             {var
               _ph_=idx_o7_-1|0,
               _pi_=
                function(s_pc_)
                 {function _pe_(param_o8_)
                   {var y_pa_=param_o8_[2],x_o$_=param_o8_[1];
                    function get_o__(t_o9_)
                     {return urldecode_js_string_string_oN_
                              (_nA_(t_o9_,interrupt_oE_));}
                    var _pb_=get_o__(y_pa_);
                    return [0,get_o__(x_o$_),_pb_];}
                  var arr_bis_pd_=split_oA_(61,s_pc_);
                  if(2===arr_bis_pd_.length)
                   {var
                     _pf_=array_get_nK_(arr_bis_pd_,1),
                     _pg_=_nV_([0,array_get_nK_(arr_bis_pd_,0),_pf_]);}
                  else
                   var _pg_=undefined_m__;
                  return _nu_(_pg_,interrupt_oE_,_pe_);},
               _pl_=
                aux_pk_
                 ([0,
                   _nu_(array_get_nK_(arr_o5_,idx_o7_),interrupt_oE_,_pi_),
                   acc_pj_],
                  _ph_);}
            catch(_pm_)
             {if(_pm_[1]===Local_exn_oC_)
               {var _pn_=idx_o7_-1|0,idx_o7_=_pn_;continue;}
              throw _pm_;}
            return _pl_;}
          return acc_pj_;}}
      return aux_pk_(0,len_po_-1|0);}
    var
     url_re_ps_=new regExp_nE_(caml_js_from_byte_string(_ar_)),
     file_re_p3_=new regExp_nE_(caml_js_from_byte_string(_aq_));
    function string_of_url_p2_(param_pt_)
     {switch(param_pt_[0])
       {case 1:
         var
          match_pu_=param_pt_[1],
          frag_pv_=match_pu_[6],
          args_pw_=match_pu_[5],
          port_px_=match_pu_[2],
          path_pA_=match_pu_[3],
          host_pz_=match_pu_[1],
          _py_=
           caml_string_notequal(frag_pv_,_a3_)
            ?_cO_(_a2_,urlencode_oO_(0,frag_pv_))
            :_a1_,
          _pB_=args_pw_?_cO_(_a0_,encode_arguments_pq_(args_pw_)):_aZ_,
          _pD_=_cO_(_pB_,_py_),
          _pF_=
           _cO_
            (_aX_,
             _cO_
              (_d3_
                (_aY_,
                 _dw_
                  (function(eta_pC_){return urlencode_oO_(0,eta_pC_);},
                   path_pA_)),
               _pD_)),
          _pE_=443===port_px_?_aV_:_cO_(_aW_,string_of_int_cP_(port_px_)),
          _pG_=_cO_(_pE_,_pF_);
         return _cO_(_aU_,_cO_(urlencode_oO_(0,host_pz_),_pG_));
        case 2:
         var
          match_pH_=param_pt_[1],
          frag_pI_=match_pH_[4],
          args_pJ_=match_pH_[3],
          path_pL_=match_pH_[1],
          _pK_=
           caml_string_notequal(frag_pI_,_aT_)
            ?_cO_(_aS_,urlencode_oO_(0,frag_pI_))
            :_aR_,
          _pM_=args_pJ_?_cO_(_aQ_,encode_arguments_pq_(args_pJ_)):_aP_,
          _pO_=_cO_(_pM_,_pK_);
         return _cO_
                 (_aN_,
                  _cO_
                   (_d3_
                     (_aO_,
                      _dw_
                       (function(eta_pN_){return urlencode_oO_(0,eta_pN_);},
                        path_pL_)),
                    _pO_));
        default:
         var
          match_pP_=param_pt_[1],
          frag_pQ_=match_pP_[6],
          args_pR_=match_pP_[5],
          port_pS_=match_pP_[2],
          path_pV_=match_pP_[3],
          host_pU_=match_pP_[1],
          _pT_=
           caml_string_notequal(frag_pQ_,_bb_)
            ?_cO_(_ba_,urlencode_oO_(0,frag_pQ_))
            :_a$_,
          _pW_=args_pR_?_cO_(_a__,encode_arguments_pq_(args_pR_)):_a9_,
          _pY_=_cO_(_pW_,_pT_),
          _p0_=
           _cO_
            (_a7_,
             _cO_
              (_d3_
                (_a8_,
                 _dw_
                  (function(eta_pX_){return urlencode_oO_(0,eta_pX_);},
                   path_pV_)),
               _pY_)),
          _pZ_=80===port_pS_?_a5_:_cO_(_a6_,string_of_int_cP_(port_pS_)),
          _p1_=_cO_(_pZ_,_p0_);
         return _cO_(_a4_,_cO_(urlencode_oO_(0,host_pU_),_p1_));}}
    var l_p4_=location;
    urldecode_js_string_string_oN_(l_p4_.hostname);
    try {}catch(_p5_){if(_p5_[1]!==_a_)throw _p5_;}
    path_of_path_string_oV_(urldecode_js_string_string_oN_(l_p4_.pathname));
    decode_arguments_js_string_pr_(l_p4_.search);
    urldecode_js_string_string_oN_(l_p4_.href);
    var formData_qb_=this.FormData;
    function _qa_(form_contents_p6_,form_elt_p8_)
     {if(891486873<=form_contents_p6_[1])
       {var list_p7_=form_contents_p6_[2];
        list_p7_[1]=[0,form_elt_p8_,list_p7_[1]];
        return 0;}
      var
       f_p9_=form_contents_p6_[2],
       _p__=form_elt_p8_[2],
       _p$_=form_elt_p8_[1];
      return 781515420<=_p__[1]
              ?f_p9_.append(_p$_.toString(),_p__[2])
              :f_p9_.append(_p$_.toString(),_p__[2]);}
    function _qd_(param_qc_){return ActiveXObject;}
    var _qN_=[0,_N_];
    function error_qk_(f_qf_)
     {return _f2_
              (_jS_,
               function(s_qe_)
                {_oj_.error(s_qe_.toString());return _j_(s_qe_);},
               f_qf_);}
    function debug_qO_(f_qh_)
     {return _f2_
              (_jS_,function(s_qg_){return _oj_.log(s_qg_.toString());},f_qh_);}
    function check_error_qP_(gl_qi_)
     {var _qj_=gl_qi_.NO;
      return caml_notequal(gl_qi_.getError(),_qj_)?error_qk_(_m_):0;}
    function load_shader_qQ_(gl_ql_,shader_qn_,text_qm_)
     {gl_ql_.shaderSource(shader_qn_,text_qm_);
      gl_ql_.compileShader(shader_qn_);
      if(gl_ql_.getShaderParameter(shader_qn_,gl_ql_.COMPILE_STATUS)|0)
       return 0;
      var _qo_=new MlWrappedString(gl_ql_.getShaderInfoLog(shader_qn_));
      return _fx_(error_qk_,_p_,new MlWrappedString(text_qm_),_qo_);}
    function get_source_qR_(src_id_qp_)
     {function _qr_(param_qq_){return _f2_(error_qk_,_r_,src_id_qp_);}
      return _nx_
              (_nw_(document_n5_.getElementById(src_id_qp_.toString()),_oi_),
               _qr_).text;}
    function float32array_qS_(a_qs_)
     {var
       array_qt_=new float32Array_n__(a_qs_.length-1),
       _qu_=0,
       _qv_=a_qs_.length-1-1|0;
      if(!(_qv_<_qu_))
       {var i_qw_=_qu_;
        for(;;)
         {array_qt_[i_qw_]=a_qs_[i_qw_+1];
          var _qx_=i_qw_+1|0;
          if(_qv_!==i_qw_){var i_qw_=_qx_;continue;}
          break;}}
      return array_qt_;}
    function _qD_(i_qy_,j_qz_){return (i_qy_*4|0)+j_qz_|0;}
    function _qT_(m1_qG_,m2_qE_)
     {return _dl_
              (16,
               function(p_qA_)
                {var
                  _qB_=p_qA_%4|0,
                  _qC_=p_qA_/4|0,
                  _qF_=caml_array_get(m2_qE_,_qD_(3,_qB_)),
                  _qH_=caml_array_get(m1_qG_,_qD_(_qC_,3))*_qF_,
                  _qI_=caml_array_get(m2_qE_,_qD_(2,_qB_)),
                  _qJ_=caml_array_get(m1_qG_,_qD_(_qC_,2))*_qI_,
                  _qK_=caml_array_get(m2_qE_,_qD_(1,_qB_)),
                  _qL_=caml_array_get(m1_qG_,_qD_(_qC_,1))*_qK_,
                  _qM_=caml_array_get(m2_qE_,_qD_(0,_qB_));
                 return caml_array_get(m1_qG_,_qD_(_qC_,0))*
                        _qM_+
                        _qL_+
                        _qJ_+
                        _qH_;});}
    var line_regexp_qU_=regexp_ou_(_l_),couple_regexp_qW_=regexp_ou_(_k_);
    function read_coord_couple_ri_(c_qV_)
     {var _qX_=string_match_ov_(couple_regexp_qW_,c_qV_,0);
      if(_qX_)
       {var _qY_=_dw_(_c5_(matched_group_ow_,_qX_[1]),_s_);
        if(_qY_)
         {var _qZ_=_qY_[1];
          if(_qZ_)
           {var _q0_=_qY_[2];
            if(_q0_)
             {var _q1_=_q0_[1];
              if(_q1_&&!_q0_[2])
               return [0,
                       [0,caml_int_of_string(_qZ_[1]),caml_int_of_string(_q1_[1])]];}}}
        return 0;}
      return 0;}
    function concat_rh_(a_q4_)
     {var r_q2_=[0,0],_q3_=0,_q5_=a_q4_.length-1-1|0;
      if(!(_q5_<_q3_))
       {var i_q6_=_q3_;
        a:
        for(;;)
         {var len_q7_=0,param_q8_=a_q4_[i_q6_+1],_q$_=r_q2_[1];
          for(;;)
           {if(param_q8_)
             {var
               l_q__=param_q8_[2],
               _q9_=len_q7_+1|0,
               len_q7_=_q9_,
               param_q8_=l_q__;
              continue;}
            r_q2_[1]=_q$_+len_q7_|0;
            var _ra_=i_q6_+1|0;
            if(_q5_!==i_q6_){var i_q6_=_ra_;continue a;}
            break;}
          break;}}
      var pos_rb_=[0,-1],l_rc_=[0,0],_rg_=r_q2_[1];
      return _dl_
              (_rg_,
               function(param_rf_)
                {for(;;)
                  {var _rd_=l_rc_[1];
                   if(_rd_){var t_re_=_rd_[1];l_rc_[1]=_rd_[2];return t_re_;}
                   pos_rb_[1]+=1;
                   l_rc_[1]=caml_array_get(a_q4_,pos_rb_[1]);
                   continue;}});}
    var pi_rM_=4*Math.atan(1);
    function start_vQ_(param_rj_)
     {var
       pos_rk_=param_rj_[1],
       norm_rm_=param_rj_[2],
       fps_text_rl_=document_n5_.createTextNode(_I_.toString()),
       _rn_=_nw_(document_n5_.getElementById(_H_.toString()),_n8_);
      if(_rn_!=null_m9_)_rn_.appendChild(fps_text_rl_);
      function _rp_(param_ro_){return _f2_(error_qk_,_n_,_g_);}
      var
       canvas_rq_=
        _nx_(_nw_(document_n5_.getElementById(_g_.toString()),_of_),_rp_);
      function _rw_(param_rs_)
       {return _f2_
                (_jS_,
                 function(s_rr_)
                  {window_n4_.alert(s_rr_.toString());return _j_(s_rr_);},
                 _o_);}
      try
       {var
         ctx_rt_=canvas_rq_.getContext(_M_.toString()),
         _ru_=
          1-(ctx_rt_==null_m9_?1:0)
           ?ctx_rt_
           :canvas_rq_.getContext(_L_.toString()),
         _rv_=_ru_;}
      catch(_sf_){var _rv_=null_m9_;}
      var
       gl_rx_=_nx_(_rv_,_rw_),
       _ry_=get_source_qR_(_G_),
       _rz_=get_source_qR_(_F_),
       vertexShader_rA_=gl_rx_.createShader(gl_rx_.VERTEX_SHADER),
       fragmentShader_rB_=gl_rx_.createShader(gl_rx_.FRAGMENT_SHADER);
      load_shader_qQ_(gl_rx_,vertexShader_rA_,_rz_);
      load_shader_qQ_(gl_rx_,fragmentShader_rB_,_ry_);
      var prog_rC_=gl_rx_.createProgram();
      gl_rx_.attachShader(prog_rC_,vertexShader_rA_);
      gl_rx_.attachShader(prog_rC_,fragmentShader_rB_);
      gl_rx_.linkProgram(prog_rC_);
      if(!(gl_rx_.getProgramParameter(prog_rC_,gl_rx_.LINK_STATUS)|0))
       error_qk_(_q_);
      gl_rx_.useProgram(prog_rC_);
      check_error_qP_(gl_rx_);
      debug_qO_(_E_);
      gl_rx_.enable(gl_rx_.DEPTH_TEST);
      gl_rx_.depthFunc(gl_rx_.LESS);
      var
       proj_loc_rD_=gl_rx_.getUniformLocation(prog_rC_,_D_.toString()),
       lightPos_loc_rE_=gl_rx_.getUniformLocation(prog_rC_,_C_.toString()),
       ambientLight_loc_rF_=gl_rx_.getUniformLocation(prog_rC_,_B_.toString()),
       lightPos_rG_=float32array_qS_([254,3,0,-1]),
       ambientLight_rH_=float32array_qS_([254,0.1,0.1,0.1]);
      gl_rx_.uniform3fv(lightPos_loc_rE_,lightPos_rG_);
      gl_rx_.uniform3fv(ambientLight_loc_rF_,ambientLight_rH_);
      var pos_attr_rI_=gl_rx_.getAttribLocation(prog_rC_,_A_.toString());
      gl_rx_.enableVertexAttribArray(pos_attr_rI_);
      var array_buffer_rJ_=gl_rx_.createBuffer();
      gl_rx_.bindBuffer(gl_rx_.ARRAY_BUFFER,array_buffer_rJ_);
      gl_rx_.bufferData(gl_rx_.ARRAY_BUFFER,pos_rk_,gl_rx_.STATIC_DRAW);
      gl_rx_.vertexAttribPointer(pos_attr_rI_,3,gl_rx_.FLOAT,_false_nD_,0,0);
      var norm_attr_rK_=gl_rx_.getAttribLocation(prog_rC_,_z_.toString());
      gl_rx_.enableVertexAttribArray(norm_attr_rK_);
      var norm_buffer_rL_=gl_rx_.createBuffer();
      gl_rx_.bindBuffer(gl_rx_.ARRAY_BUFFER,norm_buffer_rL_);
      gl_rx_.bufferData(gl_rx_.ARRAY_BUFFER,norm_rm_,gl_rx_.STATIC_DRAW);
      gl_rx_.vertexAttribPointer(norm_attr_rK_,3,gl_rx_.FLOAT,_false_nD_,0,0);
      var
       _rN_=pi_rM_/2,
       mat_rO_=
        _qT_
         ([254,
           1,
           0,
           0,
           0,
           0,
           Math.cos(_rN_),
           Math.sin(_rN_),
           0,
           0,
           -Math.sin(_rN_),
           Math.cos(_rN_),
           0,
           0,
           0,
           0,
           1],
          _qT_
           ([254,0.5,0,0,0,0,0.5,0,0,0,0,0.5,0,0,0,0,1],
            [254,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]));
      check_error_qP_(gl_rx_);
      debug_qO_(_y_);
      function get_time_rQ_(param_rP_)
       {return new date_constr_nN_().getTime();}
      var last_draw_rR_=[0,get_time_rQ_(0)],draw_times_rS_=_ea_(0);
      function f_sd_(param_se_)
       {var _rT_=1*(new date_constr_nN_().getTime()/1000);
        gl_rx_.uniformMatrix4fv
         (proj_loc_rD_,
          _false_nD_,
          float32array_qS_
           (_qT_
             (mat_rO_,
              [254,
               Math.cos(_rT_),
               0,
               -Math.sin(_rT_),
               0,
               0,
               1,
               0,
               0,
               Math.sin(_rT_),
               0,
               Math.cos(_rT_),
               0,
               0,
               0,
               0,
               1])));
        gl_rx_.clear(gl_rx_.DEPTH_BUFFER_BIT|gl_rx_.COLOR_BUFFER_BIT);
        gl_rx_.drawArrays(gl_rx_.TRIANGLES,0,pos_rk_.length/3|0);
        check_error_qP_(gl_rx_);
        var now_rU_=get_time_rQ_(0),_rV_=now_rU_-last_draw_rR_[1];
        if(0===draw_times_rS_[1])
         {var cell_rW_=[];
          caml_update_dummy(cell_rW_,[0,_rV_,cell_rW_]);
          draw_times_rS_[1]=1;
          draw_times_rS_[2]=cell_rW_;}
        else
         {var tail_rX_=draw_times_rS_[2],cell_rY_=[0,_rV_,tail_rX_[2]];
          draw_times_rS_[1]=draw_times_rS_[1]+1|0;
          tail_rX_[2]=cell_rY_;
          draw_times_rS_[2]=cell_rY_;}
        last_draw_rR_[1]=now_rU_;
        if(50<_ee_(draw_times_rS_))_ed_(draw_times_rS_);
        var _rZ_=0,_r0_=_ee_(draw_times_rS_),_r7_=1000;
        if(0===draw_times_rS_[1])
         var _r1_=_rZ_;
        else
         {var tail_r2_=draw_times_rS_[2],accu_r3_=_rZ_,cell_r4_=tail_r2_[2];
          for(;;)
           {var _r5_=accu_r3_+cell_r4_[1];
            if(cell_r4_!==tail_r2_)
             {var _r6_=cell_r4_[2],accu_r3_=_r5_,cell_r4_=_r6_;continue;}
            var _r1_=_r5_;
            break;}}
        fps_text_rl_.data=_f2_(_jU_,_J_,1/_r1_*_r0_*_r7_).toString();
        var
         match_r8_=task_mO_(0),
         t_r9_=match_r8_[1],
         w_r__=match_r8_[2],
         _sa_=0.02*1000,
         id_sb_=
          window_n4_.setTimeout
           (caml_js_wrap_callback
             (function(param_r$_){return wakeup_lX_(w_r__,0);}),
            _sa_);
        on_cancel_mP_
         (t_r9_,function(param_sc_){return window_n4_.clearTimeout(id_sb_);});
        return _mQ_(t_r9_,f_sd_);}
      return f_sd_(0);}
    window_n4_.onload=
    _n2_
     (function(param_v5_)
       {function _sh_(exn_sg_){return _f2_(error_qk_,_K_,_kr_(exn_sg_));}
        try
         {var
           _td_=0,
           _te_=0,
           _tf_=0,
           _tg_=0,
           _th_=0,
           _ti_=0,
           _tk_=
            function(frame_si_)
             {var
               a_sj_=
                str_array_nL_(frame_si_[4].toString().split(_x_.toString()));
              window_n4_.arr=a_sj_;
              var vertex_sk_=[0,0],norm_sl_=[0,0],face_sm_=[0,0],i_sn_=0;
              for(;;)
               {var _so_=_nB_(array_get_nK_(a_sj_,i_sn_));
                if(_so_)
                 {var
                   _sp_=
                    string_match_ov_
                     (line_regexp_qU_,new MlWrappedString(_so_[1]),0);
                  if(_sp_)
                   {var _sq_=_dw_(_c5_(matched_group_ow_,_sp_[1]),_w_);
                    if(_sq_)
                     {var _sr_=_sq_[1];
                      if(_sr_)
                       {var _ss_=_sr_[1];
                        if(caml_string_notequal(_ss_,_v_))
                         if(caml_string_notequal(_ss_,_u_))
                          if(caml_string_notequal(_ss_,_t_))
                           var _st_=0;
                          else
                           {var _su_=_sq_[2];
                            if(_su_)
                             {var _sv_=_su_[1];
                              if(_sv_)
                               {var _sw_=_su_[2];
                                if(_sw_)
                                 {var _sx_=_sw_[1];
                                  if(_sx_)
                                   {var _sy_=_sw_[2];
                                    if(_sy_)
                                     {var _sz_=_sy_[1];
                                      if(_sz_&&!_sy_[2])
                                       {var
                                         _sA_=
                                          [0,
                                           [1,
                                            [0,
                                             caml_float_of_string(_sv_[1]),
                                             caml_float_of_string(_sx_[1]),
                                             caml_float_of_string(_sz_[1])]]],
                                         _st_=1;}
                                      else
                                       var _st_=0;}
                                    else
                                     var _st_=0;}
                                  else
                                   var _st_=0;}
                                else
                                 var _st_=0;}
                              else
                               var _st_=0;}
                            else
                             var _st_=0;}
                         else
                          {var _sB_=_sq_[2];
                           if(_sB_)
                            {var _sC_=_sB_[1];
                             if(_sC_)
                              {var _sD_=_sB_[2];
                               if(_sD_)
                                {var _sE_=_sD_[1];
                                 if(_sE_)
                                  {var _sF_=_sD_[2];
                                   if(_sF_)
                                    {var _sG_=_sF_[1];
                                     if(_sG_&&!_sF_[2])
                                      {var
                                        _sA_=
                                         [0,
                                          [0,
                                           [0,
                                            caml_float_of_string(_sC_[1]),
                                            caml_float_of_string(_sE_[1]),
                                            caml_float_of_string(_sG_[1])]]],
                                        _st_=1;}
                                     else
                                      var _st_=0;}
                                   else
                                    var _st_=0;}
                                 else
                                  var _st_=0;}
                               else
                                var _st_=0;}
                             else
                              var _st_=0;}
                           else
                            var _st_=0;}
                        else
                         {var _sH_=_sq_[2];
                          if(_sH_)
                           {var _sI_=_sH_[1];
                            if(_sI_)
                             {var _sJ_=_sH_[2];
                              if(_sJ_)
                               {var _sK_=_sJ_[1];
                                if(_sK_)
                                 {var _sL_=_sJ_[2];
                                  if(_sL_)
                                   {var _sM_=_sL_[1];
                                    if(_sM_&&!_sL_[2])
                                     {var
                                       _sN_=
                                        _dw_
                                         (read_coord_couple_ri_,
                                          [0,_sI_[1],[0,_sK_[1],[0,_sM_[1],0]]]);
                                      if(_sN_)
                                       {var _sO_=_sN_[1];
                                        if(_sO_)
                                         {var _sP_=_sN_[2];
                                          if(_sP_)
                                           {var _sQ_=_sP_[1];
                                            if(_sQ_)
                                             {var _sR_=_sP_[2];
                                              if(_sR_)
                                               {var _sS_=_sR_[1];
                                                if(_sS_&&!_sR_[2])
                                                 {var _sA_=[0,[2,[0,_sO_[1],_sQ_[1],_sS_[1]]]],_st_=1,_sT_=0;}
                                                else
                                                 var _sT_=1;}
                                              else
                                               var _sT_=1;}
                                            else
                                             var _sT_=1;}
                                          else
                                           var _sT_=1;}
                                        else
                                         var _sT_=1;}
                                      else
                                       var _sT_=1;
                                      if(_sT_){var _sA_=0,_st_=1;}}
                                    else
                                     var _st_=0;}
                                  else
                                   var _st_=0;}
                                else
                                 var _st_=0;}
                              else
                               var _st_=0;}
                            else
                             var _st_=0;}
                          else
                           var _st_=0;}}
                      else
                       var _st_=0;}
                    else
                     var _st_=0;
                    if(!_st_)var _sA_=0;}
                  else
                   var _sA_=0;
                  if(_sA_)
                   {var _sU_=_sA_[1];
                    switch(_sU_[0])
                     {case 1:
                       var match_sV_=_sU_[1];
                       norm_sl_[1]=
                       [0,[0,match_sV_[1],match_sV_[2],match_sV_[3]],norm_sl_[1]];
                       break;
                      case 2:
                       var match_sW_=_sU_[1];
                       face_sm_[1]=
                       [0,[0,match_sW_[1],match_sW_[2],match_sW_[3]],face_sm_[1]];
                       break;
                      default:
                       var match_sX_=_sU_[1];
                       vertex_sk_[1]=
                       [0,[0,match_sX_[1],match_sX_[2],match_sX_[3]],vertex_sk_[1]];}}
                  var _sY_=i_sn_+1|0,i_sn_=_sY_;
                  continue;}
                var
                 _sZ_=_dn_(_dC_(face_sm_[1])),
                 _s0_=_dn_(_dC_(norm_sl_[1])),
                 _s1_=_dn_(_dC_(vertex_sk_[1])),
                 vertex__ta_=
                  _dl_
                   (_sZ_.length-1,
                    function(i_s2_)
                     {var
                       _s3_=caml_array_get(_sZ_,i_s2_),
                       match_s4_=caml_array_get(_s1_,_s3_[1][1]-1|0),
                       match_s5_=caml_array_get(_s1_,_s3_[2][1]-1|0),
                       match_s6_=caml_array_get(_s1_,_s3_[3][1]-1|0);
                      return [0,
                              match_s4_[1],
                              [0,
                               match_s4_[2],
                               [0,
                                match_s4_[3],
                                [0,
                                 match_s5_[1],
                                 [0,
                                  match_s5_[2],
                                  [0,
                                   match_s5_[3],
                                   [0,match_s6_[1],[0,match_s6_[2],[0,match_s6_[3],0]]]]]]]]];}),
                 norm__tb_=
                  _dl_
                   (_sZ_.length-1,
                    function(i_s7_)
                     {var
                       _s8_=caml_array_get(_sZ_,i_s7_),
                       match_s9_=caml_array_get(_s0_,_s8_[1][2]-1|0),
                       match_s__=caml_array_get(_s0_,_s8_[2][2]-1|0),
                       match_s$_=caml_array_get(_s0_,_s8_[3][2]-1|0);
                      return [0,
                              match_s9_[1],
                              [0,
                               match_s9_[2],
                               [0,
                                match_s9_[3],
                                [0,
                                 match_s__[1],
                                 [0,
                                  match_s__[2],
                                  [0,
                                   match_s__[3],
                                   [0,match_s$_[1],[0,match_s$_[2],[0,match_s$_[3],0]]]]]]]]];}),
                 vertex_tc_=float32array_qS_(concat_rh_(vertex__ta_));
                return [0,vertex_tc_,float32array_qS_(concat_rh_(norm__tb_))];}},
           headers_tj_=_ti_?_ti_[1]:0,
           get_args_tl_=_tf_?_tf_[1]:0,
           check_headers_tm_=_td_?_td_[1]:function(param_tn_,_to_){return 1;};
          if(_te_)
           {var form_arg_tp_=_te_[1];
            if(_tg_)
             {var post_args_tr_=_tg_[1];
              _dD_
               (function(param_tq_)
                 {return _qa_
                          (form_arg_tp_,
                           [0,param_tq_[1],[0,-976970511,param_tq_[2].toString()]]);},
                post_args_tr_);}
            var form_arg_ts_=[0,form_arg_tp_];}
          else
           if(_tg_)
            {var
              post_args_tt_=_tg_[1],
              _tu_=_nB_(_nV_(formData_qb_)),
              contents_tv_=
               _tu_?[0,808620462,new (_tu_[1])()]:[0,891486873,[0,0]];
             _dD_
              (function(param_tw_)
                {return _qa_
                         (contents_tv_,
                          [0,param_tw_[1],[0,-976970511,param_tw_[2].toString()]]);},
               post_args_tt_);
             var form_arg_ts_=[0,contents_tv_];}
           else
            var form_arg_ts_=0;
          if(form_arg_ts_)
           {var _tx_=form_arg_ts_[1];
            if(_th_)
             var _ty_=[0,_ao_,_th_,126925477];
            else
             {if(891486873<=_tx_[1])
               {var yes_tz_=0,no_tA_=0,param_tB_=_tx_[2][1];
                for(;;)
                 {if(param_tB_)
                   {var
                     l_tC_=param_tB_[2],
                     x_tD_=param_tB_[1],
                     _tE_=781515420<=x_tD_[2][1]?0:1;
                    if(_tE_)
                     {var _tF_=[0,x_tD_,yes_tz_],yes_tz_=_tF_,param_tB_=l_tC_;
                      continue;}
                    var _tG_=[0,x_tD_,no_tA_],no_tA_=_tG_,param_tB_=l_tC_;
                    continue;}
                  var _tH_=_dC_(no_tA_);
                  _dC_(yes_tz_);
                  if(_tH_)
                   {var
                     nine_digits_tJ_=
                      function(param_tI_)
                       {return string_of_int_cP_(math_nR_.random()*1000000000|0);},
                     _tK_=nine_digits_tJ_(0),
                     _tL_=_cO_(_S_,_cO_(nine_digits_tJ_(0),_tK_)),
                     _tM_=[0,_am_,[0,_cO_(_an_,_tL_)],[0,164354597,_tL_]];}
                  else
                   var _tM_=_al_;
                  var _tN_=_tM_;
                  break;}}
              else
               var _tN_=_ak_;
              var _ty_=_tN_;}
            var match_tO_=_ty_;}
          else
           var match_tO_=[0,_aj_,_th_,126925477];
          var
           post_encode_tP_=match_tO_[3],
           content_type_tQ_=match_tO_[2],
           _tR_=caml_js_from_byte_string(_f_),
           method__uo_=match_tO_[1],
           _up_=
            function(handle_tS_)
             {var
               res_tT_=match_result_nM_(handle_tS_),
               _tU_=
                caml_js_to_byte_string
                 (_nA_(array_get_nK_(res_tT_,1),interrupt_oE_).toLowerCase());
              if
               (caml_string_notequal(_tU_,_aE_)&&
                caml_string_notequal(_tU_,_aD_))
               {if
                 (caml_string_notequal(_tU_,_aC_)&&
                  caml_string_notequal(_tU_,_aB_))
                 {if
                   (caml_string_notequal(_tU_,_aA_)&&
                    caml_string_notequal(_tU_,_az_))
                   {var _tW_=1,_tV_=0;}
                  else
                   var _tV_=1;
                  if(_tV_){var ssl_tX_=1,_tW_=2;}}
                else
                 var _tW_=0;
                switch(_tW_)
                 {case 1:var _tY_=0;break;
                  case 2:var _tY_=1;break;
                  default:var ssl_tX_=0,_tY_=1;}
                if(_tY_)
                 {var
                   path_str_tZ_=
                    urldecode_js_string_string_oN_
                     (_nA_(array_get_nK_(res_tT_,5),interrupt_oE_)),
                   _t1_=
                    function(param_t0_){return caml_js_from_byte_string(_aI_);},
                   _t3_=
                    urldecode_js_string_string_oN_
                     (_nA_(array_get_nK_(res_tT_,9),_t1_)),
                   _t4_=
                    function(param_t2_){return caml_js_from_byte_string(_aJ_);},
                   _t5_=
                    decode_arguments_js_string_pr_
                     (_nA_(array_get_nK_(res_tT_,7),_t4_)),
                   _t7_=path_of_path_string_oV_(path_str_tZ_),
                   _t8_=
                    function(param_t6_){return caml_js_from_byte_string(_aK_);},
                   _t9_=
                    caml_js_to_byte_string(_nA_(array_get_nK_(res_tT_,4),_t8_)),
                   _t__=
                    caml_string_notequal(_t9_,_aH_)
                     ?caml_int_of_string(_t9_)
                     :ssl_tX_?443:80,
                   url_t$_=
                    [0,
                     urldecode_js_string_string_oN_
                      (_nA_(array_get_nK_(res_tT_,2),interrupt_oE_)),
                     _t__,
                     _t7_,
                     path_str_tZ_,
                     _t5_,
                     _t3_],
                   _ua_=ssl_tX_?[1,url_t$_]:[0,url_t$_];
                  return [0,_ua_];}}
              throw [0,Not_an_http_protocol_pp_];},
           _uq_=
            function(param_un_)
             {function _ul_(handle_ub_)
               {var
                 res_uc_=match_result_nM_(handle_ub_),
                 path_str_ud_=
                  urldecode_js_string_string_oN_
                   (_nA_(array_get_nK_(res_uc_,2),interrupt_oE_));
                function _uf_(param_ue_)
                 {return caml_js_from_byte_string(_aL_);}
                var
                 _uh_=
                  caml_js_to_byte_string(_nA_(array_get_nK_(res_uc_,6),_uf_));
                function _ui_(param_ug_)
                 {return caml_js_from_byte_string(_aM_);}
                var
                 _uj_=
                  decode_arguments_js_string_pr_
                   (_nA_(array_get_nK_(res_uc_,4),_ui_));
                return [0,
                        [2,
                         [0,
                          path_of_path_string_oV_(path_str_ud_),
                          path_str_ud_,
                          _uj_,
                          _uh_]]];}
              function _um_(param_uk_){return 0;}
              return _nj_(file_re_p3_.exec(_tR_),_um_,_ul_);},
           _ur_=_nj_(url_re_ps_.exec(_tR_),_uq_,_up_);
          if(_ur_)
           {var _us_=_ur_[1];
            switch(_us_[0])
             {case 0:
               var url_ut_=_us_[1],_uu_=url_ut_.slice(),_uv_=url_ut_[5];
               _uu_[5]=0;
               var match_uw_=[0,string_of_url_p2_([0,_uu_]),_uv_],_ux_=1;
               break;
              case 1:
               var url_uy_=_us_[1],_uz_=url_uy_.slice(),_uA_=url_uy_[5];
               _uz_[5]=0;
               var match_uw_=[0,string_of_url_p2_([1,_uz_]),_uA_],_ux_=1;
               break;
              default:var _ux_=0;}}
          else
           var _ux_=0;
          if(!_ux_)var match_uw_=[0,_f_,0];
          var
           url_uB_=match_uw_[1],
           _uC_=_cL_(match_uw_[2],get_args_tl_),
           url_uD_=
            _uC_?_cO_(url_uB_,_cO_(_ai_,encode_arguments_pq_(_uC_))):url_uB_,
           match_uE_=task_mO_(0),
           w_uF_=match_uE_[2],
           res_uG_=match_uE_[1];
          try
           {var _uH_=new XMLHttpRequest(),req_uI_=_uH_;}
          catch(_vT_)
           {try
             {var
               a5f6575ba_uJ_=_qd_(0),
               _uK_=new a5f6575ba_uJ_(_R_.toString()),
               req_uI_=_uK_;}
            catch(_uR_)
             {try
               {var
                 a64f1392a_uL_=_qd_(0),
                 _uM_=new a64f1392a_uL_(_Q_.toString()),
                 req_uI_=_uM_;}
              catch(_uQ_)
               {try
                 {var
                   a30a5da5a_uN_=_qd_(0),
                   _uO_=new a30a5da5a_uN_(_P_.toString());}
                catch(_uP_){throw [0,_d_,_O_];}
                var req_uI_=_uO_;}}}
          req_uI_.open(method__uo_.toString(),url_uD_.toString(),_true_nC_);
          if(content_type_tQ_)
           req_uI_.setRequestHeader
            (_ah_.toString(),content_type_tQ_[1].toString());
          _dD_
           (function(param_uS_)
             {return req_uI_.setRequestHeader
                      (param_uS_[1].toString(),param_uS_[2].toString());},
            headers_tj_);
          var
           headers_uY_=
            function(s_uW_)
             {function _uV_(v_uT_){return [0,new MlWrappedString(v_uT_)];}
              function _uX_(param_uU_){return 0;}
              return _nj_
                      (req_uI_.getResponseHeader(caml_js_from_byte_string(s_uW_)),
                       _uX_,
                       _uV_);},
           checked_uZ_=[0,0],
           do_check_headers_u2_=
            function(param_u1_)
             {var
               _u0_=
                checked_uZ_[1]
                 ?0
                 :_f2_(check_headers_tm_,req_uI_.status,headers_uY_)
                   ?0
                   :(wakeup_result_lv_
                      (w_uF_,[1,[0,_qN_,[0,req_uI_.status,headers_uY_]]]),
                     req_uI_.abort(),
                     1);
              _u0_;
              checked_uZ_[1]=1;
              return 0;};
          req_uI_.onreadystatechange=
          caml_js_wrap_callback
           (function(param_u7_)
             {switch(req_uI_.readyState)
               {case 2:if(!onIE_n3_)return do_check_headers_u2_(0);break;
                case 3:if(onIE_n3_)return do_check_headers_u2_(0);break;
                case 4:
                 do_check_headers_u2_(0);
                 var
                  _u6_=
                   function(param_u5_)
                    {var _u3_=_ny_(req_uI_.responseXML);
                     if(_u3_)
                      {var doc_u4_=_u3_[1];
                       return _nW_(doc_u4_.documentElement)===null_m9_
                               ?0
                               :[0,doc_u4_];}
                     return 0;};
                 return wakeup_lX_
                         (w_uF_,
                          [0,
                           url_uD_,
                           req_uI_.status,
                           headers_uY_,
                           new MlWrappedString(req_uI_.responseText),
                           _u6_]);
                default:}
              return 0;});
          if(form_arg_ts_)
           {var _u8_=form_arg_ts_[1];
            if(891486873<=_u8_[1])
             {var l_u9_=_u8_[2];
              if(typeof post_encode_tP_==="number")
               {var _vd_=l_u9_[1];
                req_uI_.send
                 (_nW_
                   (_d3_
                      (_ae_,
                       _dw_
                        (function(param_u__)
                          {var _u$_=param_u__[2],_va_=param_u__[1];
                           if(781515420<=_u$_[1])
                            {var
                              _vb_=
                               _cO_
                                (_ag_,urlencode_oO_(0,new MlWrappedString(_u$_[2].name)));
                             return _cO_(urlencode_oO_(0,_va_),_vb_);}
                           var
                            _vc_=
                             _cO_(_af_,urlencode_oO_(0,new MlWrappedString(_u$_[2])));
                           return _cO_(urlencode_oO_(0,_va_),_vc_);},
                         _vd_)).toString
                     ()));}
              else
               {var
                 boundary_ve_=post_encode_tP_[2],
                 _vh_=
                  function(data_vf_)
                   {var data_vg_=_nW_(data_vf_.join(_ap_.toString()));
                    return _nz_(req_uI_.sendAsBinary)
                            ?req_uI_.sendAsBinary(data_vg_)
                            :req_uI_.send(data_vg_);},
                 _vj_=l_u9_[1],
                 b_vi_=new array_constructor_nF_(),
                 _vO_=
                  function(param_vk_)
                   {b_vi_.push(_cO_(_T_,_cO_(boundary_ve_,_U_)).toString());
                    return b_vi_;};
                _mR_
                 (_mR_
                   (iter_s_m2_
                     (function(v_vl_)
                       {b_vi_.push(_cO_(_Y_,_cO_(boundary_ve_,_Z_)).toString());
                        var _vm_=v_vl_[2],_vn_=v_vl_[1];
                        if(781515420<=_vm_[1])
                         {var
                           value_vo_=_vm_[2],
                           _vv_=-1041425454,
                           _vw_=
                            function(file_vu_)
                             {var
                               _vr_=_ad_.toString(),
                               _vq_=_ac_.toString(),
                               _vp_=_nB_(value_vo_.name);
                              if(_vp_)
                               var _vs_=_vp_[1];
                              else
                               {var
                                 _vt_=_nB_(value_vo_.fileName),
                                 _vs_=_vt_?_vt_[1]:_j_(_bk_);}
                              b_vi_.push
                               (_cO_(_aa_,_cO_(_vn_,_ab_)).toString(),_vs_,_vq_,_vr_);
                              b_vi_.push(___.toString(),file_vu_,_$_.toString());
                              return return_l0_(0);},
                           _vx_=_nB_(_nV_(_oh_));
                          if(_vx_)
                           {var
                             reader_vy_=new (_vx_[1])(),
                             match_vz_=task_mO_(0),
                             res_vA_=match_vz_[1],
                             w_vE_=match_vz_[2];
                            reader_vy_.onloadend=
                            _n2_
                             (function(param_vF_)
                               {if(2===reader_vy_.readyState)
                                 {var
                                   _vB_=reader_vy_.result,
                                   _vC_=
                                    caml_equal(typeof _vB_,_bl_.toString())?_nW_(_vB_):null_m9_,
                                   _vD_=_ny_(_vC_);
                                  if(!_vD_)throw [0,_d_,_bm_];
                                  wakeup_lX_(w_vE_,_vD_[1]);}
                                return _false_nD_;});
                            on_cancel_mP_
                             (res_vA_,function(param_vG_){return reader_vy_.abort();});
                            if(typeof _vv_==="number")
                             if(-550809787===_vv_)
                              reader_vy_.readAsDataURL(value_vo_);
                             else
                              if(936573133<=_vv_)
                               reader_vy_.readAsText(value_vo_);
                              else
                               reader_vy_.readAsBinaryString(value_vo_);
                            else
                             reader_vy_.readAsText(value_vo_,_vv_[2]);
                            var _vH_=res_vA_;}
                          else
                           {var fail_vJ_=function(param_vI_){return _j_(_bo_);};
                            if(typeof _vv_==="number")
                             var
                              _vK_=
                               -550809787===_vv_
                                ?_nz_(value_vo_.getAsDataURL)
                                  ?value_vo_.getAsDataURL()
                                  :fail_vJ_(0)
                                :936573133<=_vv_
                                  ?_nz_(value_vo_.getAsText)
                                    ?value_vo_.getAsText(_bn_.toString())
                                    :fail_vJ_(0)
                                  :_nz_(value_vo_.getAsBinary)
                                    ?value_vo_.getAsBinary()
                                    :fail_vJ_(0);
                            else
                             {var
                               e_vL_=_vv_[2],
                               _vK_=
                                _nz_(value_vo_.getAsText)
                                 ?value_vo_.getAsText(e_vL_)
                                 :fail_vJ_(0);}
                            var _vH_=return_l0_(_vK_);}
                          return _mQ_(_vH_,_vw_);}
                        var value_vN_=_vm_[2],_vM_=_X_.toString();
                        b_vi_.push
                         (_cO_(_V_,_cO_(_vn_,_W_)).toString(),value_vN_,_vM_);
                        return return_l0_(0);},
                      _vj_),
                    _vO_),
                  _vh_);}}
            else
             req_uI_.send(_u8_[2]);}
          else
           req_uI_.send(null_m9_);
          on_cancel_mP_(res_uG_,function(param_vP_){return req_uI_.abort();});
          var _vR_=_mQ_(_mR_(res_uG_,_tk_),start_vQ_),_vS_=_vR_;}
        catch(_vU_){var _vS_=fail_ms_(_vU_);}
        var t_vV_=repr_lh_(_vS_),_vW_=t_vV_[1];
        switch(_vW_[0])
         {case 1:_sh_(_vW_[1]);break;
          case 2:
           var
            sleeper_vY_=_vW_[1],
            res_vX_=temp_mj_(t_vV_),
            data_v0_=current_data_kw_[1];
           add_immutable_waiter_mu_
            (sleeper_vY_,
             function(state_vZ_)
              {switch(state_vZ_[0])
                {case 0:return fast_connect_lZ_(res_vX_,state_vZ_);
                 case 1:
                  var exn_v1_=state_vZ_[1];
                  current_data_kw_[1]=data_v0_;
                  try
                   {var _v2_=_sh_(exn_v1_),_v3_=_v2_;}
                  catch(_v4_){var _v3_=fail_ms_(_v4_);}
                  return connect_lY_(res_vX_,_v3_);
                 default:throw [0,_d_,_bB_];}});
           break;
          case 3:throw [0,_d_,_bA_];
          default:}
        return _true_nC_;});
    do_at_exit_cX_(0);
    return;}
  ());
